

function _BackbuttonFunctionStack () {	
	/*
	 * This is a stack of functions to be used when the back button is pressed (mobile only). Note that it is similar
	 * to ScreenViewStack but not identical: ScreenViewStack is really less a stack and more a list of viewed screens;
	 * this is a stack: on a LIFO basis, function objects are added to the stack and popped off of it (popping happens
	 * either when the back button is pressed, or when we pop the function off because another operation (such as 
	 * clicking a "back" link in the app UI) necessitates this removal).
	 * 
	 * Also note that only Androids (not iPhones) have back buttons, so this class really applies only to the 
	 * Android app.
	 */
	this._stack=[]; 
	this.MAX_STACK_SIZE=10;
}

var p=_BackbuttonFunctionStack.prototype;




p.add=function(fn) {
	BackbuttonFunctionStack._stack.push(fn);
	if (BackbuttonFunctionStack._stack.length>(BackbuttonFunctionStack.MAX_STACK_SIZE)) {
		BackbuttonFunctionStack._stack.shift();
	}
};




p.getAndRemoveCurrent=function() {
	if (BackbuttonFunctionStack._stack.length==0) {
		return null;
	}
	return BackbuttonFunctionStack._stack.pop();
};




p.clear=function() {
	BackbuttonFunctionStack._stack=[];
};






var BackbuttonFunctionStack=new _BackbuttonFunctionStack();

