

/*
 * This "class" is really just a namespace.  ALL onclick events' handlers should be in this file, assuming they're UiMgr-related (and not, e.g., MessengerMgr-related).
 */

function _ClickHandlers () {}

var p=_ClickHandlers.prototype;


p.homepageCreateAccountClick=function() {
	ClickHandlers._logClick("homepageCreateAccountClick", "");
	professionalSite=window.professionalSite;
	if (!CommMgr.onlineAndInitialSessionEstablishedCheck()) {
		return; // couldn't get online; user will have been alerted to this fact
	}
	
	var goNextPage=true;
	if (professionalSite) {
		var nameEl=$("#professionalName");
		var emailEl=$("#professionalEmail");
		if (nameEl.val().length==0) {
			goNextPage=false;
			DialogMgr.validationAlert("Please enter a name for yourself and try again.", nameEl);
		}
		else if (emailEl.val().length==0) {
			goNextPage=false;
			DialogMgr.validationAlert("Please enter your email address and try again.", emailEl);
		}
		else if (!UiMgr.isValidEmailAddress(emailEl.val())) {
			goNextPage=false;
			DialogMgr.validationAlert("That's not a valid email address; please enter an address like yourname@yourcompany.com and try again.", emailEl);
		}
		else {
			UiMgr.creatingAccount.creatingUserFullname=nameEl.val().trim();
			UiMgr.creatingAccount.creatingUserEmail=emailEl.val().trim();
		}
	}

	if (goNextPage) {
		if (!mobileApp) {
			// If we are desktop, then we take the user to the upload-new-image-key page, since that's how we 
			// authenticate users on the web:
			UiMgr.showAuthPage("authCreatingUserUploadNewImageKey");
		}
		else {
			// Else we are mobile-app.  We no longer use images to authenticate users on mobile.  But for backwards-compat, we
			// still generate a (fake) JPG file (actually, the first 40K of one, since that's all we ever deal with) and store
			// it in local client storage.  So:
			var mockJpgLeadingBytes=UiMgr.generateMockRandomJpgLeadingHexBytes();
			UiMgr.creatingAccount.creatingUserChosenImageKeyHexBytes=mockJpgLeadingBytes;
			ClientStorage.set(UiMgr.clientStorageKeyBytesKey, mockJpgLeadingBytes);
			ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false"); // we'll set this to the string "true" after we actually create the account server-side
			
			
			// Go straight to the choose-a-PIN page:
			UiMgr.showAuthPage("authCreatingUserChoosePin");
		}		
	}
	
};


//STEP 1 in create-account-from-temp-passphrase (process passphrase submit, go to PIN page):
p.authHomeSubmitPasscode=function(formElName) {
	if (typeof formElName=="undefined") {
		formElName="authHomeAccessCode";
	}
	ClickHandlers._logClick("authHomeSubmitPasscode", "");
	if (!CommMgr.onlineAndInitialSessionEstablishedCheck()) {
		return; // couldn't get online
	}

	var passcode=$("#"+formElName).val();
	
	if (passcode.trim().length==0) {
		//DialogMgr.alert("Please enter the passphrase your friend gave you. <a href=\"#\" onclick=\"DialogMgr.helpAlert('Hi!  This is a help-alert dialog.  It is nice, right?  I like it...<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line.<br/><br/>This is a new line. And it is going to be long.  I am going to make it long.  I am going to make it wrap and wrap and wrap.  Or at least wrap once.  We will see how much it actually wraps.  We will see if it wraps intul it cannot wrap anymore, or if it stops wrapping at some point.'); return false;\">get help</a>");
		DialogMgr.alert("Please enter the passphrase your confidant gave you.");
		return;
	}
	UiMgr.newAccountSecondUser.tempKey=passcode;
	//UiMgr.showAuthPage("authImportAccountEnterExistingPin"); // No longer; no more temp PINs (unless the user has exported a key to a new device, but we'll handle that below):
	
	
	var dataMap={tempKey:UiMgr.newAccountSecondUser.tempKey};

	DialogMgr.openBlockingModalDialog("One moment...");
	CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.PREVALIDATE_HOMEPAGE_ENTERED_PASSCODE, dataMap, true, 
		// success cb:
		function(response) {
		if (!response.success) {
			
			var alertArgMsg="We don't recognize that passphrase (or you've tried too many times with similar passphrases).  Please try again.";
			var alertArgButtonName="OK";
			var alertArgCallbackFunction=function() {
				if (!window.mobileApp) {
					DialogMgr.closeBlockingModalDialog();
				}
				UiMgr.newAccountSecondUser.tempKey=null;
			};
			DialogMgr.alert(alertArgMsg, alertArgButtonName, alertArgCallbackFunction);			

		}
		else {
			var successType=response.successType;
			DialogMgr.closeBlockingModalDialog();	
			if (!professionalSite) {
				// vanilla tunnel x:
				if (successType=="tunnelKeyFound") {
					UiMgr.showAuthPage("authSecondUserNameSelf");	
				}
				else {
					UiMgr.showAuthPage("authImportAccountEnterExistingPin");
				}
			}
			else {
				// tunnel t or similar:
				if (successType=="tunnelKeyFound") {
					//UiMgr.showAuthPage("authSecondUserUploadNewImageKey"); // skip handle page; no handles here	
					if (!mobileApp) {
						// We're not mobile, so we authenticate users with image keys; here, the user chooses one --
						UiMgr.showAuthPage("authSecondUserUploadNewImageKey");				
					}
					else {
						// Else we are mobile-app.  We no longer use images to authenticate users on mobile.  But for backwards-compat, we
						// still generate a (fake) JPG file (actually, the first 40K of one, since that's all we ever deal with) and store
						// it in local client storage.  So:
						var mockJpgLeadingBytes=UiMgr.generateMockRandomJpgLeadingHexBytes();
						UiMgr.newAccountSecondUser.chosenImageKeyHexBytes=mockJpgLeadingBytes;
						ClientStorage.set(UiMgr.clientStorageKeyBytesKey, mockJpgLeadingBytes);
						ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false"); // we'll set this to the string "true" after we actually create the account server-side
						// Go straight to the choose-a-PIN page (skipping over STEP 4):
						UiMgr.showAuthPage("authSecondUserChoosePin");
					}			
				}
				else {
					UiMgr.showAuthPage("authImportAccountEnterExistingPin");
				}
			}
		}		
	}, 
	// failure cb:
	CommMgr.defaultErrorCallback
	);	
};

//STEP 2 in create-account-from-temp-passphrase (process PIN entry, go to the enter-nickname page):
// (*** BUT NOTE***: We may be here for one of two reasons.  The fiirst is described above: the user is in step 2 of creating
// a new account from a passphrase.  They have entered a passphrase and PIN given them by a friend.  HOWEVER, they may also
// be in the process of exporting their account to a new device -- this happens when a user clicks 'add new device' on the 
// settings page of their logged-in account.  If that's the case, then the passphrase they entered in the previous step is 
// the one given them on the settings page, and the PIN they just entered is their permanent account PIN.)
p.authSecondUserEnterTempPinSubmit=function() {
	ClickHandlers._logClick("authSecondUserEnterTempPinSubmit", "");

	DialogMgr.openBlockingModalDialog("One moment...");

	var dataMap={tempKey:UiMgr.newAccountSecondUser.tempKey, tempPin:PinPad.lastUserEnteredPin};
	var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.PREVALIDATE_EXISTING_ACCT_ADD_NEW_DEVICE_CREDS, dataMap, false);	
	if (!response.success) {
		// No success if we use the passphrase and PIN as add-a-device creds either.  So, both failed.  Now we show the user a
		// message that's generic enough to apply to both possible failure scenarios.
		// note that calling this clears the blocking modal dialog, so we don't have to do it (and in fact it causes a race condition):
		var alertArgMsg="We don't recognize that passphrase (or you've tried too many times with similar passphrases).  Please try again.";
		var alertArgButtonName="OK";
		var alertArgCallbackFunction=function() {
			if (!window.mobileApp) {
				DialogMgr.closeBlockingModalDialog();
			}
			UiMgr.newAccountSecondUser.tempKey=null;
			UiMgr.newAccountSecondUser.tempPin=null; // shouldn't be non-null anyway
			UiMgr.showAuthPage("authHome");
		};
		DialogMgr.alert(alertArgMsg, alertArgButtonName, alertArgCallbackFunction);			
	}	
	else {
		// Success; the user has presented a valid temp new-device passphrase, and his valid account PIN.
		// User is not logged in yet though; we have only "prevalidated" him.  We still have to collect
		// a new image key from him (on desktop) or create a new key for him (mobile), after which we will
		// log him in.  So:
		UiMgr.existingAccountNewDevice.tempKey=UiMgr.newAccountSecondUser.tempKey;
		UiMgr.existingAccountNewDevice.pin=PinPad.lastUserEnteredPin;
		
		DialogMgr.closeBlockingModalDialog();
		if (!mobileApp) {
			// get an image from the user:
			UiMgr.showAuthPage("authExistingAccountUploadNewDeviceImageKey");
		}
		else {
			// create a key (a fake image) for the user and log them in):
			var mockJpgLeadingBytes=UiMgr.generateMockRandomJpgLeadingHexBytes();
			UiMgr.existingAccountNewDevice.chosenImageKeyHexBytes=mockJpgLeadingBytes;
			ClientStorage.set(UiMgr.clientStorageKeyBytesKey, mockJpgLeadingBytes);
			ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false"); // we'll set this to the string "true" after we actually log the user in server-side
			UiMgr.logInExistingAccountNewDevice();
		}
	}


}; 


//STEP 3 in create-account-from-temp-passphrase (process handle (formerly tunnel-nickname) submit, go to upload-permanent-key page):
p.secondUserHandleClick=function() {
	ClickHandlers._logClick("secondUserHandleClick", "");

	var handleEl=$("#secondUserHandle");
	var handle=handleEl.val().trim();
	
	if (handle.length==0) {
		DialogMgr.validationAlert("Please enter a name for yourself and try again.", handleEl);
	}
	else if (handle.length>20) {
		DialogMgr.validationAlert("That name is longer than 20 characters; please try again.", handleEl);
	}
	else if (handle.length<3) {
		DialogMgr.validationAlert("Your name must be at least three characters long; please try again.", handleEl);
	}
	else if (UiMgr.isValidHandleChars(handle)) {
		DialogMgr.validationAlert("Your name may only contain letters and numbers; please try again.", handleEl);
	}

	else {
		
		var dataMap={handle:handle};
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.IS_UNUSED_HANDLE, dataMap, false, null, null, 5000);
		if (typeof response!="undefined" && response!=null && response.success && response.handleUnused) {
			handleEl.val("");
			// Handle is valid and unused, so store it...
			UiMgr.newAccountSecondUser.chosenNickname=handle;
			
			// Now, we treat web and mobile-app users differently:
			if (!mobileApp) {
				// We're not mobile, so we authenticate users with image keys; here, the user chooses one --
				UiMgr.showAuthPage("authSecondUserUploadNewImageKey");				
			}
			else {
				// Else we are mobile-app.  We no longer use images to authenticate users on mobile.  But for backwards-compat, we
				// still generate a (fake) JPG file (actually, the first 40K of one, since that's all we ever deal with) and store
				// it in local client storage.  So:
				var mockJpgLeadingBytes=UiMgr.generateMockRandomJpgLeadingHexBytes();
				UiMgr.newAccountSecondUser.chosenImageKeyHexBytes=mockJpgLeadingBytes;
				ClientStorage.set(UiMgr.clientStorageKeyBytesKey, mockJpgLeadingBytes);
				ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false"); // we'll set this to the string "true" after we actually create the account server-side
				// Go straight to the choose-a-PIN page (skipping over STEP 4):
				UiMgr.showAuthPage("authSecondUserChoosePin");
			}		
		}
		else {
			DialogMgr.validationAlert("That name is already in use; please choose another.", handleEl);			
		}
	}
};


//STEP 4 in create-account-from-temp-passphrase (process permanent-key upload (note that ImageKeyUploader handles most of this), go to choose-permanent-PIN page):
p.authSecondUserUploadNewImageKeyClick=function(leadingKeyBytes) {
	ClickHandlers._logClick("authSecondUserUploadNewImageKeyClick", "");
	// Note that mobile users never get here because they never see the image-upload screen, so never click
	// anything on that screen.  Mobile users go to the PIN page via STEP 3 (above).
	UiMgr.newAccountSecondUser.chosenImageKeyHexBytes=leadingKeyBytes;
	UiMgr.showAuthPage("authSecondUserChoosePin");
};




//STEP 5 in create-account-from-temp-passphrase (process PIN entry, then pass off to UiMgr.createSecondUserAccount() to finish account-and-first-tunnel-creation process):
p.authSecondUserChoosePinSubmit=function() {
	ClickHandlers._logClick("authSecondUserChoosePinSubmit", "");
	var enteredPin=PinPad.lastUserEnteredPin;
	if (PinPad.validateNewLastEnteredPin()) {
		UiMgr.newAccountSecondUser.chosenPin=enteredPin;
		UiMgr.createSecondUserAccount();
	}
};





// desktop only (no clicks will come from this screen on mobile)
p.authExistingAccountUploadNewDeviceImageKeyClick=function(leadingKeyBytes) {
	ClickHandlers._logClick("authExistingAccountUploadNewDeviceImageKeyClick", "");
	UiMgr.existingAccountNewDevice.chosenImageKeyHexBytes=leadingKeyBytes;
	UiMgr.logInExistingAccountNewDevice();
};




p.homepageUseExistingKeyClick=function() {
	ClickHandlers._logClick("homepageUseExistingKeyClick", "");
	UiMgr.showAuthPage("authUploadExistingImageKey");
};

p.tunnelBackArrowClick=function() {
	ClickHandlers._logClick("tunnelBackArrowClick", "");
	//BackbuttonFunctionStack.getAndRemoveCurrent();
	if (UiMgr.currentAcctIsProfessionalClient) {
		return;
	}
	TunnelMgr.exitTunnel(true);
};






p.secondUserUploadNewKeyClick=function() {
	ClickHandlers._logClick("secondUserUploadNewKeyClick", "");
	var msg;
	if (!window.mobileApp) {
		msg="You are about to choose a JPG image file that will become your \'key\' to your tunnel.  (You will no longer use the temporary text key you just used to sign in.) ";
	}
	else {
		msg="Now you'll choose a JPG photo to be this tunnel's 'key'. (You won't need the text key you just used anymore.) ";
	}
	DialogMgr.alert(msg+_UM_uploadKeyAdditionalText, "OK", UiMgr.hiddenSecondUserUploadNewKeyCallback);
};

p.uploadReplacementKeyClick=function() {
	ClickHandlers._logClick("uploadReplacementKeyClick", "");
	var msg;
	if (!window.mobileApp) {
		msg="You are about to choose an image key that will replace the one your currently use to sign into your tunnel. ";
	}
	else {
		msg="You are about to choose an image key that will replace the one you use now. ";
	}
	DialogMgr.alert(msg+_UM_uploadKeyAdditionalText, "OK", UiMgr.hiddenUploadReplacementKeyCallback);
};



p.existingUserSignInClick=function() {
	ClickHandlers._logClick("existingUserSignInClick", "");
	try {
		if (!CommMgr.onlineAndInitialSessionEstablishedCheck()) {
			return; // couldn't get online
		}
		if (!window.mobileApp) {
			ClickHandlers.uploadAuthKeyClick();
		}
		else {
			DialogMgr.alert("After you click 'OK,' your phone's file-chooser screen will open so you can upload your signin-key photo.", "OK", ClickHandlers.uploadAuthKeyClick);
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.uploadAuthKeyClick=function() {
	ClickHandlers._logClick("uploadAuthKeyClick", "");
	try {
		UiMgr.clearAllNonFileUploadFormFields();
		ImageKeyUploader.clearFileUploadFormFields();
		UiMgr.openAuthKeyUploadChooser();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};



p.tunnelHeaderExitClick=function() {
	ClickHandlers.footerExitClick(); // identical behavior: leave, now.
};

p.footerExitClick=function() {
	ClickHandlers._logClick("footerExitClick", "");
	if (UiMgr.permanentlyDisableFooterLinks) {
		return;
	}

	try {
		if (!mobileApp || (!ClientStorage.exists(UiMgr.clientStorageKeyBytesKey))) {
			UiMgr.logout(true, true, false, null, false, true);
			UiMgr.goToHomepageAndResetUi();
		}
		else {
			var message="Okay to sign out?";
			DialogMgr.confirm(
					message, 
					function() {
						try {
							// log the user out, but only give 100ms to do that (we may be offline), then go to the homepage
							UiMgr.expressLogout();
							setTimeout(function() {
								UiMgr.goToHomepageAndResetUi();
							}, 250);
							
						}
						catch (e) {
							UiMgr.goToHomepageAndResetUi();
						}
					}, 
					function(){}, 
					"Yes", 
					"No"
				);
			
		}		
	}
	catch (e) {
		UiMgr.goToHomepageAndResetUi();
	}
	
};



p.nonAuthBackLinkClick=function() {
	ClickHandlers._logClick("nonAuthBackLinkClick", "");
	if (TunnelMgr.getCurrentTunnelAttribute("currentUserName")!=null) {
		// we're logged into a tunnel, so we want to go back to the tunnel:
		MessengerMgr.showMessengerUi(false);
	}
	else {
		// we're not logged in, so we want to go back to the homepage/login page:
		UiMgr.showAuthPages();
	}
};



//desktop only:
p.settingsBackArrowClick=function() {
	ClickHandlers._logClick("settingsBackArrowClick", "");
	DialogMgr.closeSettingsDialog();
};

p.settingsChooseTunnelChange=function() {
	ClickHandlers._logClick("settingsChooseTunnelChange", "");
	var chosenTunnelId=$("#settingsChooseTunnel").val();
	$("#settingsChooseTunnel").val("none_chosen"); // reset
	UiMgr.setUpTunnelSettingsSubPageForTunnel(chosenTunnelId);
	UiMgr.showSettingsSubPage("changeTunnelSettingsSubPage");
};

p.settingsManagePaymentsClick=function() {
	ClickHandlers._logClick("settingsManagePaymentsClick", "");
	UiMgr.showSettingsSubPage("managePaymentsSubPage");
};













p.chooseNicknameClick=function() {
	ClickHandlers._logClick("chooseNicknameClick", "");
	DialogMgr.openBlockingModalDialog("One moment...");
	setTimeout(function(){
		try {
			var newTunnelCreatingUserNicknameFormEl=$("#newTunnelCreatingUserNickname");
			if (newTunnelCreatingUserNicknameFormEl.val().trim().length==0) {
				DialogMgr.validationAlert("You have not chosen a nickname for yourself. The nickname will be visible only to you and your confidant; it can be anything, for example \"Alex\" or \"abc123.\" Please enter one and try again.", newTunnelCreatingUserNicknameFormEl);
			}
			else if (newTunnelCreatingUserNicknameFormEl.val().trim().length>24) {
				DialogMgr.validationAlert("Your nickname is longer than 24 characters.  Please enter a shorter one and try again.", newTunnelCreatingUserNicknameFormEl);
			}
			else {
				UiMgr.newTunnelCreatingUserNickname=newTunnelCreatingUserNicknameFormEl.val().trim();
				//UiMgr.showAuthPage("authChooseKey");
				UiMgr.showAuthPage("authChoosePin");
			}	
		}
		catch (__ee) {
			alertJavaScriptErrorIfConfigured(__ee); throw _ee;
		}		
	}, 100);
};



p.createTunnelClick=function() {
	ClickHandlers._logClick("createTunnelClick", "");
	if (!CommMgr.onlineAndInitialSessionEstablishedCheck()) {
		return; // couldn't get online
	}
	UiMgr.showAuthPage('authNameNonFirstTunnel');
};


p.inAccountCreateTunnelClick=function() {
	ClickHandlers._logClick("inAccountCreateTunnelClick", "");
	$("#enableNotificationsCheckbox").prop("checked", UiMgr.acctPrefs.doNotificationsAcctPref);
	$("#enableNotificationsCheckbox").hide();
	ClickHandlers.createTunnelClick();
};




//clicked from authCreateTunnelOrEnterPasscode
p.inAccountSubmitTunnelPasscode=function() {
	ClickHandlers._logClick("inAccountSubmitTunnelPasscode", "");
	var passcode=$("#inAccountNewTunnelPasscode").val();
	if (passcode.trim().length==0) {
		DialogMgr.alert("Please enter the passphrase your friend gave you.");
		return;
	}
	UiMgr.newTunnelSecondUserExistingAccount.secondUserTempKey=passcode;
	
	var dataMap={tempKey:UiMgr.newTunnelSecondUserExistingAccount.secondUserTempKey};
	DialogMgr.openBlockingModalDialog("One moment...");
	
	var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.PREVALIDATE_EXISTING_ACCT_SECOND_USER_TEMP_TUNNEL_CREDS, dataMap, false);	
	if (!response.success) {
		// note that calling this clears the blocking modal dialog, so we don't have to do it (and in fact it causes a race condition):
		var alertArgMsg="We don't recognize that passphrase (or you've tried too many similar passphrases).  Be sure to use the passphrase your friend gave you.  Please try again.";
		var alertArgButtonName="OK";
		var alertArgCallbackFunction=function() {
			if (!window.mobileApp) {
				DialogMgr.closeBlockingModalDialog();
			}
			UiMgr.newTunnelSecondUserExistingAccount.secondUserTempKey=null;
		};
		DialogMgr.alert(alertArgMsg, alertArgButtonName, alertArgCallbackFunction);
	}
	else {
		// join the tunnel, then show the tunnel-list page:
		UiMgr.createInAccountTunnelAsSecondUser(UiMgr.newTunnelSecondUserExistingAccount.secondUserTempKey);
	}		
};





p.inAccountSubmitTunnelPasscodeCancel=function() {
	ClickHandlers._logClick("inAccountSubmitTunnelPasscodeCancel", "");
	if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
		UiMgr.showAuthPage("authTunnelList");
	}
	else {
		TunnelMgr.singleTunnelAccountEnterTunnel();
	}
};





p.authCreatingUserUploadNewImageKeyCancel=function() {
	ClickHandlers._logClick("authCreatingUserUploadNewImageKeyCancel", "");
	UiMgr.goToHomepageAndResetUi();
};


p.authUploadExistingImageKeyCancel=function() {
	ClickHandlers._logClick("authUploadExistingImageKeyCancel", "");
	UiMgr.goToHomepageAndResetUi();
};


p.creatingUserChoosePinClick=function() {
	ClickHandlers._logClick("creatingUserChoosePinClick", "");
	PinPad.pinEntryForCreatingUserNewPinComplete();
};


p.authNameNonFirstTunnelCancel=function() {
	ClickHandlers._logClick("authNameNonFirstTunnelCancel", "");
	// check whether this is a new or existing user
	if (!UiMgr.isAcctLoggedIn()) {
		UiMgr.goToHomepageAndResetUi();
	} 
	else {
		if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
			UiMgr.showAuthPage("authTunnelList");
		}
		else {
			TunnelMgr.singleTunnelAccountEnterTunnel();
		}
	}
};




p.useEmailTemplateClick=function() {
	ClickHandlers._logClick("useEmailTemplateClick", "");
	UiMgr.alertEmailTemplate($('#authCreateTunnelCompleteForm #secondUserTempKey').html());
};





p.whatIsATunnelHomepageClick=function() {
	ClickHandlers._logClick("whatIsATunnelHomepageClick", "");
	UiMgr.showNonAuthUiPage('whatIsATunnel');
};



p.authPageTopLogoClick=function() {
	ClickHandlers._logClick("authPageTopLogoClick", "");
	// NOT UNTIL I WORK OUT KINKS THAT THIS CAUSES -- Core.doDocumentAndDeviceReady(); // this is the document-ready function; we're resetting everything here, as if we reloaded the page, even though we didn't
	UiMgr.goToHomepageAndResetUi();
};

p.footerLogoClick=function() {
	ClickHandlers._logClick("footerLogoClick", "");
	if (UiMgr.permanentlyDisableFooterLinks) {
		return;
	}
	// footer link is no longer deactivated under any circumstances; we risk deadending mobile-app users (except in the above case, when we want to dead-end them):
	//if (!UiMgr.deactivatedFooterLogoLink) {
		AccountUpdateRetriever.requestUpdate(true);
		if (TunnelMgr.getTunnelsCount()>0) {
			if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
				UiMgr.showAuthPage("authTunnelList");
			}
			else {
				UiMgr.goToHomepageAndResetUi();
			}
		}
		else {
			UiMgr.goToHomepageAndResetUi();
		}		
	//}
};



p.destroyAccountClick=function() {
	ClickHandlers._logClick("destroyAccountClick", "");
	UiMgr.destroyAccountIfConfirmed(); // Note: this is a DOUBLE-confirmation
};

p.sendBetaFeedbackFromFormClick=function() {
	ClickHandlers._logClick("sendBetaFeedbackFromFormClick", "");
	UiMgr.sendBetaFeedbackFromForm();
};



p.creatingUserUploadNewImageKeyClick=function(leadingKeyBytes) {
	ClickHandlers._logClick("creatingUserUploadNewImageKeyClick", "");
	UiMgr.creatingAccount.creatingUserChosenImageKeyHexBytes=leadingKeyBytes;
	UiMgr.showAuthPage("authCreatingUserChoosePin");
};



p.existingAcctPinEntryClick=function(leadingKeyBytes) {
	ClickHandlers._logClick("existingAcctPinEntryClick", "");
	UiMgr.imageAuthentication.chosenImageKeyHexBytes=leadingKeyBytes;
	UiMgr.showAuthPage("authChooseExistingPin");
};


p.existingTunnelSecondUserNicknameCancelConfirm=function() {
	ClickHandlers._logClick("existingTunnelSecondUserNicknameCancelConfirm", "");
	DialogMgr.confirm(
			"Are you sure you want to cancel this?  Your new tunnel has not been created.  (You can still create it later.)", 
			function() {
				UiMgr.goToHomepageAndResetUi();
			}, 
			function() {}, 
			"Yes, cancel", 
			"No, don't cancel"
		);
}

p.secondUserHandleClickCancelConfirm=function() {
	ClickHandlers._logClick("secondUserHandleClickCancelConfirm", "");
	DialogMgr.confirm(
			"Are you sure you want to cancel this?", 
			function() {
				UiMgr.goToHomepageAndResetUi();
			}, 
			function() {}, 
			"Yes, Cancel", 
			"No, don't cancel"
		);
}




p.authCreatingUserChoosePinSubmit=function() {
	ClickHandlers._logClick("authCreatingUserChoosePinSubmit", "");
	if (PinPad.validateNewLastEnteredPin()) {
		UiMgr.pinEntryForCreatingUserNewPinComplete();
	}	
};



p.authNameNonFirstTunnelClick=function() {
	ClickHandlers._logClick("authNameNonFirstTunnelClick", "");
	
	var tunnelNameEl=$("#authNameNonFirstTunnelForm #nonFirstTunnelName");
	var tunnelName=tunnelNameEl.val();
	if (tunnelName.trim().length==0) {
		DialogMgr.validationAlert("Please enter a name for your tunnel and try again.", tunnelNameEl);
	}
	else if (tunnelName.trim().length>20) {
		DialogMgr.validationAlert("That tunnel name is longer than 20 characters; please try again.", tunnelNameEl);
	}
	else {
		// we take different paths here depending on whether or not the user entered a handle to invite:
		var invitingViaHandle=$("#inviteByHandle").is(":checked");
		if (invitingViaHandle) {
			var handleEl=$("#tunnelInviteeHandle");
			var handle=handleEl.val().trim();
			if (handle.length==0) {
				DialogMgr.validationAlert("You didn't enter your confidant's handle; please try again (or un-check the \"I know my confidant's handle\" box).", handleEl);
			}
			else if (handle.trim().toLowerCase()==UiMgr.currentAccountHandle.toLowerCase()) {
				DialogMgr.validationAlert("You entered your own handle; please enter your confidant's handle and try again (or un-check the \"I know my confidant's handle\" box).", handleEl);
			}
			else {
				var dataMap={handle:handle};
				var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.IS_HANDLE_USED_BY_ACTIVE_ACCOUNT, dataMap, false, null, null, 5000);
				if (typeof response!="undefined" && response!=null && response.success && response.handleIsUsed) {
					UiMgr.addTunnelToExistingAccountWithHandleInvite(tunnelName, handle);	
					tunnelNameEl.val("");
				}
				else {
					DialogMgr.validationAlert("We don't recognize the handle \""+handle+"\"; please make sure you typed it properly and try again (or un-check the \"I know my confidant's handle\" box).", handleEl);			
				}
			}
		}
		else {
			UiMgr.addTunnelToExistingAccount(tunnelName);	
			tunnelNameEl.val("");
		}
		
	}
};



p.authNewAccountChooseHandleClick=function() {
	ClickHandlers._logClick("authNewAccountChooseHandleClick", "");
	var handleEl=$("#authNewAccountChooseHandle #creatingUserHandle");
	var handle=handleEl.val().trim();
	if (handle.length==0) {
		DialogMgr.validationAlert("Please enter a name for yourself and try again.", handleEl);
	}
	else if (handle.length>20) {
		DialogMgr.validationAlert("That name is longer than 20 characters; please try again.", handleEl);
	}
	else if (handle.length<3) {
		DialogMgr.validationAlert("Your name must be at least three characters long; please try again.", handleEl);
	}
	else if (UiMgr.isValidHandleChars(handle)) {
		DialogMgr.validationAlert("Your name may only contain letters and numbers; please try again.", handleEl);
	}
	else {
		var dataMap={handle:handle};
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.IS_UNUSED_HANDLE, dataMap, false, null, null, 5000);
		if (typeof response!="undefined" && response!=null && response.success && response.handleUnused) {
			handleEl.val("");
			UiMgr.creatingAccount.creatingUserChosenTunnelName="First Tunnel";
			UiMgr.creatingAccount.creatingUserChosenNickname=handle;	
			UiMgr.createInitialUserAccount();			
		}
		else {
			DialogMgr.validationAlert("That name is already in use; please choose another.", handleEl);			
		}
	}
};



p.settingsSubmitHandleChange=function() {
	ClickHandlers._logClick("settingsSubmitHandleChange", "");
	var currentHandle=UiMgr.currentAccountHandle;
	var accountHasHandle=(currentHandle!=null);
	var handleEl=$("#existingAccountChangedHandle");
	var handle=handleEl.val().trim();
	if (handle.length==0) {
		DialogMgr.validationAlert("Please enter a handle for yourself and try again.", handleEl);
	}
	else if (accountHasHandle && handle.toLowerCase()==currentHandle.toLowerCase()) {
		DialogMgr.validationAlert("That's the same as your current handle; please try again.", handleEl);
	}
	else if (handle.length>20) {
		DialogMgr.validationAlert("That handle is longer than 20 characters; please try again.", handleEl);
	}
	else if (handle.length<3) {
		DialogMgr.validationAlert("Your handle must be at least three characters long; please try again.", handleEl);
	}
	else if (UiMgr.isValidHandleChars(handle)) {
		DialogMgr.validationAlert("Your handle may only contain letters and numbers; please try again.", handleEl);
	}
	else { 
		var dataMap={handle:handle};
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.IS_UNUSED_HANDLE, dataMap, false, null, null, 5000);
		if (typeof response!="undefined" && response!=null && response.success && response.handleUnused) {
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CHANGE_HANDLE, dataMap, false, null, null, 5000);
			if (typeof response!="undefined" && response!=null && response.success) {
				handleEl.val("");
				handleEl[0].blur(); // blur it so the label returns (for next viewing)
				UiMgr.currentAccountHandle=response.newHandle;
				UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);

				DialogMgr.alert("Your handle has been changed to '"+response.newHandle+"'.", "ok", function() {
					UiMgr.showSettingsSubPage("defaultSettingsSubPage");
				});							
			}
			else {
				DialogMgr.alert("There was a problem; your handle has not been changed. Please try again.");
				handleEl.val("");
				UiMgr.showSettingsSubPage("defaultSettingsSubPage");
			}
		}
		else {
			DialogMgr.validationAlert("That handle is already in use; please choose another.", handleEl);			
		}
	}
};




p.enterTunnelFromTunnelCreatedPageClick=function() {
	ClickHandlers._logClick("enterTunnelFromTunnelCreatedPageClick", "");
	AccountUpdateRetriever.requestUpdate(true);
	DialogMgr.confirm("Have you copied the temporary passphrase to give to your confidant?  Last chance!", function(){
		if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
			UiMgr.showAuthPage("authTunnelList");
		}
		else {
			TunnelMgr.singleTunnelAccountEnterTunnel();
		}
	}, null, "Yes", "No");
};

p.tunnelListItemClick=function(clientSessionTunnelId) {
	ClickHandlers._logClick("tunnelListItemClick", "");
	if (!TunnelMgr.ignoreItemClicks) {
		TunnelMgr.enterTunnel(clientSessionTunnelId);
	}
	
};





p.addTunnelLinkClick=function() {
	ClickHandlers._logClick("addTunnelLinkClick", "");
	if (UiMgr.permanentlyDisableFooterLinks) {
		return;
	}
	UiMgr.showAuthPage("authCreateTunnelOrEnterPasscode");
};

p.viewTunnelListLinkClick=function() {
	ClickHandlers._logClick("viewTunnelListLinkClick", "");
	if (UiMgr.permanentlyDisableFooterLinks) {
		return;
	}
	try {
		TunnelMgr.exitTunnel(true);
	}
	catch (e) {
		if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
			UiMgr.showAuthPage("authTunnelList");
		}
		else {
			TunnelMgr.singleTunnelAccountEnterTunnel();
		}
	}
};




p.tunnelHeaderSettingsClick=function() {
	ClickHandlers._logClick("tunnelHeaderSettingsClick", "");
	VirtualKeyboard.changeKbVisibilityAsNeeded(false, true);
	setTimeout(function() {
		ClickHandlers.settingsLinkClick(true);
	}, 50);
};


p.tunnelHeaderHelpClick=function() {
	ClickHandlers._logClick("tunnelHeaderHelpClick", "");
	// click on the settings link at the top of the convo history; this is the same as a click to the 
	// settings link in the footer except we need to tell that method that we're in the convo history with
	// a true boolean, so:
	ClickHandlers.helpLinkClick(true);
};







p.settingsLinkClick=function(isMessengerUi) {
	ClickHandlers._logClick("settingsLinkClick", "isMessengerUi="+isMessengerUi);

	// show or hide specific settings main-page elements depending on who's logged in:
	
	// hide this in all cases; it's note ready  --
	$("#changeNameRow").hide();
	$("#changeNameSpacerRow").hide();	
	
	if (!skinnedUi) { // regular TX --
		$("#downloadPatientDataRow").hide();
		$("#downloadPatientDataSpacerRow").hide();
		$("#resetClientTimesRow").hide();
		$("#resetClientTimesSpacerRow").hide();
		$("#managePaymentsRow").hide();
		$("#managePaymentsSpacerRow").hide();
	}
	else { // pro site such as TT --
		$("#tunnelSettingsRow").hide();
		$("#tunnelSettingsSpacerRow").hide();
		$("#changeHandleRow").hide();
		$("#changeHandleSpacerRow").hide();

		if (UiMgr.currentAcctIsProfessionalClient) { // a client --
			$("#downloadPatientDataRow").hide();
			$("#downloadPatientDataSpacerRow").hide();
			$("#resetClientTimesRow").hide();
			$("#resetClientTimesSpacerRow").hide();
			$("#destroyAccountRow").hide();
			$("#destroyAccountSpacerRow").hide();
			$("#managePaymentsRow").hide();
			$("#managePaymentsSpacerRow").hide();
		}
		else { // an originator (e.g. therapist) --
			// nothing specific to hide for originators that's not hidden for all pro-site users.
		}
	}

	UiMgr.tunnelIdCurrentlyEditingInSettings=null;
	UiMgr.setUpSettingsTunnelSelectMenu();
	if (!window.mobileApp) {
		DialogMgr.openSettingsDialog();
		UiMgr.showSettingsSubPage("defaultSettingsSubPage");
		return;
	}
	else {
		isMessengerUi=(typeof isMessengerUi=="undefined"?false:isMessengerUi);
		// first, resize the settings dialog appropriately:
		$("#mobileSettingsDialog").css("height", ""+($(window).height()-(isMessengerUi?0:45))+"px");
		if (ScreenViewStack.isMessagingUiActive()) {
			$("#wrapperTable").hide();
		}
		DialogMgr.openSettingsDialog();
		UiMgr.showSettingsSubPage("defaultSettingsSubPage");
	}
};


p.settingsSubmitTunnelNameChange=function() {
	ClickHandlers._logClick("settingsSubmitTunnelNameChange");
	var tunnelNameEl=$("#newTunnelName");
	var tunnelName=tunnelNameEl.val().trim();
	if (tunnelName.length==0) {
		DialogMgr.validationAlert("Please enter a new tunnel name and try again.", tunnelNameEl);
	}
	else if (tunnelName.length>20) {
		DialogMgr.validationAlert("That name is longer than 20 characters; please try again.", tunnelNameEl);
	}
	else if (tunnelName.length<5) {
		DialogMgr.validationAlert("The tunnel name must be at least five characters long; please try again.", tunnelNameEl);
	}
	else if (UiMgr.isValidTunnelNameChars(tunnelName)) {
		DialogMgr.validationAlert("The name may only contain letters, numbers, spaces, and the \"'\", \"-\", \"(\", \")\", and \"!\" characters; please try again.", tunnelNameEl);
	}
	else {	
		setTimeout(function() {
			UiMgr.renameTunnel(UiMgr.tunnelIdCurrentlyEditingInSettings, tunnelName);
			UiMgr.showSettingsSubPage("defaultSettingsSubPage");
			DialogMgr.alert("The tunnel has been renamed to \""+tunnelName+"\".");
		}, 100);
	}

};
	


p.settingsDeleteTunnelClick=function() {
	ClickHandlers._logClick("settingsDeleteTunnelClick");
	if (UiMgr.tunnelIdCurrentlyEditingInSettings==null) {
		throw new Error("UiMgr.tunnelIdCurrentlyEditingInSettings should not be null here.");
	}

	UiMgr.destroyTunnelIfConfirmed(UiMgr.tunnelIdCurrentlyEditingInSettings, function() {
		UiMgr.showSettingsSubPage("defaultSettingsSubPage");
		DialogMgr.alert("The tunnel has been destroyed.");
	});
};










p.helpLinkClick=function(isMessengerUi) {
	ClickHandlers._logClick("helpLinkClick", "isMessengerUi="+isMessengerUi);
	if (UiMgr.permanentlyDisableFooterLinks) {
		return;
	}
	if (!window.mobileApp) {
		// show the proper help and return:
		UiMgr.showNonAuthUiPage("help");
		setTimeout(function() {
			$("#notSignedInHelp")[!UiMgr.isAcctLoggedIn()?"show":"hide"]();
			$("#signedInHelp")[UiMgr.isAcctLoggedIn()?"show":"hide"]();			
		}, 100);
		return;
	}
	else {
		isMessengerUi=(typeof isMessengerUi=="undefined"?false:isMessengerUi);
		// first, resize the settings dialog appropriately:
		$("#mobileHelpDialog").css("height", ""+($(window).height()-(isMessengerUi?0:45))+"px");
		if (ScreenViewStack.isMessagingUiActive()) {
			$("#wrapperTable").hide();
		}
		DialogMgr.openHelpDialog();
	}
};


//mobile only:
p.settingsHeaderClick=function() {
	ClickHandlers._logClick("settingsHeaderClick", "");
	// mobile settings now also appear in a dialog, so we just close it:
	if (mobileApp && ScreenViewStack.isMessagingUiActive()) {
		$("#wrapperTable").show();
		// force-show or force-hide the virtual kb (need to do this for display reasons):
		MessengerMgr.setVirtualKbModeEnabled(MessengerMgr.isVirtualKbModeEnabled(), true);
		VirtualKeyboard.changeKbVisibilityAsNeeded(MessengerMgr.isVirtualKbModeEnabled(), true);
	}
	//BackbuttonFunctionStack.getAndRemoveCurrent();  // a click, not a back-button event, is closing this settings dialog, so remove the closer fn from the stack
	DialogMgr.closeSettingsDialog();
};





// mobile only:
p.helpHeaderClick=function() {
	ClickHandlers._logClick("helpHeaderClick", "");
	// mobile settings now also appear in a dialog, so we just close it:
	if (mobileApp && ScreenViewStack.isMessagingUiActive()) {
		$("#wrapperTable").show();
	}
	//BackbuttonFunctionStack.getAndRemoveCurrent(); 
	DialogMgr.closeHelpDialog();
};


p.tunnelListAddButtonClick=function() {
	ClickHandlers._logClick("tunnelListAddButtonClick", "");
	if (TunnelMgr.addDeleteMode=="add") {
		// the tunnel list is already in add mode, so we want to go and add a tunnel, so this is the same as a click on the "+" in the footer:
		ClickHandlers.addTunnelLinkClick();
	}
	else {
		TunnelMgr.switchAddDeleteMode("add");
	}
};

p.tunnelListDeleteButtonClick=function() {
	ClickHandlers._logClick("tunnelListDeleteButtonClick", "");
	if (TunnelMgr.addDeleteMode=="delete") {
		TunnelMgr.switchAddDeleteMode("add");
	}
	else {
		TunnelMgr.switchAddDeleteMode("delete");
	}
};


p.tunnelListItemBombClick=function(e, clientTunnelId) {
	ClickHandlers._logClick("tunnelListItemBombClick", "clientTunnelId="+clientTunnelId);
    if (!e) {
    	e=window.event;
    }
	if (e.stopPropagation) {
		e.stopPropagation();
	}
	else {
		e.cancelBubble=true;
	}
	UiMgr.destroyTunnelIfConfirmed(clientTunnelId);
};


p.cancelEvent=function(e) {
    if (!e) {
    	e=window.event;
    }
	if (e.stopPropagation) {
		e.stopPropagation();
	}
	else {
		e.cancelBubble=true;
	}
};









// handles clicks on store links (desktop only, which includes tablets viewing the desktop ui).  appOs is ios or android.
p.homepageStoreLinkClick=function(url, appOs, deviceIsTablet, deviceIsAppleTablet, deviceIsAndroidTablet) {
	ClickHandlers._logClick("homepageStoreLinkClick", "");
	if (!deviceIsTablet) {
		window.open(url);
	}
	else if (deviceIsAppleTablet) {
		if (appOs=="ios") {
			DialogMgr.confirm("Since you are using an Apple tablet device, you may use this website to access Tunnel X, or download the app. Which would you like to do?", function(){}, function(){window.open(url);}, "Use this site", "Get the app");
		}
		else {
			// they want to see the Play Store link, fine; they'll go there in their browser:
			window.open(url);
		}
	}
	else if (deviceIsAndroidTablet) {
		if (appOs=="android") {
			DialogMgr.confirm("Since you are using an Android tablet device, you may use this website to access Tunnel X, or download the app. Which would you like to do?", function(){}, function(){window.open(url);}, "Use this site", "Get the app");
		}
		else {
			// they want to see the Play Store link, fine; they'll go there in their browser:
			window.open(url);
		}
	}
	/*
	else if (deviceIsAndroidTablet) {
		if (appOs=="android") {
			DialogMgr.alert("Since you are using an Android tablet device, you may use this website to access Tunnel X (the Tunnel X Android app is designed for smartphones only).");
		}
	}
	*/
	else { // else we are on a tablet, but not an Apple or Android one, so just let people go to the store links, which will open in their browsers:
		window.open(url);
	}
};


p.settingsAddDeviceClick=function() {
	ClickHandlers._logClick("settingsAddDeviceClick", "");
	// Get a new key from the server:
	DialogMgr.openBlockingModalDialog("One moment please...");
	setTimeout(function() {
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.GET_EXISTING_ACCOUNT_NEW_DEVICE_PASSPHRASE, {}, false);	
		DialogMgr.closeBlockingModalDialog();
		if (typeof response=="undefined") {
			DialogMgr.alert("You appear to have lost your internet connection; please try again later.");
			return;
		}
		UiMgr.showSettingsSubPage("addADeviceSubPage"); // reveal the sub-page with the passphrase on it...	
		$("#addADevicePassphrase").html(response.tk); // ...then populate the copy-n-paste div with the new temp passphrase.
	}, 100);
};



p.settingsBackupKeyClick=function() {
	ClickHandlers._logClick("settingsBackupKeyClick", "");
	// Get a new (long, backup, never-expiring) key from the server:
	DialogMgr.openBlockingModalDialog("One moment please...");
	setTimeout(function() {
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.GET_EXISTING_ACCOUNT_BACKUP_PASSPHRASE, {}, false);	
		DialogMgr.closeBlockingModalDialog();
		if (typeof response=="undefined") {
			DialogMgr.alert("You appear to have lost your internet connection; please try again later.");
			return;
		}
		UiMgr.showSettingsSubPage("backupKeySubPage"); // reveal the sub-page with the passphrase on it...	
		$("#backupKeyPassphrase").html(response.tk); // ...then populate the copy-n-paste div with the new passphrase.
	}, 100);
};








p.settingsRemoveFromDeviceClick=function() {
	ClickHandlers._logClick("settingsRemoveFromDeviceClick", "");
	UiMgr.showSettingsSubPage("removeFromDeviceSubPage"); // reveal the sub-page
};

p.settingsChangeHandleClick=function() {
	ClickHandlers._logClick("settingsChangeHandleClick", "");
	UiMgr.showSettingsSubPage("changeHandleSubPage");
	$("#existingAccountChangedHandle label").show();
	UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
};

p.settingsChangeProNameClick=function() {
	ClickHandlers._logClick("settingsChangeProNameClick", "");
	UiMgr.showSettingsSubPage("changeProOriginatingNameSubPage");
	$("#existingAccountChangedProOriginatingName label").show();
	UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
};







p.settingsNonDefaultPageBackArrowClick=function() {
	ClickHandlers._logClick("settingsNonDefaultPageBackArrowClick", "");
	UiMgr.showSettingsSubPage("defaultSettingsSubPage");
};

p.removeKeySettingsButtonClick=function() {
	ClickHandlers._logClick("removeKeySettingsButtonClick", "");
	DialogMgr.confirm(
			"Are you absolutely sure?<br/><br/>This will remove your account from this device, but your confidants will still have "
			+"access to the tunnels you share with them.<br/><br/>If you wish to erase every trace of your tunnels and messages, tap "
			+" \"no\", then \"cancel,\" then tap \"destroy your account.\"", 
			function() { 
				try {
					ClientStorage.wipe();
					// log the user out, but only give 100ms to do that (we may be offline), then go to the homepage
					setTimeout(function() {
						UiMgr.goToHomepageAndResetUi();
					}, 100);
					try {
						UiMgr.expressLogout();	
					}
					catch (ee) {}
				
				}
				catch (e) {
					DialogMgr.alert("There was an error; your key may not have been removed.");
				}
			}, 
			function(){}, 
			"Yes", 
			"No"
		);
}; 


p.cancelRemoveKeySettingsButtonClick=function() {
	ClickHandlers._logClick("cancelRemoveKeySettingsButtonClick", "");
	UiMgr.showSettingsSubPage("defaultSettingsSubPage");
};

p.settingsManagePaymentsCancelClick=function() {
	ClickHandlers._logClick("settingsManagePaymentsCancelClick", "");
	UiMgr.showSettingsSubPage("defaultSettingsSubPage");
};



p.paypalArrowClick=function(clickedDomEl) {
	DialogMgr.alert("The Paypal site has opened in a new tab or window.  When you are finished setting up recurring payments, please return here.",
			"OK",
			function() {
				UiMgr.showSettingsSubPage("defaultSettingsSubPage");
			});
	return true;
};







p._logClick=function(functionName, additionalData) {
	if (typeof additionalData=="undefined" || additionalData==null || additionalData.length==0) {
		additionalData="[none]";
	}
	if (location.href.indexOf("localdev")>-1) {
		console.info("ClickHandler."+functionName+"() called; additionalData="+additionalData);		
	}
};




p.notSignedInHelpTypeToggle=function(creatingUser) {
	$("#notSignedInHelp #creatingUserHelp")[creatingUser?"show":"hide"]();
	$("#notSignedInHelp #secondUserHelp")[creatingUser?"hide":"show"]();
};


p.signedInHelpShowSection=function(section) {
	$("#signedInHelp #generalHelp")[section=="generalHelp"?"show":"hide"]();
	$("#signedInHelp #faq")[section=="faq"?"show":"hide"]();
	$("#signedInHelp #privacy")[section=="privacy"?"show":"hide"]();
	$("#signedInHelp #tos")[section=="tos"?"show":"hide"]();
};


p.toggleHelpTypes=function(loggedIn) {
	$("#signedInHelp")[loggedIn?"show":"hide"]();
	$("#notSignedInHelp")[loggedIn?"hide":"show"]();
};



p.addClientSubmit=function(formId) {
	var nameEl=$("#"+formId+" #clientName");
	var emailEl=$("#"+formId+" #clientEmail");
	var telEl=$("#"+formId+" #clientTel");
	if (nameEl.val().length==0) {
		DialogMgr.validationAlert("Please enter the "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"'s name and try again.", nameEl);
	}
	else if (emailEl.val().trim().length>0 && !UiMgr.isValidEmailAddress(emailEl.val())) {
		DialogMgr.validationAlert("That is not a valid email address. Please enter one in the format somename@somecompany.com and try again (or leave this blank; it's not required).", emailEl);
	}
	else {
		UiMgr.addTunnelToExistingProfessionalAccount(nameEl.val().trim(), emailEl.val().trim(), telEl.val().trim());	
		nameEl.val("");
		emailEl.val("");
		telEl.val("");
	}
};

p.professionalTunnelCompleteNotNowButtonClick=function() {
	DialogMgr.alert("No problem.  When you're ready to start adding "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"s, just click the '+' icon in the bottom-right corner of your screen.", 
			"OK", 
			// from here, same as clicking tunnel-list link in footer:
			function() {
				ClickHandlers.viewTunnelListLinkClick();
			}
	);
};

p.professionalTunnelCompleteDoneButtonClick=function() {
	DialogMgr.alert("Okay! When you want to add more "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"s in the future, just click the '+' icon in the bottom-right corner of your screen.", 
			"OK", 
			// from here, same as clicking tunnel-list link in footer:
			function() {
				ClickHandlers.viewTunnelListLinkClick();
			}
	);
};

p.settingsDownloadPatientDataClick=function(clickedAnchor) {
	DialogMgr.alert("After clicking \"OK\", you'll download a \"CSV\" file containing all data you've entered for all "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"s on the "+UiMgr.skinnedSiteData.clientName+" Info screen.  (Most versions of Excel can open \"CSV\" files.)", "OK", function() {
		var clickedAnchorJq=$(clickedAnchor);
		var href=clickedAnchorJq.prop("href");
		window.open(href.replace(/\_sessPathParamName/g, UiMgr.sessionPathParamName).replace(/\_sessPathParamVal/g, CommMgr.getControlServer().sessionId));
	});
};


p.settingsResetPatientTimeDataClick=function() {
	DialogMgr.confirm("Okay to reset time-spent data for all "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"s to 0:00?", 
		function() {
			var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.RESET_ALL_PRO_CLIENT_TIME_DATA, {}, false);	
			if (typeof response=="undefined" || !response.success) {
				DialogMgr.alert("There was a problem; time-spent data wasn't reset.");
			}
			else {
				DialogMgr.alert("Time-spent data has been reset.");
			}
		},
		function() {},
		"OK",
		"Cancel"
	);
};
p.nonLoggedInMobileKeyRemoveButtonClick=function() {
	DialogMgr.confirm(
			"Are you sure you want to remove your key from this device?  You will have to import your account (if possible), or create an entirely new account.  You may lose all account data by doing this.  Okay to proceed?",
			function() {
				try {
					ClientStorage.wipe();
					// log the user out, but only give 100ms to do that (we may be offline), then go to the homepage
					setTimeout(function() {
						UiMgr.goToHomepageAndResetUi();
					}, 100);
				}
				catch (e) {
					DialogMgr.alert("There was an error; your key may not have been removed.");
				}				
			},
			function() {},
			"Yes, remove it!",
			"Cancel"
	);
};

p.escapeKeyup=function() {
	if (mobileApp) {
		return true;
	}
	if (UiMgr.currentAcctIsProfessionalClient) {
		return true;
	}
	//if (DialogMgr.isAnyDialogOpen()) {
	//	return true;
	//}
	if (TunnelMgr.currentClientSessionTunnelId!=null) {
		TunnelMgr.exitTunnel(true);
		return false;
	}
	return true; 
};




var ClickHandlers=new _ClickHandlers();