


function _Core () {
	this.doWidthZoomFix=window.doWidthZoomFix; // convenience
	this.forcedMobileWidth=0;
}

var p=_Core.prototype;





p.doDocumentAndDeviceReadyAfterPrngReady=function() {
	DialogMgr.initAsNeeded();

	DialogMgr.openBlockingModalDialog("Initializing...<br/><br/>Move your mouse around the screen to speed this process...<br/><br/><br/>");
	setTimeout(function() {
		if (Crypto.isPrngReady()) {
			DialogMgr.closeBlockingModalDialog();
			Core.doDocumentAndDeviceReady(); 
			
		}
		else {
			setTimeout(function() {
				console.warn("Crypto.isPrngReady() returned false; will check again in 100 millis.");
				Core.doDocumentAndDeviceReadyAfterPrngReady();
			}, 100);
		}		
	}, 0);
};

p.doDocumentAndDeviceReady=function() {
	DialogMgr.initAsNeeded();

	if (Core.doWidthZoomFix) {
		Core.startWidthZoomFix(320);
	}
	if (mobileApp && Core.reformatPinDisplayForLessOblongDisplay()) {
		Core.doReformatPinDisplayForLessOblongDisplay();
	}

    
    if (mobileApp) {
    	if (!ClientStorage.isLocalStorageEnabled()) {
    		throw new Error("localStorage is not enabled on this browser.  Since we are in a Cordova context, it should be; this is a problem and we can't continue.");
    	}
    }
    

	
	UiMgr=new _UiMgr(window.uiMgrProps, window.uiMgrHandlerKeys);


	MessengerMgr.maxMessageLengthKb=parseInt(MessengerMgr.maxMessageLengthBytes/1024);

	UiMgr.clearAllNonFileUploadFormFields(); /* in case the browser has remembered any values */
	ImageKeyUploader.clearFileUploadFormFields();
	
	// this shouldn't be running, but if it is:
	AccountUpdateRetriever.stop();

	
	var controlServer=new Server(window._ajhp, CommMgrConstants.SERVER_TYPE_CONTROL);
	CommMgr.addServer("controlServer", controlServer);
	var processDecryptedTkParamValueAfterInit=false;
	if (!window.mobileApp) {
		// we'll show the homepage, UNLESS there is a "tk" param (an encrypted temp key was passed on the URL), so:
		if (window.secondUserWithTkParam) {
			// we have a tk param; doesn't necessarily mean it's valid; check --
			if (invalidKeyPassedInTkParam) {
				UiMgr.showAuthPage("authHome");
				alert("Hmm... Looks like you've been invited to Tunnel X, but that the encrypted key in your URL is not valid.  Please make sure you copied the URL correctly.  Also if you have already created an account, you should simply go to https://tunnelx.com.");
			}
			else {
				// we have a tk param with a value that decrypts to a temp passphrase, so:
				processDecryptedTkParamValueAfterInit=true;
				// ...and show NO page; at the end of this doc-ready function, we'll call code that does that.
			}
		}
		else {
			UiMgr.showAuthPage("authHome");
		}
	}
	else {
		// for mobile, we may have the user's image key already stored, in localStorage.  If so, we don't need to show them
		// either the homepage or the upload-your-image page; we take them straight to the PIN-entry page.  So:
		var leadingImageKeyBytes="";
		
		var clientStorageKeyAccountCreatedForBytesKeyExistsButNotTrue;
		if (!ClientStorage.exists(UiMgr.clientStorageKeyAccountCreatedForBytesKey)) {
			clientStorageKeyAccountCreatedForBytesKeyExistsButNotTrue=false;
		}
		else if ((""+ClientStorage.get(UiMgr.clientStorageKeyAccountCreatedForBytesKey))!="true") {
			clientStorageKeyAccountCreatedForBytesKeyExistsButNotTrue=true;
		}
		else {
			clientStorageKeyAccountCreatedForBytesKeyExistsButNotTrue=false;
		}
		
		if (ClientStorage.exists(UiMgr.clientStorageKeyBytesKey) && clientStorageKeyAccountCreatedForBytesKeyExistsButNotTrue) {
			// Sometimes we'll have bytes stored in local storage that don't correspond to an actual account; unless
			// we do something about that, user will be dead-ended on the PIN-entry page, so:
			ClientStorage.remove(UiMgr.clientStorageKeyBytesKey);
		}
		// now we proceed, knowing that if we find a stored key, it corresponds to a real account --
		if (ClientStorage.exists(UiMgr.clientStorageKeyBytesKey)) {
			leadingImageKeyBytes=ClientStorage.get(UiMgr.clientStorageKeyBytesKey);
			if (typeof leadingImageKeyBytes=="undefined" || leadingImageKeyBytes==null) {
				leadingImageKeyBytes="";
			}
		}
		if (leadingImageKeyBytes.length>0 && CommMgr.onlineAndInitialSessionEstablishedCheck()) {
			UiMgr.showAuthPage("authChooseExistingPin");
		}
		else {
			UiMgr.showAuthPage("authHome");
		}
	}
	/*
    we may also be popping up one of the content pages (like "about", "faq", etc.);
    check (ALL of this is a last-minute, really ugly hack that needs to be cleaned up):
    */

    if (showAboutOnStart) {
        UiMgr.showNonAuthUiPage("about");
    }
    else if (showFaqOnStart) {
        UiMgr.showNonAuthUiPage("help");
    }
    else if (showPrivacyOnStart) {
        UiMgr.showNonAuthUiPage("privacy");
    }
    else if (showTosOnStart) {
        UiMgr.showNonAuthUiPage("tos");
    }
    else if (showContactOnStart) {
        UiMgr.showNonAuthUiPage("betafeedback");
    }
    else if (showWhatIsOnStart) {
        UiMgr.showNonAuthUiPage("whatIsATunnel");
    }
  //console.info("calling resizeWrapperTableInnerDiv() from Core.doDocumentAndDeviceReady...");
	UiMgr.resizeWrapperTableInnerDiv(false);
	
	MessengerMgr.resizeHistoryBoxHeight();
	
	
	if (window.mobileApp) {
		UiMgr.resizeMobileFullbleedPages(); 
	}

	if (mobileApp) {
		window.addEventListener("orientationchange", MessengerMgr.resizeHistoryBoxHeight, false);
		window.addEventListener("orientationchange", function() {UiMgr.resizeWrapperTableInnerDiv(false);}, false);
	}
	
	if (!window.mobileApp) { /* mobile devices don't get resized except when kb pops up, and firing this on mobiles causes issues. */
		$(window).resize(function(){MessengerMgr.resizeHistoryBoxHeight();});
	}

	$(window).unload(function(){UiMgr.expressLogout();});

	try {
		if (!window.mobileApp) { /* mobile devices don't get resized except when kb pops up, and firing this on mobiles causes issues. */ 
			window.addEventListener("resize", function() {UiMgr.resizeWrapperTableInnerDiv(false);}, false);
		} 
	}
	catch (e) {}

	$(window).keypress(function(){UiMgr.registerWindowActivity(); return true;});
	$(window).mousemove(function(){UiMgr.registerWindowActivity(); return true;});
	$(window).focus(function(){UiMgr.registerWindowActivity(); UiMgr.registerWindowFocusState(true); UiMgr.stopToggleTitle(); return true;});
	$(window).click(function(){UiMgr.registerWindowActivity(); return true;});
	$(window).blur(function(){UiMgr.registerWindowFocusState(false); return true;});

	$(document).keyup(function(e) {
		  if (e.keyCode == 27) {
			  return ClickHandlers.escapeKeyup();
		  }
		});
	
	Core.startAutologoutChecks();
	
	UiMgr.showFooterIcon("help", true);
	if (window.mobileApp) {
		UiMgr.resizeMobileAlertHeight();
	}
			
	$(".genericButton").button();  /* style <button> els with jquery-ui */ 
	$(".fakeTabButton").button(); /* the buttons which are fake tabs in the convo history for pro sites */


	

	if (mobileApp) {
		document.addEventListener("pause", MobileDevice._onPauseEvent, false);
		document.addEventListener("resume", MobileDevice._onResumeEvent, false);
		// note that for the followign two events (which fire when the device goes on/offline), the first firing of either of these doesn't happen for at least a second on iOS --
		document.addEventListener("online", MobileDevice._onOnlineEvent, false);
		document.addEventListener("offline", MobileDevice._onOfflineEvent, false);
		// this event is Android-only; if a call to MobileDevice.setBackbuttonFunction() has been made (BackbuttonFunctionStack
		// tracks what, if anything, should happen when the back button is pressed):
		document.addEventListener("backbutton", MobileDevice._onBackbuttonEvent, false);
		MobileDevice.setDeviceProperties(window.device); // window.device is an object made available by Cordova
		
		// start the check to see if we're online (mobile app only) (if we're offline for more than 10 mins, the ui will reset, returning either to the HP or the initial PIN-entry screen; either way, it will stop trying to ping the server):
		MobileDevice.resetUiIfClientOfflineTooLong(true);
		
		if (window.mobileApp) {
			UiMgr.resizeTunnelListWrapper();
		}

		// reveal the UI:
		setTimeout(function(){
			//$("#mobileAppPreReadyOverlay").hide("fade", 250);
			//$("#mobileAppPreReadyOverlay").hide(); // we don't use this anymore
		}, 100);
		
	}
	
	if (processDecryptedTkParamValueAfterInit) {
		Core.submitPasscodeFromTkParam(window.plaintextTempKey);
	}
	

	

};

p.submitPasscodeFromTkParam=function(passcode) {
	if (!CommMgr.onlineAndInitialSessionEstablishedCheck()) {
		return; // couldn't get online
	}

	UiMgr.newAccountSecondUser.tempKey=passcode;	
	
	var response;
	var dataMap={tempKey:UiMgr.newAccountSecondUser.tempKey};

	DialogMgr.openBlockingModalDialog("One moment...");

	response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.PREVALIDATE_HOMEPAGE_ENTERED_PASSCODE, dataMap, false);	
	if (!response.success) {
		var alertArgMsg="We don't recognize the secret code in your URL.  Please make sure you are using the correct URL that your confidant sent you. Or, if you already have already created an account with this URL, please just go to <a href=\"https://tunnelx.com\">https://tunnelx.com</a> and log in.";
		var alertArgButtonName="OK";
		var alertArgCallbackFunction=function() {
			if (!window.mobileApp) {
				DialogMgr.closeBlockingModalDialog();
			}
			UiMgr.newAccountSecondUser.tempKey=null;
		};
		DialogMgr.alert(alertArgMsg, alertArgButtonName, alertArgCallbackFunction);	
		UiMgr.showAuthPage("authHome");

	}
	else {
		var successType=response.successType;
		DialogMgr.closeBlockingModalDialog();	
		if (!professionalSite) {
			// vanilla tunnel x:
			if (successType=="tunnelKeyFound") {
				UiMgr.showAuthPage("authSecondUserNameSelf");	
			}
			else {
				UiMgr.showAuthPage("authImportAccountEnterExistingPin");
			}
		}
		else {
			// tunnel t or similar:
			if (successType=="tunnelKeyFound") {
				//UiMgr.showAuthPage("authSecondUserUploadNewImageKey"); // skip handle page; no handles here	
				if (!mobileApp) {
					// We're not mobile, so we authenticate users with image keys; here, the user chooses one --
					UiMgr.showAuthPage("authSecondUserUploadNewImageKey");				
				}
				else {
					// Else we are mobile-app.  We no longer use images to authenticate users on mobile.  But for backwards-compat, we
					// still generate a (fake) JPG file (actually, the first 40K of one, since that's all we ever deal with) and store
					// it in local client storage.  So:
					var mockJpgLeadingBytes=UiMgr.generateMockRandomJpgLeadingHexBytes();
					UiMgr.newAccountSecondUser.chosenImageKeyHexBytes=mockJpgLeadingBytes;
					ClientStorage.set(UiMgr.clientStorageKeyBytesKey, mockJpgLeadingBytes);
					ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false"); // we'll set this to the string "true" after we actually create the account server-side
					// Go straight to the choose-a-PIN page (skipping over STEP 4):
					UiMgr.showAuthPage("authSecondUserChoosePin");
				}			
			}
			else {
				UiMgr.showAuthPage("authImportAccountEnterExistingPin");
			}
		}
		$("#tkParamUserMessage").html("<b>Welcome to Tunnel X!</b>  Now, let's create your account so you can converse securely and privately with your confidant.<br/><br/>");
	}
};



// Note: in a desktopp browser (i.e. for debugging), this method will always determine the orientation to be portrait, and
// also will not calculate the zoom factor properly if the desktop browser's width is greater than its height.
p.startWidthZoomFix=function(forcedWidth) {
	try {
		Core.forcedMobileWidth=forcedWidth;
		//alert("Core.forcedMobileWidth="+Core.forcedMobileWidth)
	    Core.fixWidthZoom(); // fix the current scale.  
	    if (mobileApp) {
			window.addEventListener("orientationchange", Core.fixWidthZoom, false);	    	
	    }
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw __ee;
	}
}; 

p.doReformatPinDisplayForLessOblongDisplay=function() {
	try {
	    if (mobileApp) {
	    	var currentAspectRatio=Core.getAspectRatio();
	    	var targetAspectRatio=1.5;
	    	if (currentAspectRatio>targetAspectRatio) {
	    		// why were we here?????
	    		return;
	    	}
	    	$(".inPagePinPadHolder").each(function() {
	    		$(this).css("zoom", 0.82);
	    		$(this).css("width", "320px");
	    		$(this).css("border-left", "36px solid #30343A");
	    		$(this).css("border-right", "18px solid #30343A");
	    	});
	    	//document.body.style.zoom=zoomFactor;
			//window.addEventListener("orientationchange", function() {document.body.style.zoom=zoomFactor;}, false);	    	
	    }
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw __ee;
	}
};







p.fixWidthZoom=function() {
	if (Core.forcedMobileWidth==0) {
		return;
	}
	try {
		//alert("document.documentElement.clientWidth="+document.documentElement.clientWidth);
		var zoomFactor=document.documentElement.clientWidth / Core.forcedMobileWidth
		//alert("zoomFactor="+zoomFactor);
        document.body.style.zoom=zoomFactor;	    		
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.doTimedOutDeviceReadyCheck=function() { /* called by doDocumentReady(), for mobiles only */
	if (window.mobileDeviceReady) {
		Core.doDocumentAndDeviceReadyAfterPrngReady();
	}
	else {
		setTimeout(Core.doTimedOutDeviceReadyCheck, 100);
	}
};

p.containsOnly=function(s, validChars) {
	for (var i=0; i<s.length; i++) {
		if (validChars.indexOf(s.charAt(i))==-1) {
			return false;
		}
	}
	return true;
};

p.urlencode=function(s) {
	s=escape(s);
	return s.replace(/\%20/g, "+");
};

p.urldecode=function(s) {
	s=s.replace(/\+/g, "%20");
	return unescape(s);
};

p.arrayContains=function(arr, val) {
	for (var i=0; i<arr.length; i++) {
		if (arr[i]==val) {
			return true;
		}
	}
	return false;
};


p.selectText=function(domObj) {
    if ( document.selection ) {
        var range = document.body.createTextRange();
        range.moveToElementText(domObj);
        range.select();
    } else if ( window.getSelection ) {
        var range = document.createRange();
        range.selectNodeContents(domObj);
        window.getSelection().removeAllRanges();
        window.getSelection().addRange(range);
    }
};


p.toStringAllProps=function(o) {
	if (typeof o=="undefined") {
		return "[undefined]";
	}
	if (o==null) {
		return "[null]";
	}
	var s="[";
	var first=true;
    for (var prop in o) {
    	if (!o.hasOwnProperty(prop)) {
    		continue;
    	}
    	if (!first) {
    		s+="; ";
    	}
    	s+=prop+"="+o[prop];
    	first=false;
    }
    s+="]";
    return s;
};

p.startAutologoutChecks=function() {
	Core.doAutologoutCheck();
};

p.doAutologoutCheck=function() {
	var loggedOut=false;
	//console.info("in doAutologoutCheck() start...");
	if (UiMgr.isAcctLoggedIn()) {
		//console.info("in doAutologoutCheck(), acct is logged in...");
		// User done anything in a while?  If not, let's log them out --
		var diff=new Date().getTime()-UiMgr.lastActivityTimeMillis;
		//console.info("in doAutologoutCheck(), diff="+diff+" and (UiMgr.acctPrefs.autoExitAfterMinutesAcctPref*1000*60)="+(UiMgr.acctPrefs.autoExitAfterMinutesAcctPref*1000*60));
		if (diff>(UiMgr.acctPrefs.autoExitAfterMinutesAcctPref*1000*60)) {
			if (!window.mobileApp) {
				// Desktop: force-log them out.
				loggedOut=true;
				//console.info("in doAutologoutCheck(), window.mobileApp=false, about to call MessengerMgr.doForcedLogout()...");
				MessengerMgr.doForcedLogout();					
			}
			else {
				// mobile; all we'll do is this, which will end their session but leave their key stored on the device (a forced logout would nuke it):
				loggedOut=true;
				try {
					// if Android, we should be able to close the app entirely
					//console.info("in doAutologoutCheck(), trying navigator.app.exitApp()...");
					navigator.app.exitApp();
				}
				catch (e) {
					//console.info("in doAutologoutCheck(), navigator.app.exitApp() threw Error ("+e.message+")...");
				} // iOS will currently throw an exception; some Androids might; desktop web debugging always will
				// do this for iOS (an for any Androids which for whatever reason were unable to exit, or any iOS's which
				// were able to execute exitApp() but didn't throw an exception and didn't exit) --
				setTimeout(function() {
					//console.info("in doAutologoutCheck(), calling goToHp...");
					UiMgr.goToHomepageAndResetUi();
				}, 250);				
			}
		}		
	}
	if (!loggedOut) {
		//console.info("in doAutologoutCheck(), !loggedOut, so calling self again in 15000 ms...");
		setTimeout(Core.doAutologoutCheck, 15000);		
	}

};

/**
 * Returns the display aspect ratio, regardless of orientation (so always a number >=1)
 */
p.getAspectRatio=function() {
	var height=parseInt($(window).height());
	var width=parseInt($(window).width());
	if (width>height) {
		height=width;
		width=parseInt($(window).height());
	}
	return height/width;
};

/**
 * Returns true if the display is less oblong than most devices (such as iPads); if returns true, PIN display must be reformatted
 */
p.reformatPinDisplayForLessOblongDisplay=function() {
	return (Core.getAspectRatio()<1.4);
};




var Core=new _Core();
