

function _DialogMgr () {
	this.mobileDialog=null;
	this.initted=false;
	this.allDialogRefs=[]; // will hold a ref to each dialog object after initIsNeeded() called
}
var p=_DialogMgr.prototype;



p.initAsNeeded=function() {
	if (DialogMgr.initted) {
		return;
	}
	DialogMgr.initted=true;
	DialogMgr.elementToFocusOnClose=null;
	DialogMgr.lastTextboxPromptValue="";
	
	if (window.mobileApp) {
		DialogMgr.mobileDialog=new MobileDialog();
	}
	else {
		// no need to set up this jquery-ui dialog stuff unless we're not mobile; note that there's logic in here
		// that acts conditionally based on whether we're mobile or not; if we're in this else block, we're not
		// mobile, but we'll leave it in there for now, in case we decide to switch back to jquery-ui dialogs
		// for mobile at some point:
		
		var mobileMinMaxWidthAllDialogs=260;
		DialogMgr.alertCallbackFn=null;
		DialogMgr.alertDialog=$("#alertDialog");
		DialogMgr.alertDialog.dialog({
			autoOpen: false, 
			title: "",
			buttons: { 
				"OK": function() { $(this).dialog("close"); }
			},
			closeText: "Close",
			draggable: true,
			minHeight: 0,
			minWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:675),
			maxWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:675),
			modal: true,
			resizable: false,
			zIndex: 9999
		});
		DialogMgr.allDialogRefs.push(DialogMgr.alertDialog);
		
		
		// this pageSpecificHelpDialog is a special alert used only for "help" text; it is separate from the alertDialog because
		// we want to be able to trigger a helpAlert from a regular alert without reusing the alert (thereby 
		// nuking it); it also has a higher z-index so it will always appear on top of a regular alert (may also
		// be called from a confirm, or not from a dialog at all).  It is also NOT MODAL.
		DialogMgr.pageSpecificHelpDialog=$("#pageSpecificHelpDialog");
		DialogMgr.pageSpecificHelpDialog.dialog({
			autoOpen: false, 
			title: "",
			buttons: { 
				"OK": function() { $(this).dialog("close"); }
			},
			closeText: "Close",
			draggable: true,
			minHeight: 0,
			maxHeight: 600,
			minWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:650),
			maxWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:650),
			modal: false,
			resizable: true,
			zIndex: 10000
		});
		DialogMgr.allDialogRefs.push(DialogMgr.pageSpecificHelpDialog);
		
		
		
		
		DialogMgr.confirmDialog=$("#confirmDialog");
		DialogMgr.confirmDialog.dialog({
			autoOpen: false, 
			title: "",
			buttons: {}, // populated later
			closeText: "Close",
			draggable: true,
			minHeight: 0,
			minWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:675),
			maxWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:675),
			modal: true,
			resizable: false,
			zIndex: 9999
		});
		DialogMgr.allDialogRefs.push(DialogMgr.confirmDialog);
		
		
		
		
		DialogMgr.blockingModalDialog=$("#blockingModalDialog");
		DialogMgr.blockingModalDialog.dialog({
			autoOpen: false, 
			title: "",
			buttons: {}, // no buttons; this is a messaging dialog which is only closed externally
			draggable: true,
			minHeight: 180,
			minWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:400),
			maxWidth: (window.mobileApp?mobileMinMaxWidthAllDialogs:400),				
			modal: true,
			resizable: false,
			zIndex: 9999,
			closeOnEscape: false // don't allow [esc] key to close this dialog
		});
		DialogMgr.allDialogRefs.push(DialogMgr.blockingModalDialog);
		
		
		
		
		
		DialogMgr.settingsDialog=$("#settingsDialog");
		var buttonsObj=new Object();
		buttonsObj["Done"]= function() { DialogMgr.settingsDialog.dialog("close");};
		DialogMgr.settingsDialog.dialog({
			autoOpen: false, 
			title: "",
			buttons: buttonsObj, 
			draggable: true,
			//minHeight: 500,
			minWidth: 900,
			maxWidth: 900,				
			modal: true,
			resizable: true,
			zIndex: 9999,
			closeOnEscape: true // allow [esc] key to close this dialog
		});
		DialogMgr.allDialogRefs.push(DialogMgr.settingsDialog);
		
		
		
		DialogMgr.desktopVirtualKeyboardDialogLarge=$("#desktopVirtualKeyboardDialogLarge");
		var buttonsObj=new Object();
		buttonsObj["Close"]= function() { 
			DialogMgr.desktopVirtualKeyboardDialogLarge.dialog("close"); 
			VirtualKeyboard.desktopVirtualKeyboardOpen=false;
			};
		buttonsObj["Smaller Keyboard"]= function() {
			DialogMgr.desktopVirtualKeyboardDialogLarge.dialog("close");
			DialogMgr.desktopVirtualKeyboardDialogSmall.dialog("close"); 
			VirtualKeyboard.desktopVirtualKeyboardOpen=false;
			DialogMgr.openDesktopVirtualKeyboardDialog(false);
			};
		DialogMgr.desktopVirtualKeyboardDialogLarge.dialog({
			autoOpen: false, 
			title: "",
			buttons: buttonsObj, 
			draggable: true,
			//minHeight: 500,
			minWidth: 1000,
			//maxWidth: 400,				
			modal: false,
			resizable: false,
			zIndex: 9999,
			closeOnEscape: true // allow [esc] key to close this dialog
		});
		DialogMgr.allDialogRefs.push(DialogMgr.desktopVirtualKeyboardDialogLarge);

		
		
		DialogMgr.desktopVirtualKeyboardDialogSmall=$("#desktopVirtualKeyboardDialogSmall");
		var buttonsObj=new Object();
		buttonsObj["Close"]= function() {
			DialogMgr.desktopVirtualKeyboardDialogSmall.dialog("close");
			VirtualKeyboard.desktopVirtualKeyboardOpen=false;
			};
		buttonsObj["Larger Keyboard"]= function() {
			DialogMgr.desktopVirtualKeyboardDialogSmall.dialog("close"); 
			DialogMgr.desktopVirtualKeyboardDialogLarge.dialog("close"); 
			VirtualKeyboard.desktopVirtualKeyboardOpen=false; 
			DialogMgr.openDesktopVirtualKeyboardDialog(true);
			};
		DialogMgr.desktopVirtualKeyboardDialogSmall.dialog({
			autoOpen: false, 
			title: "",
			buttons: buttonsObj, 
			draggable: true,
			//minHeight: 500,
			minWidth: 542,
			//maxWidth: 400,				
			modal: false,
			resizable: false,
			zIndex: 9999,
			closeOnEscape: true // allow [esc] key to close this dialog
		});
		DialogMgr.allDialogRefs.push(DialogMgr.desktopVirtualKeyboardDialogSmall);

		DialogMgr.customDialog=null;

	}	
};

p.isAnyDialogOpen=function() {
	for (var i=0; i<DialogMgr.allDialogRefs.length; i++) {
		try {
			if (DialogMgr.allDialogRefs[i].dialog("isOpen")===true) { // actual comparison with truth and type needed here per docs
				alert(DialogMgr.allDialogRefs[i]+" isOpen! returniing true.")
				return true;
			}			
		}
		catch (e) {}
	}
	return false;
};


/** Opens a modal alert (dialog with one button).
 * @param message The message to show; html is okay.
 * @param buttonName Optional: label for the button; if not supplied or if null, "OK" is used
 * @param callbackFn Optional: callback function to execute after button is clicked; if not supplied or if null, there will be no callback.
 */
p.alert=function(message, buttonName, callbackFn) {
	buttonName=((typeof buttonName=="undefined" || buttonName==null)?"OK":buttonName);
	if (typeof callbackFn=="undefined" || callbackFn==null) {
		callbackFn=function(){};
	}
	else if ((typeof callbackFn).toLowerCase()!="function") {
		throw new Error("The passed callbackFn was not a function; its type was "+typeof callbackFn+". This param must be a function, or null.");
	}

	if (!window.mobileApp) {
		DialogMgr.alertDialog.html(message);
		
		if (DialogMgr.alertCallbackFn!=null) {
			DialogMgr.alertDialog.unbind( "dialogclose", DialogMgr.alertCallbackFn);
		}
		if (callbackFn!=null) {
			DialogMgr.alertCallbackFn=callbackFn;
			DialogMgr.alertDialog.unbind("dialogclose");
			DialogMgr.alertDialog.bind( "dialogclose", DialogMgr.alertCallbackFn);
		}
		DialogMgr.alertDialog.dialog("option", "position", {my: "center", at: "center", of: window});
		DialogMgr.alertDialog.dialog("open");	
		
	}
	else {
		DialogMgr.mobileDialog._openMobileModalDialog(message, [buttonName], [callbackFn], 0);
	}
};

/*
 * Opens a non-modal, resizeable alert with a higher z-index than regular alerts/confirms/blocking-modals; also does not reuse
 * any other dialogs (therefore can be called from another dialog, as long as it's not another help dialog). Unlike
 * regular alerts, this dialog's closer button is always "OK" and it does not call a callback function.  (Finally note: whether
 * the dialog is modal or not doesn't matter for mobile since mobile dialogs are displayed at full width/height.)
 */
p.helpAlert=function(message) {
	if (!window.mobileApp) {
		DialogMgr.pageSpecificHelpDialog.html(message);
		DialogMgr.pageSpecificHelpDialog.dialog("option", "position", {my: "center", at: "center", of: window});
		DialogMgr.pageSpecificHelpDialog.dialog("open");	
	}
	else {
		DialogMgr.mobileDialog._openMobilePageSpecificHelpDialog(message);
	}
};








/** Opens a confirm (a dialog with a "true" button and a "false" button, typically an OK/Cancel pair)
 * @param message The message; html is okay
 * @param trueCallbackFn Optional: function to be called when "true" button is clicked; if not specified or null, there will be no "true" callback
 * @param falseCallbackFn Optional: function to be called when "false" button is clicked; if not specified or null, there will be no "false" callback
 * @param trueButtonLabel Optional: label for the "true" button; defaults to "OK" if null or not specified
 * @param falseButtonLabel Optional: label for the "false" button; defaults to "Cancel" if null or not specified
 * 
 */
p.confirm=function(message, trueCallbackFn, falseCallbackFn, trueButtonLabel, falseButtonLabel) {
	if (typeof trueCallbackFn=="undefined" || trueCallbackFn==null) {
		trueCallbackFn=function(){};
	}
	if (typeof falseCallbackFn=="undefined" || falseCallbackFn==null) {
		falseCallbackFn=function(){};
	}
	if (typeof trueButtonLabel=="undefined" || trueButtonLabel==null) {
		trueButtonLabel="OK";
	}
	if (typeof falseButtonLabel=="undefined" || falseButtonLabel==null) {
		falseButtonLabel="Cancel";
	}
	
	if (!window.mobileApp) {
		var buttons=new Object();
		DialogMgr.confirmDialog.html(message);
		buttons[trueButtonLabel]= function() { DialogMgr.confirmDialog.dialog("close"); trueCallbackFn(); };
		buttons[falseButtonLabel]= function() { DialogMgr.confirmDialog.dialog("close"); falseCallbackFn(); };
		DialogMgr.confirmDialog.dialog("option","buttons", buttons);
		DialogMgr.confirmDialog.dialog("option", "position", {my: "center", at: "center", of: window});
		DialogMgr.confirmDialog.dialog("open");		
	}
	else {
		DialogMgr.mobileDialog._openMobileModalDialog(message, [trueButtonLabel, falseButtonLabel], [trueCallbackFn, falseCallbackFn], 0);
	}
};





p.textboxPrompt=function(preTextboxMessage, textboxDefaultValue, textboxCss, okCallbackFn, cancelCallbackFn, okButtonLabel, cancelButtonLabel, passwordBox) {
	if (preTextboxMessage==null) {
		throw new Error("preTextboxMessage can't be null");
	}
	if (typeof textboxDefaultValue=="undefined" || textboxDefaultValue==null) {
		textboxDefaultValue="";
	}
	if (typeof textboxCss=="undefined" || textboxCss==null) {
		textboxCss="margin-top:4px;";
	}
	if (typeof okCallbackFn=="undefined" || okCallbackFn==null) {
		okCallbackFn=function(){};
	}
	if (typeof cancelCallbackFn=="undefined" || cancelCallbackFn==null) {
		cancelCallbackFn=function(){};
	}
	if (typeof okButtonLabel=="undefined" || okButtonLabel==null) {
		okButtonLabel="OK";
	}
	if (typeof cancelButtonLabel=="undefined" || cancelButtonLabel==null) {
		cancelButtonLabel="Cancel";
	}	
	if (typeof passwordBox=="undefined" || passwordBox==null) {
		passwordBox=false;
	}
	DialogMgr.lastTextboxPromptValue="";
	var buttons=new Object();
	var message="";
	if (preTextboxMessage.length>0) {
		message+=preTextboxMessage+"<br/>";
	}
	var now=new Date().getTime(); 
	message+="<form style=\"display:inline;\" name=\"promptForm"+now+"\" id=\"promptForm"+now+"\" action=\"#\" onsubmit=\"return false;\">";
	message+="<input "+(window.mobileApp?"tabindex=\"-1\"":"")+" onblur=\"DialogMgr.lastTextboxPromptValue=this.value\"  onkeyup=\"DialogMgr.lastTextboxPromptValue=this.value\" onchange=\"DialogMgr.lastTextboxPromptValue=this.value\" type=\""+(passwordBox?"password":"text")+"\" class=\"formTypeText\" style=\""+textboxCss+"\" name=\"promptTextbox"+now+"\" value=\""+textboxDefaultValue+"\" id=\"promptTextbox"+now+"\">";	
	message+="</form>";
	DialogMgr.confirmDialog.html(message);
	buttons[okButtonLabel]= function() { DialogMgr.confirmDialog.dialog("close"); okCallbackFn(); };
	buttons[cancelButtonLabel]= function() { DialogMgr.confirmDialog.dialog("close"); cancelCallbackFn(); };
	DialogMgr.confirmDialog.dialog("option","buttons", buttons);
	DialogMgr.confirmDialog.dialog("option", "position", {my: "center", at: "center", of: window});
	DialogMgr.confirmDialog.dialog("open");

};





// NOTE ABOUT USING THIS METHOD: remember that whenever we open a dialog before communicating with the server, we have to put that server-
// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up
/**
 * 
 */
p.openBlockingModalDialog=function(message, expectedDisplayDurationMillis) {
	// Fuck this bullshit; no progress pars for now:
	expectedDisplayDurationMillis=0;
	
	if (!window.mobileApp) {
		DialogMgr.blockingModalDialog.html("<br/>"+message);
		DialogMgr.blockingModalDialog.dialog("option", "position", {my: "center", at: "center", of: window});
		DialogMgr.blockingModalDialog.dialog("open");		
	}
	else {
		DialogMgr.mobileDialog._openMobileModalDialog(message, [], [], expectedDisplayDurationMillis);
	}

};

p.closeBlockingModalDialog=function() {
	if (!window.mobileApp) {
		DialogMgr.blockingModalDialog.html("");
		DialogMgr.blockingModalDialog.dialog("close");		
	}
	else { 
		DialogMgr.mobileDialog.closeMobileModalDialog();
	}
};



/**
 * Closes the dialog opened by  openCustomDialog() -- often called from within the dialog itself (or an iframe within the dialog); exits silently if there's an exception.
 */
p.closeDialog=function() {
	try {
		// first we have to kick the doc that's in there out:
		DialogMgr.customDialog.html("<html><head></head><body></body></html>");
		// And then close the dialog:
		DialogMgr.customDialog.dialog("close");
		if (DialogMgr.allDialogRefs[DialogMgr.allDialogRefs.length-1]==DialogMgr.customDialog) {
			DialogMgr.allDialogRefs.pop();
		}
	}
	catch (e) {}
};






/**
 * 
 * @param uriRelFromAppCtx Doc to display in the iframe
 * @param widthPx outer width of the dialog
 * @param heightPx outer height of the dialog
 * @param dialogTitle text to appear in the dialog's title bar
 * @param closeButtonLabel label for the lower-right button which closes the dialog (null means don't show the button)
 * @param closeCallbackFn callback function to be called when the dialog is closed, either by the upper-right "x" or by the lower-right close button, if any
 */
p.openCustomDialog=function(html, widthPx, heightPx, dialogTitle, trueButtonLabel, trueCallbackFn, falseButtonLabel, falseCallbackFn, modal, cssClass) {
	try {
		// unlike with alert and confirm dialogs, we instantiate a new dialog object every time we need
		// an iframe dialog (among other things, so we can set the height and width):
		DialogMgr.customDialog=$("#customDialog");
		var showFalseButton=true;
		if (typeof trueCallbackFn=="undefined" || trueCallbackFn==null) {
			trueCallbackFn=function(){};
		}
		if (typeof falseCallbackFn=="undefined" || falseCallbackFn==null) {
			falseCallbackFn=function(){};
		}
		if (typeof trueButtonLabel=="undefined" || trueButtonLabel==null) {
			trueButtonLabel="OK";
		}
		if (typeof falseButtonLabel=="undefined" || falseButtonLabel==null) {
			showFalseButton=false;
		}
	
		var buttonsObj=new Object();
		if (trueButtonLabel!=null) {
			// then we're showing an OK button:
			buttonsObj[trueButtonLabel]=function() { $(this).dialog("close");};
		}
		if (falseButtonLabel!=null) {
			// then we're showing a Cancel button:
			buttonsObj[falseButtonLabel]=function() { $(this).dialog("close");};
		}
		if (typeof cssClass=="undefined" || cssClass==null) {
			cssClass="";
		}
		
		buttonsObj[trueButtonLabel]= function() { DialogMgr.customDialog.dialog("close"); trueCallbackFn(); };
		if (showFalseButton) {
			buttonsObj[falseButtonLabel]= function() { DialogMgr.customDialog.dialog("close"); falseCallbackFn(); };
		}
	
		DialogMgr.customDialog.dialog({
			autoOpen: true, 
			title: dialogTitle,
			buttons: buttonsObj,
			closeText: "Close",
			draggable: true,
			width:widthPx,
			height:heightPx,
			modal: modal,
			position: {my: "center", at: "center", of: window},
			resizable: false,
			zIndex: 9999,
			dialogClass: cssClass
		});
		DialogMgr.customDialog.bind("dialogclose", DialogMgr.clearCustomDialogHtml);
		DialogMgr.customDialog.html(html);
		DialogMgr.allDialogRefs.push(DialogMgr.customDialog);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};



/**
 * Opens the settings layout in a dialog which is similar to a customDialog except that its contents are populated
 * when the UI loads, and are never depopulated.
 */
p.openSettingsDialog=function() {
	try {
		if (!window.mobileApp) {
			DialogMgr.settingsDialog.dialog("option", "position", {my: "center", at: "center", of: window});
			DialogMgr.settingsDialog.dialog("open");
		}
		else {
			DialogMgr.mobileDialog._openMobileSettingsDialog();
		}	
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};


p.openHelpDialog=function() {
	try {
		if (!window.mobileApp) {
			throw new Error("This method is mobile-only; help is displayed differently for the desktop site.");
		}
		else {
			DialogMgr.mobileDialog._openMobileHelpDialog();
		}	
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};
/*
p.openBlockingModalDialog=function(message, expectedDisplayDurationMillis) {
	
	if (!window.mobileApp) {
		DialogMgr.blockingModalDialog.html("<br/>"+message);
		DialogMgr.blockingModalDialog.dialog("option", "position", {my: "center", at: "center", of: window});
		DialogMgr.blockingModalDialog.dialog("open");		
	}
	else {
		DialogMgr.mobileDialog._openMobileModalDialog(message, [], [], expectedDisplayDurationMillis);
	}

};
 */


/**
 * Opens the virtual keyboard (desktop only) and populates it if it's never been populated
 */
p.openDesktopVirtualKeyboardDialog=function(large) {
	if (VirtualKeyboard.desktopVirtualKeyboardOpen) {
		return;
	}
	try {	
		try {
			DialogMgr.desktopVirtualKeyboardDialogSmall.dialog("close");	
			DialogMgr.desktopVirtualKeyboardDialogLarge.dialog("close");
			VirtualKeyboard._revertToUnshifted();
		}
		catch (_e) {}
		if (!VirtualKeyboard.desktopDialogPopupated[large?"large":"small"]) {
			DialogMgr[large?"desktopVirtualKeyboardDialogLarge":"desktopVirtualKeyboardDialogSmall"].html(VirtualKeyboard.getHtml(true, large));
			VirtualKeyboard.desktopDialogPopupated[large?"large":"small"]=true;
		}
		DialogMgr[large?"desktopVirtualKeyboardDialogLarge":"desktopVirtualKeyboardDialogSmall"].dialog("open");
		VirtualKeyboard.desktopVirtualKeyboardOpen=true;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};








p.closeSettingsDialog=function() {

	try {
		if (!window.mobileApp) {
			DialogMgr.settingsDialog.dialog("close");		
		}
		else { 
			DialogMgr.mobileDialog.closeMobileSettingsDialog();
		}
	}
	catch (e) {}
};



p.closeHelpDialog=function() {

	try {
		if (!window.mobileApp) {
			// nothing; not used for desktop.	
		}
		else { 
			DialogMgr.mobileDialog.closeMobileHelpDialog();
		}
	}
	catch (e) {}
};



p.clearCustomDialogHtml=function() {
	DialogMgr.customDialog.html("");
};

p.validationAlert=function(message, elementToFocus) {
	try {
		var callbackFn;
		if (typeof elementToFocus != "undefined") {
			DialogMgr.elementToFocusOnClose=elementToFocus;
			callbackFn=_DMFocusElement;
		}
		else {
			DialogMgr.elementToFocusOnClose=null;		
			callbackFn=null;
		}
		DialogMgr.alert(message, "OK", callbackFn);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};



function _DMFocusElement() {
	if (DialogMgr.elementToFocusOnClose!=null) {
		try {
			DialogMgr.elementToFocusOnClose.focus();
		}
		catch (e) {}		
	}
	DialogMgr.elementToFocusOnClose=null;
}





DialogMgr=new _DialogMgr(); // note: the singleton exists now, but still needs to be initted
