

function _MediaUploader () {
	this.FILE_INPUT_SELECTOR="#fileUploadForm #file";
	this.CORDOVA_FILE_INPUT_SELECTOR="#cordovaFileUri";
	this.currentChosenFilename=null;

	this.uploadFileClickTimeout=null;
	this.enabled=false;
}

var p=_MediaUploader.prototype;

/** 
 * Must be called before using MediaUploader to manage file-upload-related input from user.
 */
p.startUseInEditor=function() {
	MediaUploader.reset();
	MediaUploader.enabled=true;
	UiMgr.currentMultipartMode="mediaUpload";
};




p.reset=function() {
	// Clear the hidden file-submitter form:
	MediaUploader.clearFileUploadFormFields();
	// Null out the context-variable values stored in the MediaUploader object:
	MediaUploader.uploadFileClickTimeout=null;
	MediaUploader.enabled=false;
	UiMgr.currentMultipartMode=null;
};


p.openFileChooser=function() {
	if (!window.useCordovaFilePluginForUploads) {
		$(MediaUploader.FILE_INPUT_SELECTOR).val(""); // reset current file if any
		$(MediaUploader.FILE_INPUT_SELECTOR).click(); // clicking this causes the dialog to open
	}
	else {
		$(MediaUploader.CORDOVA_FILE_INPUT_SELECTOR).val("");

		// must manually trigger this click to reset the timeout (runs the same function as the non-cordova case)
		MediaUploader.uploadFileHiddenFieldClick();

		// callback function for when user selects an image
		var cameraSuccess=function(fileUri) {
			$(MediaUploader.CORDOVA_FILE_INPUT_SELECTOR).val(fileUri);
			// trigger the onchange event manually to remain consistent with existing code
			// runs the same function as the non-cordova case
			$(MediaUploader.CORDOVA_FILE_INPUT_SELECTOR).change();
		}

		// set up camera options; note that the defaults are what we need for the rest
		var cameraOptions={};
		cameraOptions.sourceType=Camera.PictureSourceType.SAVEDPHOTOALBUM;
		cameraOptions.mediaType=Camera.MediaType.ALLMEDIA;
		cameraOptions.quality=100;
		cameraOptions.correctOrientation=true;

		navigator.camera.getPicture(cameraSuccess, null, cameraOptions);
	}
	// We don't do anything else here; if the user chooses a file, the element's onchange handler will fire.
};


p.uploadFileHiddenFieldClick=function() {
	// the only reason we track this "click" is to clear the timeout that tells us if the click in the function that 
	// should have opened the file dialog didn't work:
	window.clearTimeout(MediaUploader.uploadFileClickTimeout);
};


p.clearFileUploadFormFields=function() {
	UiMgr._clearFormFields(true);
};



p.doSubmitAction=function() {
	var filename=MediaUploader.currentChosenFilename;
	if (filename.trim().length==0) {
		MediaUploader.reset();
		return;
	}
	else {
		var lcFilename=filename.toLowerCase();
		setTimeout(function(){MediaUploader.uploadFile();},100);
	}
};

p.uploadFile=function() {
	try {
		var filename="";
		if (!window.useCordovaFilePluginForUploads) {
			filename=$("#fileUploadForm #file").val();
		}
		else {
			filename=$(MediaUploader.CORDOVA_FILE_INPUT_SELECTOR).val();
		}
		var fileSize;
		try {
			if (!window.useCordovaFilePluginForUploads) {
				fileSize=parseInt($("#fileUploadForm #file")[0].files && $("#fileUploadForm #file")[0].files[0].size);
			}
			else {
				window.resolveLocalFileSystemURL(filename, function(fileEntry) {
					fileEntry.file(function(fileObj) {
						$("#cordovaFileSize").val(fileObj.size);
					});
				});
			}
		}
		catch (e) { // not all browser support the above code:
			if (!window.useCordovaFilePluginForUploads) {
				fileSize=-1;
			}
			else {
				$("#cordovaFileSize").val(-1);
			}
		}
		$("#fileUploadForm #filename").val(UiMgr.getFilenameOnly(filename));
		$("#fileUploadForm #fileSize").val(fileSize);
		var qString="?_multipartHandlerKey="+UiMgr.handlerKeys.UPLOAD_MEDIA;
		$("#uploadStatusArea").show();
		$("#uploadStatusArea").html("Uploading/encrypting..."); // put this static message here until we can start writing dynamic ones based on upload info from the server
		qString+="&messageType="+MessengerMgr.currentMessageType;
		CommMgr.startAsynchronousAjaxFileUpload(CommMgr.getControlServer(), UiMgr.handlerKeys.UPLOAD_MEDIA, qString);	
		MessengerMgr.updateUploadDataStatusUI(null, "Uploading/encrypting...");
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};



p.doFileElementOnchange=function() {
	var currentChosenFile="";
	if (!window.useCordovaFilePluginForUploads) {
		currentChosenFile=$(MediaUploader.FILE_INPUT_SELECTOR).val();
	}
	else {
		currentChosenFile=$(MediaUploader.CORDOVA_FILE_INPUT_SELECTOR).val();
	}
	// filename may be a full file path, or a fake file path, or just a name (for most, it's a name).  We only want
	// the name (and we have to remember different systems have different file separators).  So:
	if (currentChosenFile.length>0) {
		currentChosenFile=currentChosenFile.replace(/\\/g,"/").replace(/\:/g,"/");
		if (currentChosenFile.indexOf("/")>-1) {
			currentChosenFile=currentChosenFile.substring(currentChosenFile.lastIndexOf("/")+1);
		}
	}
	MediaUploader.currentChosenFilename=currentChosenFile;
	MediaUploader.doSubmitAction();
};




p.uploadFileSuccessCallback=function() {
	DialogMgr.closeBlockingModalDialog();
	alert("do success cb here.");
};

p.uploadFileFailureCallback=function(errorMessage) {
	DialogMgr.alert(errorMessage);
	MediaUploader.clearFileUploadFormFields();
};








var MediaUploader=new _MediaUploader();
