function _MessengerMgr () {
	this.maxMessageLengthBytes=null;
	this.maxMessageLengthKb=null;
	this.USER_TYPE_LOCAL=1;
	this.USER_TYPE_CORRESPONDENT=2;
	this.USER_TYPE_SYSTEM=3;
	this.CKEDITOR_CSS_SELECTOR=".cke_wysiwyg_div"; // this assumes we never hve more than one CKEditor on the page; if we do, this needs to change (be more specific)
	if (!window.mobileApp) {
		this.MONTH_NAMES=["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];		
	}
	else {
		this.MONTH_NAMES=["Jan.", "Feb.", "Mar.", "Apr.", "May", "June", "July", "Aug.", "Sept.", "Oct.", "Nov.", "Dec."];		
	}
	
	this.standardUpdateCheckIntervalMillis=window.standardUpdateCheckIntervalMillis;
	this.doUpdateChecks=false; // set to true after successful login, back to false on logout
	this.retrievedCorrespondentMessageIds=[];
	this.correspondentStatusMessageSpanIds=["correspondentOnline","correspondentOffline","correspondentOfflineNeverOnline","correspondentTyping","correspondentUploading","correspondentDeletedAll"];
	this.currentCorrespondentStatusMessageSpanId=null;
	this.uploadsInProgress=0;
	this._plaintextEditorCleanContents=""; // only used by plaintext (mobile) editor, not CKEditor.
	this.updateCheckTimeout=null; // we use this to make sure that we don't end up with multiple timeouts calling for server updates
	this.currentConfidantName=null;
	this.maliciousFileExtensions=["0xe", "73k", "7z", "89k", "a6p", "ac", "acc", "acr", "action", "actm", "ahk", "air", "apk", "app", "arscript", "as",
	                              "asb", "awk", "azw2", "bat", "beam", "bin", "btm", "bz2", "cel", "celx", "chm", "cmd", "cof", "com", "command", "cpl",
	                              "crt", "csh", "css", "dek", "dld", "dmc", "docm", "dotm", "dxl", "ear", "ebm", "ebs", "ebs2", "ecf", "eham", "elf", "es",
	                              "ex4", "exe", "exopc", "ezs", "fas", "fky", "fpi", "frs", "fxp", "gadget", "gs", "gz", "ham", "hms", "hpf", "hta", "htm",
	                              "html", "iim", "inf1", "ins", "inx", "ipa", "ipf", "isp", "isu", "jar", "job", "js", "jse", "jsx", "kix", "ksh", "lnk", "lo",
	                              "ls", "mam", "mcr", "mel", "mpx", "mrc", "ms", "msc", "msi", "msp", "mst", "mxe", "nexe", "obs", "ore", "osx", "otm", "out",
	                              "paf", "pex", "php", "pif", "plx", "potm", "ppam", "ppsm", "pptm", "prc", "prg", "ps1", "pvd", "pwc", "pyc", "pyo", "qpx",
	                              "rar", "rbx", "reg", "rgs", "rox", "rpj", "run", "s2a", "sbs", "sca", "scar", "scb", "scr", "script", "sct", "sh", "shb",
	                              "shs", "smm", "spr", "tcp", "thm", "tlb", "tms", "u3p", "udf", "upx", "url", "vb", "vbe", "vbs", "vbscript", "vlx", "vpm",
	                              "wcm", "widget", "wiz", "workflow", "wpk", "wpm", "ws", "wsf", "xap", "xbap", "xlam", "xlm", "xlsm", "xltm", "xqt", "xys",
	                              "zip", "zl9"];
	this.virtualKbModeEnabled=false;
	this.messageComposeLabelJqObj=null;
	this.clientInfoFormFieldCodes=["fullname","email","address","telephone","cityStatePostal","mobileTelephone","workTelephone","generalNotes","medications"];
	this.currentMessageType="standard"; // one of "standard", "pro-note",  or "none" (if we're in Patient Info pro-mode
}

var p=_MessengerMgr.prototype;



p.isVirtualKbModeEnabled=function() {
	return MessengerMgr.virtualKbModeEnabled;
};


p.setVirtualKbModeEnabled=function(useVirtualKb, force) {
	if (!mobileApp) {
		MessengerMgr.virtualKbModeEnabled=false;
		return;
	}
	if (force || useVirtualKb!=MessengerMgr.virtualKbModeEnabled) {
		// if we're switching from one mode to another while in a tunnel, we may have already-typed data
		// which wwe need to preserve, so:
		var newCurrentTextarea=$("#msgCompose_mobile"+(useVirtualKb?"Vkb":""));
		var previousTextarea=$("#msgCompose_mobile"+(useVirtualKb?"":"Vkb"));
		var vkbOverlay=$("#msgCompose_mobileVkbOverlay");

		var currentText=previousTextarea.val();
		
		// only xfer the text if the new and previous textareas are different (they will always
		// be different, except if force==true, in which they might be the same):
		if (useVirtualKb!=MessengerMgr.virtualKbModeEnabled) {
			newCurrentTextarea.val(currentText); // transfer the text
			previousTextarea.val(""); // clear the editor we won't be using anymore			
		}

		MessengerMgr.virtualKbModeEnabled=useVirtualKb;
		newCurrentTextarea.show();
		previousTextarea.hide();
		vkbOverlay[MessengerMgr.virtualKbModeEnabled?"show":"hide"]();	
		
		if (!useVirtualKb) {
			// hide if we're switch off VKB mode, but don't show it if we're switching it on:
			VirtualKeyboard.changeKbVisibilityAsNeeded(false);
		}

		// put the caret at the end:
		newCurrentTextarea.setSelection(newCurrentTextarea.val().length, newCurrentTextarea.val().length);

		VirtualKeyboard.createWordSuggestionRefsAsNeeded();

		setTimeout(function() {
			$("#wrapperTableInnerDiv").scrollTop(9999999);
		}, 50);
	}
};



p.getCurrentMobileEditorTextarea=function() {
	if (MessengerMgr.isVirtualKbModeEnabled()) {
		return $("#msgCompose_mobileVkb");
	}
	else {
		return $("#msgCompose_mobile");
	}
};




p.focusEditor=function() {
	if (window.mobileApp && !MessengerMgr.isVirtualKbModeEnabled()) {
		$("#msgCompose_mobile").focus();
	}
	else if (window.mobileApp && MessengerMgr.isVirtualKbModeEnabled()) {
		// we need to focus the virtual-kb field, but if we focus it without first making it read-only, the
		// system keyboard will open.  So:
		var textareaJqRef=$("#msgCompose_mobileVkb");
		textareaJqRef.prop("readonly", true);
		//console.info("textarea set to readonly=true...");
		textareaJqRef[0].focus();
		//console.info("textarea focused...");
		// if we don't do this, the cursor (caret) will never show again:
		textareaJqRef.prop("readonly", false);
		//console.info("textarea set to readonly=false...");
	}
	else {
		try {
			CKEDITOR.instances.msgCompose.focus();
		}
		catch (e) {
			$(MessengerMgr.CKEDITOR_CSS_SELECTOR).focus();
		}
	}	
};

p.checkDirtyEditor=function() {
	if (window.mobileApp) {
		return (MessengerMgr.getCurrentMobileEditorTextarea().val()!=MessengerMgr._plaintextEditorCleanContents);
	}
	else {
		return CKEDITOR.instances.msgCompose.checkDirty();
	}	
};

p.resetDirtyEditor=function() {
	if (window.mobileApp) {
		MessengerMgr._plaintextEditorCleanContents=MessengerMgr.getCurrentMobileEditorTextarea().val();
	}
	else {
		CKEDITOR.instances.msgCompose.resetDirty();
	}
};

p.encodeEditorData=function(txt) {
	return txt;
	//return $.encoder.encodeForHTML(txt);
}

p.setEditorData=function(txt) {
	txt=MessengerMgr.encodeEditorData(txt);
	if (window.mobileApp) {
		MessengerMgr._plaintextEditorCleanContents=txt;
		MessengerMgr.getCurrentMobileEditorTextarea().val(txt);
	}
	else {
		CKEDITOR.instances.msgCompose.setData(txt);
	}
};

p.isEditorEmpty=function() {
	if (mobileApp) {
		var s=MessengerMgr._plaintextEditorCleanContents.trim();
		//console.info("in isEditorEmpty(), s='"+s+"'");
		return s.length==0;
	}
	else {
		var editorVal=CKEDITOR.instances.msgCompose.getSnapshot().trim();
		return (editorVal=="<p></p>" || editorVal=="");
	}
};

p.getEditorData=function() {
	if (window.mobileApp) {
		var s=MessengerMgr.encodeEditorData(MessengerMgr._plaintextEditorCleanContents);
		// while we need to do more cleanup server-side, we disallow any html chars that might have come out
		// of this textarea, and also fix stuff like multiple spaces and linebreaks
		s=s.replace(/\&/g, "&amp;");
		s=s.replace(/\</g, "&lt;");
		s=s.replace(/\>/g, "&gt;");
		s=s.replace(/\"/g, "&quot;");
		s=s.replace(/\'/g, "&apos;");
		s=s.replace(/\\/g, "&#92;");
		s=s.replace(/  /g, "&nbsp; ");
		s=s.replace(/\r\n/g, "\n");
		s=s.replace(/\n/g, "<br />");
		return s;
	}
	else {
		return MessengerMgr.encodeEditorData(CKEDITOR.instances.msgCompose.getData());
	}
};

p.plaintextEditorContentsChange=function(contents) {
	MessengerMgr._plaintextEditorCleanContents=contents;
};



p.setNamesForStatusMsgs=function(loggedInUserName, correspondentName) {
	// for launch, we don't do this:
	if (mobileApp) {
		return;
	}
	try {
		if (correspondentName==UiMgr.unregisteredSecondUserNicknameToken) {
			correspondentName=UiMgr.unregisteredConfidantIdentifier;
		}
		for (var i=0; i<MessengerMgr.correspondentStatusMessageSpanIds.length; i++) {
			$("#"+MessengerMgr.correspondentStatusMessageSpanIds[i]+" #loggedInUserScreenName").html(loggedInUserName);
			$("#"+MessengerMgr.correspondentStatusMessageSpanIds[i]+" #otherUserScreenName").html(correspondentName);
		}
		$("#correspondentStatusMessage").show();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};


p.sendClick=function() {
	MessengerMgr.transmitMessage();
	// hack-focus the editor without triggering the OS kb to open:
	VirtualKeyboard.forceCaretFocusHack(true);
};

/**
 *Returns true if a message was sent, false otherwise. 
 */
p.transmitMessage=function() {
	try {
		var txt=MessengerMgr.getEditorData();
		if (txt.trim()==0) {
			return false;
		}
		var txtLn=txt.length;
		var txtLnKb=parseInt(txtLn/1024)+1;
		if (txtLnKb>MessengerMgr.maxMessageLengthKb) {
			DialogMgr.alert("Your message is too long ("+txtLnKb+"K); the limit is "+MessengerMgr.maxMessageLengthKb+"K. You may want to break up your message into two or more messages.");
			return false;
		}
	
		// make sure that the message itself doesn't contain tokens in our message template:
		while (txt.indexOf("__TX")>-1) {
			txt=txt.replace(/\_\_TX/g, "_TX");
		}
		
		var now=new Date();
	
		MessengerMgr.addMessageToHistory(txt, now, TunnelMgr.getCurrentTunnelAttribute("currentUserName"), "cts"+now.getTime(), MessengerMgr.USER_TYPE_LOCAL, true, CommMgr.getControlServer(), MessengerMgr.currentMessageType);
		
		if (mobileApp && MessengerMgr.isVirtualKbModeEnabled()) {
			VirtualKeyboard.clearWordSuggestionHistory();
		}
		var response=null;
		var data={};
		data.m=txt.trim();
		data.timeMillis=now.getTime();
		data.suc=false;
		data.messageType=MessengerMgr.currentMessageType;
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.TRANSMIT_MESSAGE, data, false);
		if (typeof response.success=="undefined" || response.success!=true) {
			throw new Error("Couldn't send message: "+response.errorMsg);
		}
		if (mobileApp) {
			$("#wrapperTableInnerDiv").scrollTop(9999999); 
			
		}
		return true;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.addSystemMessage=function(txt) {
	try {
		var now=new Date();
		MessengerMgr.addMessageToHistory(txt, now, TunnelMgr.getCurrentTunnelAttribute("currentUserName"), "cts"+now.getTime(), MessengerMgr.USER_TYPE_SYSTEM, false, CommMgr.getControlServer(), "standard");
		var response=null;
		var data={};
		data.m=txt.trim();
		data.timeMillis=now.getTime();
		data.suc=true;
		data.messageType=MessengerMgr.currentMessageType;
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.TRANSMIT_MESSAGE, data, false);
		if (typeof response.success=="undefined" || response.success!=true) {
			throw new Error("Couldn't send message: "+response.errorMsg);
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};

p.resetEditorUi=function() {
	try {
		MessengerMgr.setEditorData("");
		$("#conversationHistory").html("&nbsp;");
		$("#proClientNotes").html("&nbsp;");
		if (window.professionalSite) {	
			UiMgr.setProMessengerUiPerComponentId("messages");
		}
		MessengerMgr.resetDirtyEditor();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.msgComposeLabelClick=function(elementId) {
	if (mobileApp) {
		if (!MessengerMgr.isVirtualKbModeEnabled()) {
			MessengerMgr.getCurrentMobileEditorTextarea()[0].focus();
			//console.info("in msgComposeLabelClick(), calling showOrHideMsgComposeLabel(false)...");
			MessengerMgr.showOrHideMsgComposeLabel(false);
		}
		else {
			MessengerMgr.plaintextEditorVirtualKbOverlayFocusEvent();
		}		
	}
	else {
		$("#msgCompose").focus();
	}
};

p.showOrHideMsgComposeLabel=function(doInTimeout) {
	if (doInTimeout) {
		setTimeout(MessengerMgr._doShowOrHideMsgComposeLabel, 50);
	}
	else {
		MessengerMgr._doShowOrHideMsgComposeLabel();
	}
};

p._doShowOrHideMsgComposeLabel=function() {
	if (mobileApp && MessengerMgr.isVirtualKbModeEnabled()) {
		// ...then the visibility of this label is dependent purely on whether the virtual kb is
		// visible and if the textarea is empty
		var showLabel=true;
		
		if (VirtualKeyboard.isKbVisible() || !MessengerMgr.isEditorEmpty()) {
			showLabel=false;
		}
		MessengerMgr.getMessageComposeLabelJqObj()[showLabel?"show":"hide"]();	
		
	}
	else {
		var value;
		if (mobileApp) {
			value=MessengerMgr.getCurrentMobileEditorTextarea().val();
		}
		else {
			value=$("#msgCompose").val().trim();
		}
		var showOrHide=(value.length>0?"hide":"show");
		//console.info("in _doShowOrHideMsgComposeLabel(), value="+value+" and value.length="+value.length+" and showOrHide="+showOrHide);
		MessengerMgr.getMessageComposeLabelJqObj()[showOrHide]();	
		//console.info("MessengerMgr.getMessageComposeLabelJqObj()[0].id="+MessengerMgr.getMessageComposeLabelJqObj()[0].id);
	}
};



p.getMessageComposeLabelJqObj=function() {
	if (MessengerMgr.messageComposeLabelJqObj==null) {
		MessengerMgr.messageComposeLabelJqObj=$("#msgComposeLabel");
	}
	return MessengerMgr.messageComposeLabelJqObj;
};

p.resetComposePane=function() {
	var resetComposePaneFn=function() {
		MessengerMgr.setEditorData("");
		if (mobileApp) {
			MessengerMgr.getCurrentMobileEditorTextarea().val("");
		}
		else {
			$("#msgCompose").val("");
		}
		if (!MessengerMgr.isVirtualKbModeEnabled()) {
			MessengerMgr.showOrHideMsgComposeLabel(false);
		}
	};
	
	MessengerMgr.resetDirtyEditor();
	//this sucks, but we have to check to make sure the compose pane is indeed cleared:
	setTimeout(function(){
		resetComposePaneFn();
	}, 100);
};


p.ckEditorKeyEvent=function(eventInfo) { // eventInfo is an instance of CKEDITOR.eventInfo.
	try {
		if((""+UiMgr.acctPrefs.sendMessageOnEnterAcctPref)=="true") {
			if((""+eventInfo.data.keyCode)==13) {
				// [Enter] key was pressed and we are in send-on-enter mode:
				MessengerMgr.transmitMessage();
				eventInfo.cancel();
				eventInfo.stop();
				// Firefox fix:
				setTimeout(function() {MessengerMgr.resetComposePane();}, 10);
				
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.plaintextEditorKeyEvent=function(keyupEvent) { // keyupEvent is a jquery Event object
	try {
		if(window.mobileApp || ((""+UiMgr.acctPrefs.sendMessageOnEnterAcctPref)=="true")) {
			if(keyupEvent.which==13) {
				// [Enter] key was pressed and we are in send-on-enter mode:
				MessengerMgr.transmitMessage();
				keyupEvent.preventDefault();
				keyupEvent.stopImmediatePropagation();
				keyupEvent.stopPropagation();
				
				// Firefox fix:
				setTimeout(function() {MessengerMgr.resetComposePane();}, 100);
				
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
	MessengerMgr.showOrHideMsgComposeLabel(false);
};






p.messageDateFormat=function(dateMillis) {
	try {
		var dt=new Date(dateMillis);
		var paddedMins=""+dt.getMinutes();
		if (paddedMins.length==1) {
			paddedMins="0"+paddedMins;
		}
		var amPm=(dt.getHours()>11)?"pm":"am";
		var hour;
		if (dt.getHours()==0) {
			hour=12;
		}
		else if (dt.getHours()>12) {
			hour=dt.getHours()-12;
		}
		else {
			hour=dt.getHours();
		}
		var s;
		if (!window.mobileApp) {
			s=MessengerMgr.MONTH_NAMES[dt.getMonth()]+" "
				+dt.getDate()+", "
				+dt.getFullYear()+", "
				+hour+":"
				+paddedMins+" "
				+amPm
			;			
		}
		else {
			var dateStr;
			var now=new Date();

			var isToday=(now.getFullYear()==dt.getFullYear() && now.getMonth()==dt.getMonth() && now.getDate()==dt.getDate());
			if (isToday) {
				dateStr="today";
			}
			else {
				dateStr=(dt.getMonth()+1)+"/"+dt.getDate()+"/"+(""+dt.getFullYear()).substring(2);
			}
			s=dateStr+", "+hour+":"+paddedMins+amPm;			
		}
		return s;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.doForcedLogout=function(inactivityForcedLogoutByClient, msg) {
	try {
		if (typeof inactivityForcedLogoutByClient=="undefined") {
			inactivityForcedLogoutByClient=true;
		}
		if (typeof msg=="undefined") {
			msg=null;
		}
		//console.info("in MessengerMgr.doForcedLogout(), inactivityForcedLogoutByClient="+inactivityForcedLogoutByClient+" and msg="+msg);
		UiMgr.logout(true, true, !inactivityForcedLogoutByClient, msg, inactivityForcedLogoutByClient, true);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};



p.doUpdateCheckSuccess=function(response) {
	var debugResponseAcctNotFoundForSession="[not-found]";
	try {
		debugResponseAcctNotFoundForSession=response.acctNotFoundForSession;
	}
	catch (e) {}
	//console.info("in doUpdateCheckSuccess() response="+response+" and debugResponseAcctNotFoundForSession="+debugResponseAcctNotFoundForSession);
	if (CommMgr.sessionExistsOnServerCheck(response)) { // if this returns false (which happens when there WAS a response but the session ids we sent were not recognized, presumably because of a timeout or server restart), the user is told in an alert that they have to sign on again, then taken to homepage (or PIN page for mobile)
		try {
			//console.info("calling setCurrentSessionDataFromResponse() from doUpdateCheckSuccess()...");
			var responseReceived=CommMgr.setCurrentSessionDataFromResponse(response); // required for any AJAX callback function

			//UiMgr.debugUpdaterRequestsCount.mainUpdater++;
			// UiMgr.updateDebugPaneForUpdaters();
			if (responseReceived && response.success) {
				UiMgr.lastUpdateResponseTime=new Date().getTime();
				if (typeof response.flo!="undefined" && response.flo!=null && response.flo) {
					MessengerMgr.doForcedLogout(false, response.flm);
					// get outta here; we're done processing this update since we're now logged out:
					return;
				}
				var correspondentOnline=(response.o==1); // boolean value, but in 0/1 notation for compactness
				var correspondentEventCodes=response.e;
				var waitingMessageIdsArr=response.m;
				var alertMessagesArr=response.a;
				var deletedMessageIdPairsArr=response.d; // array within an array; first inner el is sid, second is cts
				var uploadData=response.u;
				
				var alertMessages=null;
				if (alertMessagesArr!=null && alertMessagesArr.length>0) {
					alertMessages="";
					for (var i=0; i<alertMessagesArr.length; i++) {
						if (i>0) {
							alertMessages+="<br/><br/>";
						}
						alertMessages+=alertMessagesArr[i];
					}
					DialogMgr.alert(alertMessages);
				}
				
				if (correspondentEventCodes.length==0) {
					// No new activity reported for corresp, so just note if they are online or offline --
					if (correspondentOnline) {
						MessengerMgr.setCorrespondentActivity("correspondentOnline");
					}
					else {
						if (TunnelMgr.getUnparsedCurrentConfidantName()==UiMgr.unregisteredSecondUserNicknameToken) {
							MessengerMgr.setCorrespondentActivity("correspondentOfflineNeverOnline");
						}
						else {
							MessengerMgr.setCorrespondentActivity("correspondentOffline");
						}				
					}
				}
				else {
					// else the "e" attr contains at least one event code (a char) indicating new action by the corresp;
					// codes are as follows: i=corresp logged in; o=corresp logged out; t=corresp typing; u=corresp uploading
					// a file; d=corresp deleted all messages (so we have to too).  Some of these events take priority over 
					// others, and we report them in two different ways in the corresp-status bar, or in the message window 
					// in the case of a logon/off):
					if (correspondentEventCodes.indexOf('t')>-1) {
						MessengerMgr.setCorrespondentActivity("correspondentTyping");
					}
					else if (correspondentEventCodes.indexOf('u')>-1) {
						MessengerMgr.setCorrespondentActivity("correspondentUploading");
					}
					else if (correspondentEventCodes.indexOf('x')>-1) {
						UiMgr.expressLogout(); // game over: the other user destroyed the tunnel.
					}
					if (correspondentEventCodes.indexOf('i')>-1) {
						// no, we need to do this at the server level:
						//MessengerMgr.addSystemMessage("The other user logged on.");
					}
					else if (correspondentEventCodes.indexOf('o')>-1) {
						// no, we need to do this at the server level:
						//MessengerMgr.addSystemMessage("The other user logged off.");
					}
					if (correspondentEventCodes.indexOf('d')>-1) {
						$("#conversationHistory").html("&nbsp;");
						MessengerMgr.setCorrespondentActivity("correspondentDeletedAll");
					}
				}
				// now, regardless of any of the above, if there are new messages, we need to collect them, so:
				if (waitingMessageIdsArr.length>0) {
					var msgIdsList="";
					for (var i=0; i<waitingMessageIdsArr.length; i++) {
						if (MessengerMgr.retrievedCorrespondentMessageIds.indexOf(waitingMessageIdsArr[i])>-1) {
							// We shouldn't get here, but this guards against retrieving/showing the same message twice (e.g. at startup and then as a realtime message):
							continue;
						}
						if (msgIdsList.length>0) {
							msgIdsList+=",";
						}
						msgIdsList+=waitingMessageIdsArr[i];
					}
					setTimeout("MessengerMgr.retrieveNewMessages(\""+msgIdsList+"\")", 0);
				}
				if (deletedMessageIdPairsArr.length>0) {
					for (var i=0; i<deletedMessageIdPairsArr.length; i++) {
						MessengerMgr.removeMessageFromHistoryUi(deletedMessageIdPairsArr[i][0], deletedMessageIdPairsArr[i][1]);
					}
				}
				
				// deal with uploadData, which populates the status area next to the "upload media" button:
				MessengerMgr.updateUploadDataStatusUI(uploadData);
			}
		}
		catch (__ee) {
			alertJavaScriptErrorIfConfigured(__ee); throw _ee;
		}
		finally {
			MessengerMgr.doUpdateChecks=true;
			clearTimeout(MessengerMgr.updateCheckTimeout);
			MessengerMgr.updateCheckTimeout=setTimeout(MessengerMgr.doUpdateCheck, MessengerMgr.standardUpdateCheckIntervalMillis);
		}	
	}		
};



p.doUpdateCheckFailure=function(response, textStatus, errorThrown) {
	var debugResponseAcctNotFoundForSession="[not-found]";
	try {
		debugResponseAcctNotFoundForSession=response.acctNotFoundForSession;
	}
	catch (e) {}
	//console.info("in doUpdateCheckFailure() response="+response+" and debugResponseAcctNotFoundForSession="+debugResponseAcctNotFoundForSession);

	if (CommMgr.sessionExistsOnServerCheck(response)) { // if this returns false (which happens when there WAS a response but the session ids we sent were not recognized, presumably because of a timeout or server restart), the user is told in an alert that they have to sign on again, then taken to homepage (or PIN page for mobile)
		//console.info("in doUpdateCheckFailure(), response.acctNotFoundForSession is false...");
		CommMgr.ajaxGlobalErrorCallback(response, textStatus, errorThrown);
		// likely we lost our internet connection; we'll just try again:
		clearTimeout(MessengerMgr.updateCheckTimeout);
		MessengerMgr.doUpdateChecks=true;
		MessengerMgr.updateCheckTimeout=setTimeout(MessengerMgr.doUpdateCheck, MessengerMgr.standardUpdateCheckIntervalMillis);
	}
};

p.uploadMediaClick=function() {
	try {
		//DialogMgr.alert("MessengerMgr.uploadsInProgress="+MessengerMgr.uploadsInProgress+"; UiMgr.maxConcurrentUploads="+UiMgr.maxConcurrentUploads);
		if (MessengerMgr.uploadsInProgress>=UiMgr.maxConcurrentUploads) {
			DialogMgr.alert("Sorry, only "+UiMgr.maxConcurrentUploads+" upload"+(UiMgr.maxConcurrentUploads>1?"s":"")+" allowed at a time.");
		}
		else {
			//throw new Error("we aren't using ImageKeyUploader for uploading media anymore; fix this.");
			//ImageKeyUploader.currentFileUploadOnchangeUiMgrFunctionName='hiddenUploadMediaChanged';
			//ImageKeyUploader.autoclickFileUploadBoxWithErrorTimeout();
			MediaUploader.openFileChooser();
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.doUpdateCheck=function(forceMobileUpdateCheck) {
	forceMobileUpdateCheck=(typeof forceMobileUpdateCheck=="undefined"?false:forceMobileUpdateCheck);
	try {
		if (MessengerMgr.doUpdateChecks) {
			if (forceMobileUpdateCheck || !window.mobileApp) {
				var map={};
				map.t=MessengerMgr.checkDirtyEditor(); // t=typing -- we pass true if editor has changed since last update, e.g. if the user has typed since then
				MessengerMgr.resetDirtyEditor();
				CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CHECK_FOR_UPDATES, map, true, MessengerMgr.doUpdateCheckSuccess, MessengerMgr.doUpdateCheckFailure, 120000);
			}
			else {
				// we're being an app.  Ther is no sense in initiating an update request if we know we're not online, which is knowable
				// since we're an app.  So: 
				if (CommMgr.clientIsOnline()) {
					MessengerMgr.doUpdateCheck(true); // call this function again, but with a true param that will force us to do the update
				}
				else {
					// schedule another update in a bit --
					var intervalMillis=MessengerMgr.standardUpdateCheckIntervalMillis*5; // multiply by 5 because we're offline
					// if we're also not foregrounded, multiply by another 3:
					if (mobileApp && MobileDevice.isPaused()) {
						intervalMillis*=3;
					}
					MessengerMgr.doUpdateChecks=true;
					clearTimeout(MessengerMgr.updateCheckTimeout);
					MessengerMgr.updateCheckTimeout=setTimeout(MessengerMgr.doUpdateCheck, intervalMillis);
				}
			}
		}	
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.updateUploadDataStatusUI=function(uploadData, staticMessage) {
	try {
		if (typeof staticMessage=="undefined") {
			staticMessage=null;
		}
		
		if (uploadData!=null) {
			MessengerMgr.uploadsInProgress=uploadData.uploadsCount;
		}
		
		if (uploadData!=null && uploadData.uploadsCount==0) {
			// uploadsCount=uploads in progress; if there are none, all we have to do is hide the status UI element if it's visible:
			$("#uploadStatusArea").hide();
		}
		else {
			$("#uploadStatusArea").show();
			var uploadStatusMsg="";
			if (uploadData!=null) {
				uploadStatusMsg="Uploading/encrypting "+(window.mobileApp?"file":uploadData.fl)+"";
				var uploadedKb=parseInt(""+(uploadData.bytesSoFar/1024));
				// Not reporting percentages right now for mobile because something's wrong with the logic that populates
				// (i think) uploadData.fileSizeWasReportedByClient for mobile (which handles file uploads differently
				// from desktop version), so --
				//if (uploadData.fileSizeWasReportedByClient) {
				if (!mobileApp && uploadData.fileSizeWasReportedByClient) {
					var totalKb=parseInt(""+(uploadData.totalBytesComing/1024));
					if (!window.mobileApp) {
						uploadStatusMsg+=", ("+uploadedKb+" of "+totalKb+" KB, "+parseInt(""+uploadData.pctComplete)+"%)";					
					}
					else {
						uploadStatusMsg+=", "+parseInt(""+uploadData.pctComplete)+"% complete...";					
					}
				}
				else {
					uploadStatusMsg+=" ("+uploadedKb+" KB so far)";
				}
			}
			else {
				uploadStatusMsg=staticMessage;
			}
			$("#uploadStatusArea").show();
			$("#uploadStatusArea").html(uploadStatusMsg);
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};



p.setCorrespondentActivity=function(correspondentStatusMessageSpanId) {
	// for launch, we don't do this:
	if (1!=2) {
		return;
	}

	try {
		if (correspondentStatusMessageSpanId!=MessengerMgr.currentCorrespondentStatusMessageSpanId) {
			for (var i=0; i<MessengerMgr.correspondentStatusMessageSpanIds.length; i++) {
				if (MessengerMgr.currentCorrespondentStatusMessageSpanId==MessengerMgr.correspondentStatusMessageSpanIds[i]) {
					$("#"+MessengerMgr.correspondentStatusMessageSpanIds[i]).hide();
				}
				else if (correspondentStatusMessageSpanId==MessengerMgr.correspondentStatusMessageSpanIds[i]) {
					$("#"+MessengerMgr.correspondentStatusMessageSpanIds[i]).show();
				}
			}
			MessengerMgr.currentCorrespondentStatusMessageSpanId=correspondentStatusMessageSpanId;
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};




p.retrieveNewMessages=function(commaDelimMsgIds) {
	try {
		var map={};
		map.m=commaDelimMsgIds;
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.RETRIEVE_CORRESPONDENT_MESSAGES, map, false);
		if (response.success) {
			var messages=response.ms;
			for (var i=0; i<messages.length; i++) {
				var id=messages[i].i;
				var currentUserComposed=messages[i].ruc; // true if this user composed this, false if correspondent did.
				var clientTimestamp=messages[i].ccm; // time in millis this message was created per the authoring user's web client
				var serverTimestamp=messages[i].scm; // time in millis this message was created per the server that processed the message's transmission
				var messageText=messages[i].mt; // content of message
				var systemUserMessage=messages[i].suc; // true if message "composed" by system user
				var messageType=messages[i].messageType; // "standard" or "pro-note"
				
				var userIdentifier;
				var userType;
				if (currentUserComposed) { // this will be the case if we have a system message which should appear as if it were composed by the locak user, e.g. when a media file has completed uploading.
					userIdentifier=TunnelMgr.getCurrentTunnelAttribute("currentUserName");
					userType=MessengerMgr.USER_TYPE_LOCAL;
				}
				else if (systemUserMessage) {
					userIdentifier="Tunnel X";
					userType=MessengerMgr.USER_TYPE_SYSTEM;
				}
				else {
					userIdentifier=TunnelMgr.getParsedCurrentConfidantName();	
					userType=MessengerMgr.USER_TYPE_CORRESPONDENT;			
				}
	
				MessengerMgr.addMessageToHistory(messageText, new Date(serverTimestamp), userIdentifier, "sid"+id, userType, false, CommMgr.getControlServer(), messageType);
			}
		}
		if (!UiMgr.windowHasFocus) {
			UiMgr.startToggleTitle();
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.loadConversationHistory=function() {
	try {
		// Note: this request is synchronous, and not in a timeout, because it needs to do its thing
		// before the user can start using the client.  Timeout is set higher than normal because
		// large histories may take a while to load.  May want to consider making this async later,
		// which would among other things allow users to cancel loading the history.  We may also want
		// to limit the size of the history loaded.
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOAD_CONVERSATION_HISTORY, {}, false);
		if (!response.success) {
			throw new Error(response.errorMsg);
		}
		
		var confidantName=TunnelMgr.getTunnelAttribute(TunnelMgr.currentClientSessionTunnelId, "confidantName");
		if (typeof confidantName=="undefined" || confidantName==null || confidantName==UiMgr.unregisteredSecondUserNicknameToken) {
			confidantName=UiMgr.unregisteredConfidantIdentifier;
		}

		MessengerMgr.currentConfidantName=confidantName;
		var messages=response.ms;
		for (var i=0; i<messages.length; i++) {
			var id=messages[i].i;
			var currentUserComposed=messages[i].ruc; // true if this user composed this, false if correspondent did.
			var clientTimestamp=messages[i].ccm; // time in millis this message was created per the authoring user's web client
			var serverTimestamp=messages[i].scm; // time in millis this message was created per the server that processed the message's transmission
			var messageText=messages[i].mt; // content of message
			var systemUserMessage=messages[i].suc; // true if message "composed" by system user
			var messageType=messages[i].messageType; // "standard" or "pro-note"
			var userType=null;
			var authorIdentifier=null;
			if (systemUserMessage) {
				userType=MessengerMgr.USER_TYPE_SYSTEM;
				authorIdentifier="Tunnel X";
			}
			else if (currentUserComposed) {
				userType=MessengerMgr.USER_TYPE_LOCAL;
				authorIdentifier=TunnelMgr.getCurrentTunnelAttribute("currentUserName");
			}
			else {
				userType=MessengerMgr.USER_TYPE_CORRESPONDENT;
				//authorIdentifier=TunnelMgr.getUnparsedCurrentConfidantName();
				authorIdentifier=MessengerMgr.currentConfidantName;
				// wallpapering over a bug here; this is ugly:
				if (typeof authorIdentifier=="undefined" || authorIdentifier==null) {
					authorIdentifier=MessengerMgr.currentConfidantName;
				}


			}
			if (typeof userType=="undefined" || userType==null) {
				throw new Error("userType could not be determined.");
			}
			if (typeof authorIdentifier=="undefined" || authorIdentifier==null) {
				if (userType==MessengerMgr.USER_TYPE_LOCAL) {
					authorIdentifier="You";					
				}
				else if (userType==MessengerMgr.USER_TYPE_CORRESPONDENT) {
					authorIdentifier="Your Confidant";					
				}
				else { // system user:
					authorIdentifier="Tunnel X";					
				}
			}
			MessengerMgr.addMessageToHistory(messageText, new Date(serverTimestamp), authorIdentifier, "sid"+id, userType, false, CommMgr.getControlServer(), messageType);
		}
		if (mobileApp) {
			MessengerMgr.getCurrentMobileEditorTextarea()[0].blur();
		}
		else {
			$("#msgCompose").blur();
		}
		
		setTimeout(function(){
			MessengerMgr.focusEditor();
		}, 100);
		;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.addMessageToHistory=function(txt, composeDate, composerUserIdentifier, msgId, userType, clearAndFocusEditor, server, messageType) {
	try {
		if (typeof server=="messageType") {
			throw new Error("not enough args; see addMessageToHistory() sig for details.");
		}

		var serverSessionId=server.sessionId;
		if (($("#"+msgId).length>0)) {
			// somehow we've already got this message in the history, so:
			return;
		}

		var msgDivHtml;
		if (messageType=="standard") {
			msgDivHtml=$("#messageTemplate").html();
		}
		else {
			msgDivHtml=$("#messageTemplatePatientNotes").html();
		}
		
		
		msgDivHtml=msgDivHtml.replace(/\_\_TXMSGID\_\_/g, msgId);
		msgDivHtml=msgDivHtml.replace(/\_\_TXDATE\_\_/g, MessengerMgr.messageDateFormat(composeDate.getTime()));
		var composerUser;
		var msgBgColorHex;
		var msgFontColorHex;
		if (userType==MessengerMgr.USER_TYPE_LOCAL) {
			composerUser="You";
			if (!window.mobileApp && !(typeof (TunnelMgr.getCurrentTunnelAttribute("currentUserName"))=="undefined")) {
				composerUser+=" ("+TunnelMgr.getCurrentTunnelAttribute("currentUserName")+")";
			}
			msgBgColorHex="ffffff";
			msgFontColorHex="808080";
		}
		else if (userType==MessengerMgr.USER_TYPE_CORRESPONDENT) {
			composerUser=composerUserIdentifier;
			msgBgColorHex="ffffff";
			msgFontColorHex="111111";
		}
		else if (userType==MessengerMgr.USER_TYPE_SYSTEM) {
			composerUser="Tunnel X";
			msgBgColorHex="fce6bb";
			msgFontColorHex="808080";
		}
		else {
			throw new Error("unrecognized userType: "+userType);
		}
		
		if (typeof composerUser=="undefined" || composerUser==null || composerUser==UiMgr.unregisteredSecondUserNicknameToken) {
			composerUser=UiMgr.unregisteredConfidantIdentifier;
		}
		
		// *** Handle two types of URLs (img src's / hrefs) -- note that they will sometimes exist in the same tunnel:
		// handle old-style URLs (not generated after Jan 2013):
		txt=txt.replace(/\?\_s\=\_\_SIT\_\_/g, ";"+UiMgr.sessionPathParamName+"="+serverSessionId+"?dp=true"); // dp is another dummy param; it's a hack to make the replace() we do here work retroactively with these old-style URLs (otherwise we end up with ...?&x=y ype stuff)
		// handle new-style URLs (post-Jan 2013; _dParam is not used; it just tells us that the preceding "?" was the beginning of the URL; a bit ugly):
		txt=txt.replace(/\?\_dParam\=true/g, ";"+UiMgr.sessionPathParamName+"="+serverSessionId+"?"); 
		msgDivHtml=msgDivHtml.replace(/\_\_TXAUTHOR\_\_/g, composerUser);
		msgDivHtml=msgDivHtml.replace(/\_\_TXBGCOLOR\_\_/g, "#"+msgBgColorHex);
		msgDivHtml=msgDivHtml.replace(/\_\_TXFONTCOLOR\_\_/g, "#"+msgFontColorHex);
		
		var messageContent;
		// now we need to determine if we're dealing with a txt value that we should display as-is, or a <cp> value, so:
		if (txt.indexOf("<cp ")!=0) {
			// message doesn't start with "<cp ", so it's a normal message, which means we do nothing, unless there's no <p> surrounding the text (as with mobile msgs), in which case we add them:
			if (!txt.startsWith("<p") && !txt.trim().endsWith("</p>")) {
				txt="<p>"+txt+"</p>";
			}
			messageContent=txt;
		}
		else {
			// else it's a CP message, and right now, there's only one kind of CP message, the one that starts
			// with, exactly, '<cp type=\"uploadedmedia\" value=\"' and ends with '" />', so our job is easy:
			var cpMessageType="uploadedmedia";
			var openingSeq="<cp type=\""+cpMessageType+"\" value=\"";
			var clientParsedTxt=txt.substring(openingSeq.length, txt.lastIndexOf("\" />"));
			switch (cpMessageType) {
				case "uploadedmedia": {
					// we now have a string in the format of a query string: name/value pairs for us to extract, so:
					var nvPairs=clientParsedTxt.split("&");
					var paramsMap={};
					for (var i=0; i<nvPairs.length; i++) {
						if (nvPairs[i].indexOf("=")==-1) {
							continue;
						}
						var nameAndValue=nvPairs[i].split("=");
						paramsMap[nameAndValue[0]]=Core.urldecode(nameAndValue[1]);
					}
					var mediaUrl=paramsMap.mediaUrl;
					var hasThumb=(paramsMap.hasThumb=="true");
					var originalFilename=paramsMap.originalFilename;
					var sizeBytes=parseInt(paramsMap.sizeBytes);
					
					var thumbUrl=null;
					var thumbHeightPx=0;
					var thumbWidthPx=0;
					if (hasThumb) {
						thumbUrl=paramsMap.thumbUrl;
						thumbHeightPx=parseInt(paramsMap.thumbHeightPx);
						thumbWidthPx=parseInt(paramsMap.thumbWidthPx);
					}
					if (window.mobileApp) {
						// scale the thumbs
						var scaleFactor=298/600; // native max width/height for thumb images is 600
						thumbHeightPx=parseInt(thumbHeightPx*scaleFactor);
						thumbWidthPx=parseInt(thumbWidthPx*scaleFactor);
					}
					var fileSize;
					if (sizeBytes<=0) {
						fileSize="unknown size";
					}
					else {
						var sizeKB=parseInt(Math.floor(sizeBytes/1024));
						if (sizeKB==0) {
							sizeKB=1;
						}
						if (sizeKB<1024) {
							fileSize=sizeKB+"KB";
						}
						else {
							fileSize=Math.ceil(sizeKB/(1024/10))/10+"MB"; // force one decimal place
						}
					}
					// now we've got all data we need to create some simple html, which differs if the media is an image (since
					// we show a thumbnail in that case):
					messageContent="";
					
					var maxFilenameLength=(window.mobileApp?28:65);
					var truncatedFilename=new String(originalFilename);
					if (truncatedFilename.length>maxFilenameLength) {
						truncatedFilename=truncatedFilename.substring(0, maxFilenameLength)+"...";
					}
					if (window.mobileApp) {
						// tell the server we're a mobile app; also pass the mobileMultiSessionClientIdentifier this way (for now, anyway) since we can't do cookies in the app:
						// also, since we're passing this on the qstring, we have to convert "+" to encoded; otherwise the server will see as a space char, so:
						var mmscid=UiMgr.mobileMultiSessionClientIdentifier.replace(/\+/g, "%2B");
						mediaUrl+="&"+window.mobileAppBooleanParamName+"=true&mobileMultiSessionClientIdentifier="+mmscid;
						thumbUrl+="&"+window.mobileAppBooleanParamName+"=true&mobileMultiSessionClientIdentifier="+mmscid;
					}
	
					var href="";
					var target="";
					var onclick="";
					var warningMessage="Files of this type are potentially dangerous. Only download this file if you trust your confidant completely. Okay to download?";
					var potentiallyMalicious=$.inArray(originalFilename.split('.').pop(), MessengerMgr.maliciousFileExtensions) > -1;
					// we handle links like this differently depending on whether we're a mobile app or not.  If not, we just do the link, with a _blank target.
					// But if we do that in the mobile app, it'll try to launch one of the user's phone's browsers, and that'll go badly, since the user won't 
					// have a session in that browser.  But, we have the InAppBrowser native Phonegap plugin installed, which means that a call to window.open()
					// opens in a browser local to this app.  So, we have to set the above three values differently depending on whether we're an app or not:
					if (mobileApp) {
						href="#";
						target="_self";
						if (potentiallyMalicious) {
							onclick="DialogMgr.confirm('"+warningMessage+"', function() { MessengerMgr.openOrSaveFile('"+mediaUrl+"'); }, null, 'OK', 'Cancel'); return false";
						}
						else {
							onclick="MessengerMgr.openOrSaveFile('"+mediaUrl+"'); return false;";
						}
					}
					else {
						href=mediaUrl;
						target="_blank";
						if (potentiallyMalicious) {
							href="#";
							target="_self";
							onclick="DialogMgr.confirm('"+warningMessage+"', function() { window.open('"+mediaUrl+"', '_blank', 'location=yes'); }, null, 'OK', 'Cancel'); return false";
						}
						else {
							onclick="return true;";
						}
					}
					if (hasThumb) {
						messageContent+="<div class=\"clearfix\">&nbsp;</div><a onclick=\""+onclick+"\" title=\"click to view "+originalFilename+" in a new window\" target=\""+target+"\" href=\""+href+"\" style=\"float:left; display:block; height:"+thumbHeightPx+"px; width:"+thumbWidthPx+"px; margin-top:5px;border:1px solid #000000; color:#000000;\">";
						messageContent+="<img src=\""+thumbUrl+"\" style=\"height:"+thumbHeightPx+"px; width:"+thumbWidthPx+"px; border-width:0px;\" />";
						messageContent+="</a><div class=\"clearfix\">&nbsp;</div>";
					}
					// and now, the download link (only if we DON'T have a thumb):
					var saveIsForced=(mediaUrl.indexOf("&s=true")>-1);
					if (!hasThumb) {
						messageContent+="<b>"+truncatedFilename+" ("+fileSize+")</b> <a onclick=\""+onclick+"\" target=\""+target+"\" href=\""+href+"\"  title=\"click to "+(saveIsForced?"save":"view")+" "+originalFilename+(saveIsForced?"":" in another window")+"\" >(download file)</a><div class=\"clearfix\">&nbsp;</div>";
					}
				}
			}
		}
	
		// *** Handle two types of URLs (img src's / hrefs) -- note that they will sometimes exist in the same tunnel:
		// handle old-style URLs (not generated after Jan 2013):	
		messageContent=messageContent.replace(/\?\_s\=\_\_SIT\_\_/g, ";"+UiMgr.sessionPathParamName+"="+serverSessionId+"?dp=true"); // dp is another dummy param; it's a hack to make the replace() we do here work retroactively with these old-style URLs (otherwise we end up with ...?&x=y ype stuff)
		// handle new-style URLs (post-Jan 2013; _dParam is not used; it just tells us that the preceding "?" was the beginning of the URL; a bit ugly):
		messageContent=messageContent.replace(/\?\_dParam\=true/g, ";"+UiMgr.sessionPathParamName+"="+serverSessionId+"?");	
		msgDivHtml=msgDivHtml.replace(/\_\_TXMSGCONTENT\_\_/g, messageContent);
		
		
		var messageHistoryDiv;
		if (messageType=="standard") {
			messageHistoryDiv=$("#conversationHistory");
		}
		else if (messageType=="pro-note") {
			messageHistoryDiv=$("#proClientNotes");
		}
		else {
			throw new Error("messageType unrecognized ('"+messageType+"')");
		}
		
		messageHistoryDiv.append(msgDivHtml);
		if (window.mobileApp) {
			// Some mobile browsers ignore the .scrollTop() call below; if we also focus thie element, which will be at the bottom of the
			// convo history, then we'll scroll to the bottom even for these disobedient browsers (the focus() call is after the scrollTop() call, below):
			var forcedScrollFocusReceiverElement="<a hidefocus=\"true\" href=\"#\" style=\"height:1px; width:1px; overflow:hidden; display:block;\" onclick=\"return false\" tabindex=\"-1\" id=\"scrollerFocusReceiver"+msgId+"\">&nbsp;</a>";
			messageHistoryDiv.append(forcedScrollFocusReceiverElement);
		}
		messageHistoryDiv.scrollTop(9999999);
		
		if (!window.mobileApp) {
			if (clearAndFocusEditor) {
				MessengerMgr.setEditorData("");
				MessengerMgr.focusEditor();
			}
		}
		else {
			$("#wrapperTableInnerDiv").scrollTop(9999999); // scroll this, since unlike with the desktop version, this is a scrollable area
			$("#scrollerFocusReceiver"+msgId).focus(); // for the browsers which don't scroll when we scrollTop():
			if (clearAndFocusEditor) {
				MessengerMgr.setEditorData("");
				setTimeout(function() {MessengerMgr.focusEditor();}, 50);
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};


p.saveToMobileFilesys=function(url) {
	if (typeof cordova=="undefined") {
		DialogMgr.alert("Can't do save operation from desktop, as the cordova object doesn't exist there.");
		return;
	}
	if (typeof cordova.file=="undefined") {
		DialogMgr.alert("Sorry, can't save that file to your device (cordove.file is undefined).");
		return;
	}
	if (typeof cordova.file.dataDirectory=="undefined") {
		DialogMgr.alert("Sorry, can't save that file to your device (cordova.file.dataDirectory is undefined).");
		return;
	}
	var destDir=cordova.file.dataDirectory; // this is the preferred dir for us; it's also not synced to cloud with iOS
	if (destDir==null) {
		DialogMgr.alert("Sorry, can't save that file to your device (destDir="+destDir+").");
		return;
	}
	else {
		try {
			var fileName=""+url;
			fileName=fileName.substring(fileName.lastIndexOf("/")+1);
			fileName=fileName.substring(0, fileName.indexOf(";"));
			var fileTransfer = new FileTransfer();
			var uri = encodeURI(url);

			fileTransfer.download(
			    uri,
			    destDir+fileName,
			    function(entry) {
			        //console.log("download complete: " + entry.toURL());
			    },
			    function(error) {
			    	DialogMgr.alert("Sorry, can't save that file to your device (error code '"+error.code+"'.");
			    },
			    false, // trustAllHosts param, always false
			    {
			       // headers: {
			       //     "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
			       //}
			    }
			);
		}
		catch (e) {
			DialogMgr.alert("Sorry, can't save that file to your device ('"+e.message+"').");			
		}
	}
};

p.openOrSaveFile=function(url) {
	var errorMsg="Sorry, can't open or save that type of file on your device.";
	var win=null;
	try {
		var lcUrl=url.toLowerCase();
		// because of fkng iOS issues, we are not opening files locally at all for now:
		DialogMgr.alert("The app cannot open or save this file format on this device.");
		/*
		if (lcUrl.indexOf(".jpg;")>-1 || lcUrl.indexOf(".jpeg;")>-1 || lcUrl.indexOf(".gif;")>-1 || lcUrl.indexOf(".png;")>-1 || lcUrl.indexOf(".bmp;")>-1 || lcUrl.indexOf(".svg;")>-1) {
			// open an InAppBrowser, then populate it with document.write:
			win=window.open(null, "_blank", "location=yes,closebuttoncaption=Done");
			win.executeScript({code:"document.open();document.write(\"<html><head></head><body style='margin:0; padding:0;'><img src='"+url+"' width='100%' /></body></html>\");"});
		}
		else if (lcUrl.indexOf(".txt;")>-1 || lcUrl.indexOf(".htm;")>-1 || lcUrl.indexOf(".html;")>-1 || lcUrl.indexOf(".csv;")>-1 || lcUrl.indexOf(".xml;")>-1) {
			// open an InAppBrowser directly:
			win=window.open(url, "_blank", "location=yes,closebuttoncaption=Done");
		}
		else {
			DialogMgr.alert("The app cannot open or save this file format.");
			// else we'll save it, or try to:
			//MessengerMgr.saveToMobileFilesys(url);
		}	
		*/	
	}
	catch (e) {
		try {
			win.close();
		}
		catch (ee) {}
		DialogMgr.alert(errorMsg);
	}
};

p.plaintextEditorBlurEvent=function(elValue) {
	MessengerMgr.plaintextEditorContentsChange(elValue);
	$("#wrapperTableInnerDiv").scrollTop(9999999); // scroll this, since unlike with the desktop version, this is a scrollable area
	MessengerMgr.showOrHideMsgComposeLabel(false);
};

p.plaintextEditorFocusEvent=function(elValue) {
	MessengerMgr.plaintextEditorContentsChange(elValue);
	$("#wrapperTableInnerDiv").scrollTop(9999999); // scroll this, since unlike with the desktop version, this is a scrollable area
};

p.plaintextEditorChangeEvent=function(elValue) {
	MessengerMgr.plaintextEditorContentsChange(elValue);
};




p.plaintextEditorVirtualKbOverlayFocusEvent=function() {
	if (!MessengerMgr.isVirtualKbModeEnabled()) {
		MessengerMgr.showOrHideMsgComposeLabel(false);
	}
	//MessengerMgr.focusEditor();
	VirtualKeyboard.editorOverlayFocusEvent();

};

p.plaintextEditorVirtualKbChangeEvent=function(elValue) {
	MessengerMgr.plaintextEditorContentsChange(elValue);
};









p.deleteMessage=function(msgId) {
	try {
		// msgId starts with either "sid" (server ID, the id of the msg) or "cts" (the client-side taimstamp of this
		// message, which means the current user composed the message, during this session).  Either way, we have to
		// do three things, but we do them differently depending on which type of ID this is: 1) remove from the
		// conversation history; 2) remove from the database; and 3) tell the other user's client to remove the message,
		// if they're online (the server worries about whether they're online or not, of course).  So:
		var idType=msgId.substring(0, 3);
		var numericId=parseInt(msgId.substring(3));
		// regardless of which it is, first we remove the message from this user's client's history:
		MessengerMgr.removeMessageFromHistoryUi(msgId, null);
		var map={};
		map.t=idType;
		map.n=numericId;
		var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.DELETE_MESSAGE, map, false);
		if (!response.success) {
			DialogMgr.alert("There was a problem deleting the message from the server; it may or may not have been deleted.");
		}

	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


/** Removes the specified message from the ui. One or two ids may be passed; if this client originated the delete, then either a "sid" or a "cts" id will be passed as the 
 * first arg and the second will be null.  If the server originated the delete, two ids will be passed (first the sid, then the cts).  Method first tries to remove the message via the id; if that 
 * doesn't work, it removes it via the altId. 
 * @param {String} id Required
 * @param {String} altId Required but may be null
 */
p.removeMessageFromHistoryUi=function(id, altId) {
	if (($("#"+id).length>0)) { // no exists() in jquery; this hack checks for existence:
		$("#"+id).html("");
		$("#"+id).hide(250);
	}
	else if (altId!=null) { // else, if the second arg is non-null, try this:
		$("#"+altId).html("");
		$("#"+altId).hide(250);	
	}	
	if (window.mobileApp) {
		MessengerMgr.removeMessageAutoFocusReceiverElement(id, altId);
	}
};

p.removeMessageAutoFocusReceiverElement=function(id, altId) {
	if (!window.mobileApp) {
		return;
	}
	try {
		if (($("#scrollerFocusReceiver"+id).length>0)) { // no exists() in jquery; this hack checks for existence:
			$("#scrollerFocusReceiver"+id).html("");
			$("#scrollerFocusReceiver"+id).hide();
		}
		else if (altId!=null) { // else, if the second arg is non-null, try this:
			$("#scrollerFocusReceiver"+altId).html("");
			$("#scrollerFocusReceiver"+altId).hide(0);	
		}			
	}
	catch (e) {} // swallow; we may have left a 1px-high element in the UI, which is not the end of the world.
};



p.deleteAllConfirm=function() {
	DialogMgr.confirm("Are you sure that you want to delete all messages in this tunnel? Once they're gone, they're gone.  Okay to proceed?",
		MessengerMgr.deleteAllConfirmTrueCallback, UiMgr.noop, "Yes, delete all messages permanently", "No, cancel!");
};

p.deleteAllConfirmTrueCallback=function() {
	var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.DELETE_ALL_MESSAGES, {}, false);
	if (response.success) {
		$("#conversationHistory").html("&nbsp;");
		DialogMgr.alert("All messages have been permanently deleted.");
	}
};




p.showMessengerUi=function(isInitialShow) {
	try {
		if (mobileApp) {
			VirtualKeyboard.clearWordSuggestionHistory();
		}
		UiMgr.clearAllNonFileUploadFormFields();
		if (typeof isInitialShow=="undefined") {
			isInitialShow=true;
		}
		$("#mainUiTable").show();
		if (window.mobileApp) {
			$("#conversationUiHeader").show();
			UiMgr.toggleMobileFooter(true);
		}
		$("#authPages").hide();
		$("#nonAuthUiPages").hide();
		if (isInitialShow) {
		    console.info("calling resizeWrapperTableInnerDiv() from MessengerMgr.showMesengerUi...");
			UiMgr.resizeWrapperTableInnerDiv(true);
			MessengerMgr.resizeHistoryBoxHeight();
			
			MessengerMgr.resetEditorUi();
			MessengerMgr.loadConversationHistory();
			if (!window.mobileApp) { // need to handle the equiv of this for non-CK (mobile, plaintext) editor
				CKEDITOR.instances.msgCompose.on('key', MessengerMgr.ckEditorKeyEvent);
			}
			else {
				MessengerMgr.getCurrentMobileEditorTextarea().keyup(function(event){MessengerMgr.plaintextEditorKeyEvent(event); return true;});
			}
		}
		if (mobileApp) {
			MessengerMgr.setVirtualKbModeFromAcctPref(UiMgr.acctPrefs.useVirtualKBForMobileAcctPref, false);
		}
		
		if (mobileApp) {
			MessengerMgr.getCurrentMobileEditorTextarea()[0].blur();
		}
		else {
			$("#msgCompose").blur();
		}
		
		setTimeout(function() {
			MessengerMgr.focusEditor();
			MediaUploader.startUseInEditor(); 			
		}, 100);
		
		
		if (window.mobileApp) {
			$("#wrapperTableInnerDiv").scrollTop(9999999); // scroll this, since unlike with the desktop version, this is a scrollable area
		}
		$("#uploadStatusArea").hide();

		
		UiMgr.currentAuthPage=null;
		//if (mobileApp) {
		//	BackbuttonFunctionStack.add(UiMgr.goPreviousScreen);
		//}
		
		// we have to do this on mobile for some godforesaken reason that is yet to be determined:
		if (!MessengerMgr.isVirtualKbModeEnabled()) {
			setTimeout(function() {MessengerMgr.showOrHideMsgComposeLabel(false);}, 200);
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.setVirtualKbModeFromAcctPref=function(useVirtualKBForMobileAcctPref, force) {
	var useVirtualKb=((""+useVirtualKBForMobileAcctPref+"")=="true");
	if (force || MessengerMgr.isVirtualKbModeEnabled()!=useVirtualKb) {
		MessengerMgr.setVirtualKbModeEnabled(useVirtualKb, force);
	}
};



p.resizeHistoryBoxHeight=function(forceResize, scrollToVirtualKb) {
	//console.info("resizeHistoryBoxHeight() called");
	forceResize=(typeof forceResize=="undefined"?false:forceResize);
	scrollToVirtualKb=(typeof scrollToVirtualKb=="undefined"?false:scrollToVirtualKb);
	try {
		if (forceResize || !UiMgr.ignoreResizeEvent) {
			var conversationHistory=$("#conversationHistory");	
			var proClientInfo=$("#proClientInfo");	
			var proClientNotes=$("#proClientNotes");
			
			var viewportHt=$(window).height();
			var offset=(window.mobileApp?179:400); 
			var ht=viewportHt-offset;
			ht=(ht<100?100:ht);
			conversationHistory.css("height", ""+ht+"px");
			proClientInfo.css("height", ""+ht+"px"); 
			proClientNotes.css("height", ""+ht+"px");
			conversationHistory.show();
			if (window.mobileApp) {
				// if we're mobile, two things: first, this method only gets called once (not every time the window is resized, i.e. 
				// by the kb opening up or closing.  Second, we want the newest message to be directly above the editor, always.
				// So, after setting proper height, we want to make the height of our div variable (auto).  But we still need to
				// preserver the height of the containing TD.  So:
				setTimeout(function() {
					//$("#conversationHistoryParent").css("height", ""+fullHistoryBoxHeight+"px");
					$("#conversationHistoryParent").css("background-color", "#ffffff"); // not necessary for desktop but for mobile, we need this
					setTimeout(function() {
						conversationHistory.css("height", "auto");
						proClientInfo.css("height", "auto");
						proClientNotes.css("height", "auto");
						$("#wrapperTableInnerDiv").scrollTop(999999); // scroll this, since unlike with the desktop version, this is a scrollable area
						if (scrollToVirtualKb) {
							$(document).scrollTop(999999);
						}
					}, 50);
				}, 50);
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.updateMessengerFontSizeAndFace=function() {
	var chosenFontCode=$("#fontAcctPref").val();
	var chosenFontSizeCode=$("#fontSizeAcctPref").val();
	var sizeArrayIdx=sizeCodesToSizeArrayIndices[chosenFontSizeCode];
	var sizePxArray=fontCodesToSizeArrays[chosenFontCode];
	var fontSizePx=sizePxArray[sizeArrayIdx];
	if (window.mobileApp) {
		// shrink size by 1px for mobile:
		fontSizePx--;
	}
	var fontSizeAttr=fontSizePx+"px";
	var fontFamilyAttr=fontCodesToFontFamilies[chosenFontCode];
	$("#conversationHistory").css("font-size", fontSizeAttr);
	$("#conversationHistory").css("font-family", fontFamilyAttr);
	if (!mobileApp && professionalSite) {
		$("#proClientNotes").css("font-size", fontSizeAttr);
		$("#proClientNotes").css("font-family", fontFamilyAttr);		
		//$("#proClientInfo").css("font-size", fontSizeAttr); // this stays at the style set in stylesheet
		$("#proClientInfo").css("font-family", fontFamilyAttr);		
	}
	
	if (window.mobileApp) {
		$("#msgCompose_mobile").css("font-size", fontSizeAttr);
		$("#msgCompose_mobile").css("font-family", fontFamilyAttr);		
		$("#msgCompose_mobileVkb").css("font-size", fontSizeAttr);
		$("#msgCompose_mobileVkb").css("font-family", fontFamilyAttr);		
	}
	else {
		$("#editorContainer").css("font-size", fontSizeAttr);
		$("#editorContainer").css("font-family", fontFamilyAttr);		
	}

};



p.clientInfoEditBtnClick=function() {
	MessengerMgr.switchClientInfoEditMode(true);
};

p.clientInfoSaveBtnClick=function() {
	// we validate fullname (make sure it exists) and the two large text fields (make sure they're not too long); no other length validation needed because controlled by input fields, and no other fields are required.
	var fullnameEl=$("#proClientInfo #fullnameInput");
	var generalNotesEl=$("#proClientInfo #generalNotesInput");
	var medicationsEl=$("#proClientInfo #medicationsInput");
	var textareaMaxLength=1800; // db field is a lot longer, but needs to be because values are encrypted
	if (fullnameEl.val().trim().length==0) {
		DialogMgr.validationAlert("You can't leave the "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"'s name blank; please fix and try again.", fullnameEl);
	}
	else if (generalNotesEl.val().trim().length>textareaMaxLength) {
		DialogMgr.validationAlert("The general notes can't exceed "+textareaMaxLength+" characters; please fix and try again.", generalNotesEl);
	}
	else if (medicationsEl.val().trim().length>textareaMaxLength) {
		DialogMgr.validationAlert("The medications info can't exceed "+textareaMaxLength+" characters; please fix and try again.", medicationsEl);
	}
	else {
		DialogMgr.openBlockingModalDialog("Saving your changes...");
		setTimeout(function() {
			var data={};
			for (var i=0; i<MessengerMgr.clientInfoFormFieldCodes.length; i++) {
				data[MessengerMgr.clientInfoFormFieldCodes[i]]=$("#proClientInfo #"+MessengerMgr.clientInfoFormFieldCodes[i]+"Input").val();
			}
			var response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.SAVE_CURRENT_TUNNEL_CLIENT_INFO, data, false);
			DialogMgr.closeBlockingModalDialog();
			if (typeof response.success=="undefined" || response.success!=true) {
				DialogMgr.alert("Couldn't save your data; please try again.");
			}		
			else {
				MessengerMgr.switchClientInfoEditMode(false);
			}
		}, 100);
	}
};

 
p.switchClientInfoEditMode=function(toEditMode) {
	$("#proClientInfo #clientInfoEditBtn")[!toEditMode?"show":"hide"]();
	$("#proClientInfo #clientInfoSaveBtn")[toEditMode?"show":"hide"]();
	for (var i=0; i<MessengerMgr.clientInfoFormFieldCodes.length; i++) {
		$("#proClientInfo #"+MessengerMgr.clientInfoFormFieldCodes[i]+"Input").css("borderColor", toEditMode?"#cccccc":"#ffffff");
		$("#proClientInfo #"+MessengerMgr.clientInfoFormFieldCodes[i]+"Input").prop("readonly", !toEditMode);
	}
};




var MessengerMgr=new _MessengerMgr();

