
if (typeof P=="undefined") {var P="prototype";}

function _MD () {
	this.connectivityStatusEventFired=false; // once either the "online" or "offline" event fires, this is set to true and never set back to false
	this.online=false; // set to true when "online" fires, to false when "offline" fires
	this.paused=false;
	this._deviceProperties=null; // populated after deviceReady (with Cordova props such as model, uuid, etc.)  See http://docs.phonegap.com/en/1.0.0/phonegap_device_device.md.html#Device.
	this.lastSuccessfulOnlineCheckMillis=0;
}

_MD[P].isOnlineStatusKnown=function() {
	return MobileDevice.connectivityStatusEventFired;
};




_MD[P].resetUiIfClientOfflineTooLong=function(firstCheck) {
	if (MobileDevice.isOnlineStatusKnown()) { // if it's NOT known, either we're desktop-debugging, or there's a Cordova problem; either way, we'll skip this and check again in a minute.
		// we don't do this if we are on the homepage or the main PIN-entry page; no reason:
		if (ScreenViewStack.getCurrentScreenId()!="authHome" && ScreenViewStack.getCurrentScreenId()!="authChooseExistingPin") {
			var now=new Date().getTime();
			if (MobileDevice.isOnline()) {
				MobileDevice.lastSuccessfulOnlineCheckMillis=now;
			}
			else {
				// could just be temporary, so:
				if (now-MobileDevice.lastSuccessfulOnlineCheckMillis>(1000*60*10)) {
					// been more than 10 mins; reset (unless this is the first check):
					if (!firstCheck) {
						UiMgr.goToHomepageAndResetUi(true);				
					}
				}
			}					
		}
	}
	// check again in a minute:
	setTimeout(function() {MobileDevice.resetUiIfClientOfflineTooLong(false);}, 1000*60);
};

_MD[P].isOnline=function() {
	return MobileDevice.online;
};

_MD[P].isPaused=function() {
	return MobileDevice.paused;
};


_MD[P]._onOnlineEvent=function() {
	MobileDevice.online=true;
	MobileDevice.connectivityStatusEventFired=true;
};

_MD[P]._onOfflineEvent=function() {
	MobileDevice.online=false;
	MobileDevice.connectivityStatusEventFired=true;
};

// called when the app is backgrounded
_MD[P]._onPauseEvent=function() {
	MobileDevice.paused=true;
};

// caused when the app is foregrounded
_MD[P]._onResumeEvent=function() {
	MobileDevice.paused=false;
};

// Note: Android only (not iOS); we use this to close dialogs, etc. --
_MD[P]._onBackbuttonEvent=function() {
	UiMgr.promptForBackButtonAppExit();
	return true; // nothing wrong with this stack (as far as I know), but there are issues tht need ressolving with my use of it before we turn it on; so for now, always returning true (in a timeout, we also ask the user if they want to exit).
	/*
	var fn=BackbuttonFunctionStack.getAndRemoveCurrent();
	if (fn!=null) {
		fn();
		return false; // override default action
	}
	return true;
	*/
};


_MD[P].setDeviceProperties=function(device) {
	MobileDevice.deviceProperties=device;
};

/**
 * See http://docs.phonegap.com/en/1.0.0/phonegap_device_device.md.html#device.name for return values; they are not intuitive
 */
_MD[P].getDeviceModelName=function() {
	try {
		return MobileDevice.deviceProperties.name;
	}
	catch (e) {
		return "[unknown name]";
	}
};

/**
 * See http://docs.phonegap.com/en/1.0.0/phonegap_device_device.md.html#device.platform (use isIos() and isAndroid() rather than this to reliably determine what OS we're on)
 */
_MD[P].getDeviceOS=function() {
	try {
		return MobileDevice.deviceProperties.platform;
	}
	catch (e) {
		return "[unknown platform]";
	}
};

/**
 * See http://docs.phonegap.com/en/1.0.0/phonegap_device_device.md.html#device.uuid - iOS seems to handle UUID oddly
 */
_MD[P].getDeviceUUID=function() {
	try {
		return MobileDevice.deviceProperties.uuid;
	}
	catch (e) {
		return "[unknown uuid]";
	}
};

/**
 * See http://docs.phonegap.com/en/1.0.0/phonegap_device_device.md.html#device.version -- we're unlikely to need/use this prop.
 */
_MD[P].getDeviceOSVersion=function() {
	try {
		return MobileDevice.deviceProperties.version;
	}
	catch (e) {
		return "[unknown version]";
	}
};

_MD[P].isIos=function() {
	// Note: currently, iOS devices all identify as "iPhone"; being forward-compatible and identifying "ios" devices as iOS as well, in case
	// Apple switches it up in future releases/devices:
	return (MobileDevice.getDeviceOS().toLowerCase().indexOf("iphone")>-1 || MobileDevice.getDeviceOS().toLowerCase().indexOf("ios")>-1);
};

_MD[P].isAndroid=function() {
	return (MobileDevice.getDeviceOS().toLowerCase().indexOf("android")>-1);
};





var MobileDevice=new _MD();
