

p.clearFormField=function(jqObj) {
	var elTitle=jqObj.attr("title");
	var resetVal="";
	if (typeof elTitle!="undefined" && elTitle!=null) {
		resetVal=elTitle;
	}
	jqObj.val(resetVal);
};





p.expressLogout=function() {
	UiMgr.logout(false, false, false, null, false, true);
};

p.logout=function(throwErrors, confirmLogoutWithAlert, isServerRequestedLogout, overrideDefaultLogoutMessage, inactivityForcedLogoutByClient, exitSite) {
	//console.info("in UiMgr.logout()...");
	try {
		ClickHandlers.toggleHelpTypes(false);
		try {
			TunnelMgr.exitTunnel(false); // ensure server knows we logged out of tunnel (if any)
		}
		catch (swallow) {}
		
		TunnelMgr.reset();
		
		
		// hide these; with no account, there are no settings to change, no acct to add tunnels to, and nothing to exit from (for the app; for the site, we don't hide this link):
		UiMgr.showFooterIcon("settings", false); 
		
		UiMgr.showFooterIcon("addTunnel", false); 
		UiMgr.showFooterIcon("viewTunnelList", false);
		
		
		
		ScreenViewStack.clear();
		AccountUpdateRetriever.stop(); // stop, in case there are any outstanding account-update requests
		
		if (TunnelMgr.getCurrentTunnelAttribute("currentUserName")==null) {
			if (exitSite) {
				if (!mobileApp) {
					UiMgr.goAboutBlank(); // user already logged out; just get them out of here	
				}
			}
			return;
		}
		if (!isServerRequestedLogout) { // we only tell the server we're logging out if the server didn't tell us to do it --
			try {
				var map={};
				map.inactivityForcedLogout=inactivityForcedLogoutByClient;
				response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOG_OUT, map, false);
			}
			catch (e) {
				if (throwErrors) {
					throw e;
				}
			}
		}

		
		if (exitSite) {
			if (!mobileApp) {
				UiMgr.goAboutBlank();// we don't always do this, such as if we log the user out because they clicked on the footer logo and we're returning them to the homepage.
			}
			else {
				UiMgr.goToHomepageAndResetUi();
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.loginSuccess=function() {
	try {
		UiMgr.clearAllNonFileUploadFormFields();
		MessengerMgr.showMessengerUi();
		UiMgr.unalertedPageExitOkay=false;
		UiMgr.unregisteredConfidantAlertAsNeeded();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.unregisteredConfidantAlertAsNeeded=function() {
	if (UiMgr.unregisteredSecondUserNicknameToken==TunnelMgr.getUnparsedCurrentConfidantName() && UiMgr.showAlertBasedOnPrefs("unregisteredConfidant")) {
		DialogMgr.alert("Please note: your confidant has never signed into Tunnel X. Until he/she does that and chooses a permanent image key, you may want to avoid posting sensitive information in this tunnel."+UiMgr.getMoreInfoAlertHtml("unregisteredConfidant")+UiMgr.getDontShowAlertAgainHtml("unregisteredConfidant"));
	}
};

p.alertDetailsAlert=function(alertCode) {
	try {
		var msg;
		if (!window.mobileApp) {
			switch (alertCode) {
				case "unregisteredConfidant": {msg="Since your confidant has not yet signed into Tunnel X and chosen a permanent image key, "
					+"it is possible (if unlikely) that the temporary passphrase you sent to him/her could fall into the wrong "
					+"hands (for example, if someone other than your confidant gets access to his or her email account: a hacker; a "
					+"co-worker; a roommate; etc.).  If eavesdroppers were to get hold of the temporary passphrase, they would be "
					+"able to read anything you type here.  After your confidant logs in for the first time, this will not be an issue: "
					+"the temporary passcode will no longer work once your confidant has chosen a permanent key.<br/><br/>"
					+"So we suggest, if eavesdroppers are a concern for you, that you refrain from entering any sensitive messages in this tunnel until after your confidant has "
					+"chosen a permanent image key."
					+"<br/><br/>Of course, if you don't feel that this is a real risk in your case, please feel free to "
					+"disregard this warning."; break;};
				default: {throw new Error("Unrecognized alertCode '"+alertCode+"'");};	
			}
		}
		else { // shorter versions for mobile, so all text fits on screen.
			switch (alertCode) {
				case "unregisteredConfidant": {msg="Since your confidant has never signed in and chosen an image key, "
					+"it is possible (if unlikely) that the passphrase you sent could fall into the wrong "
					+"hands. If eavesdroppers were to get hold of that passphrase, they could read anything you type here.  "
					+"After your confidant has logged in, this will not be an issue: "
					+"the passcode will not work once your confidant has chosen a key.<br/><br/>"
					+"So if eavesdroppers are a concern, then until your confidant signs in for the first time, "
					+"you shouldn't leave sensitive messages here."; break;};
				default: {throw new Error("Unrecognized alertCode '"+alertCode+"'");};	
			}
		}
		DialogMgr.alert(msg);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};




p.getMoreInfoAlertHtml=function(alertCode) {
	return " &nbsp;<a tabindex=\"-1\" href=\"#\" style=\"color:#bed62f;\" onclick=\"UiMgr.alertDetailsAlert('"+alertCode+"'); return false;\">[more&nbsp;info...]</a>";
};

p.getDontShowAlertAgainHtml=function(alertCode) {
	return "<br/><br/><form action=\"#\" onsubmit=\"return false;\">"
		+"<div style=\"width:100%; text-align:right;\"><input tabindex=\"-1\" onclick=\"UiMgr.updateAlertSuppressionPrefs('"+alertCode+"', this.checked)\" type=\"checkbox\" name=\"dontShow"+alertCode+"\" id=\"dontShow"+alertCode+"\" value=\"true\" /><label tabindex=\"-1\" style=\"font-size:"+(window.mobileApp?"12":"16")+"px;\" for=\"dontShow"+alertCode+"\">Don't show me this warning again</label>&nbsp;&nbsp;&nbsp;</div>"
		+"</form>";
};

p.updateAlertSuppressionPrefs=function(alertCode, checkboxIsChecked) {
	if (checkboxIsChecked) {
		UiMgr.addSuppressAlertCode(alertCode);
	}
	else {
		UiMgr.removeSuppressAlertCode(alertCode);
	}
};


p.showAlertBasedOnPrefs=function(alertCode) {
	return !Core.arrayContains(UiMgr.acctPrefs.suppressAlertCodesAcctPref, alertCode);
};





var _UM_uploadKeyAdditionalText;

if (!window.mobileApp) {
	_UM_uploadKeyAdditionalText="Without it (and the PIN you\'ve already chosen), you will not be "+
		"able to sign in. This key will keep your messages (and your confidant\'s) secure, private, and safe from prying eyes <i>if and only if...</i><blockquote>"+
		"1) It is a photo you took with your own camera and have never shared with anyone<br/><br/>"+
		"2) It was never on the internet (including \"cloud\" storage)<br/><br/>"+
		"3) You never share it with anyone in the future (including your confidant)"+
		"</blockquote><i>If the image key you choose doesn't meet these criteria, your tunnel will not be secure and it will not be private!</i>"+
		"<br/><br/>Click OK to upload your image key. It must be at least "+window.minKeySizeKB+"K.  (Note: The photo will not be visible to your confidant.)";
}
else { // slightly shorter version for mobile users:
	_UM_uploadKeyAdditionalText="Without it, you will not be "+
		"able to sign in. This key will protect you <i>only if...</i><br/><br/>"+
		"1) It is a photo you took and have never shared (including with your confidant)<br/><br/>"+
		"2) It was never on the internet<br/><br/>"+
		"After you tap 'OK,' your choose-file screen will open, so you can choose your photo.";

}







p.hiddenSecondUserUploadNewKeyCallback=function() {
	try {
		ImageKeyUploader.currentFileUploadOnchangeUiMgrFunctionName='hiddenSecondUserUploadNewKeyChanged';
		ImageKeyUploader.clickFileUploadBoxWithErrorTimeout();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.hiddenUploadReplacementKeyCallback=function() {
	try {
		ImageKeyUploader.currentFileUploadOnchangeUiMgrFunctionName='hiddenUploadReplacementKeyChanged';
		ImageKeyUploader.clickFileUploadBoxWithErrorTimeout();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.hiddenUploadReplacementKeyChanged=function() {
	try {
		var filename=$("#fileUploadForm #file").val();
		if (filename==null || filename.trim().length==0) {
			throw new Error("filename not found.");
		}
		if (UiMgr.isValidImageKeyFilename(filename)) {
			$("#fileUploadForm #filename").val(filename);
			try {
				// The handler we're about to talk to requires that we get a nonce from the server, generate our 
				// own nonce, and hash them with the PIN, then set those values in the form, so:
				//CommMgr.addNonceAndHashToFileUploadForm(UiMgr.handlerKeys.UPLOAD_REPLACEMENT_KEY, filename);
			}
			catch (e) {
				// Didn't work; user probably lost internet connection (or has an extremely slow one):
				console.error(e);
				DialogMgr.alert("It looks like you don't have an internet connection.  Please wait a bit, then try again.");
				return;
			}
			CommMgr.startAsynchronousAjaxFileUpload(CommMgr.getControlServer(), UiMgr.handlerKeys.UPLOAD_REPLACEMENT_KEY, "?_multipartHandlerKey="+UiMgr.handlerKeys.UPLOAD_REPLACEMENT_KEY);			
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.isValidImageKeyFilename=function(filename) {
	try {
		var lcFilename=filename.toLowerCase().trim();
		// nope, we've got android phones that supply jpgs WITHOUT A FILENAME EXTENSION: THANKS, GOOOOOOOOOGLE!!! so, no 
		// morevalidation of this type, so:
		/*
		if (!lcFilename.endsWith(".jpg") && !lcFilename.endsWith(".jpeg")) {
			DialogMgr.alert("The image file you are uploading must be in JPEG format (most photographs are in JPEG format), files which end with 'jpg' or 'jpeg'.  Please try again.  (And remember that you must have taken the photograph yourself; if someone else took it, they'll have a copy of your key!)");
			return false;
		}
		*/
		return true;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.isValidHandleChars=function(s) {
	try {
		return /[^A-Za-z0-9]/g.test(s);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.isValidTunnelNameChars=function(s) {
	try {
		return /[^A-Za-z0-9\'\-\(\)\! ]/g.test(s);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.isValidEmailAddress=function(emailAddr) {
	try {
	    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	    return re.test(emailAddr);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};




function validateEmail(email) { 
} 







p.hiddenUploadAuthKeyChanged=function() {
	try {
		var filename=$("#fileUploadForm #file").val();
		$("#fileUploadForm #filename").val(filename);
		$("#authHomeForm #imageLoginKeyDisplayName").val(UiMgr.getFilenameOnly(filename));
		PinPad.openPinDialogForAuth(); // launch the PIN chooser
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.getFilenameOnly=function(filename) {
	try {
		var filenameOnly=""+filename;
		if (filenameOnly.indexOf("\\")>-1) {
			// Win:
			filenameOnly=filenameOnly.substring(filenameOnly.lastIndexOf("\\")+1, filenameOnly.length);
		}
		else if (filenameOnly.indexOf(":")>-1) {
			// Mac:
			filenameOnly=filenameOnly.substring(filenameOnly.lastIndexOf(":")+1, filenameOnly.length);
		}
	
		else if (filenameOnly.indexOf("/")>-1) {
			// UNIX:
			filenameOnly=filenameOnly.substring(filenameOnly.lastIndexOf("/")+1, filenameOnly.length);
		}
		return filenameOnly;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};


p.openAuthKeyUploadChooser=function() {
	try {
		ImageKeyUploader.currentFileUploadOnchangeUiMgrFunctionName='hiddenUploadAuthKeyChanged';
		ImageKeyUploader.clickFileUploadBoxWithErrorTimeout();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};





p.logInExistingAccountNewDevice=function() {
	var pinVal=UiMgr.existingAccountNewDevice.pin;
	UiMgr.existingAccountNewDevice.pin=null;
	//we're ready to attempt authentication:
	// remember that whenever we open a dialog before communicating with the server, we have to put that server-
	// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
	DialogMgr.openBlockingModalDialog("Signing you in...", UiMgr.expectedAuthTimeMillis);
	setTimeout(function(){
		var dataMap={};
		// Attempt the login:
		var hexBytes=UiMgr.existingAccountNewDevice.chosenImageKeyHexBytes;
		UiMgr.existingAccountNewDevice.chosenImageKeyHexBytes=null;
		if (mobileApp) {
			ClientStorage.set(UiMgr.clientStorageKeyBytesKey, hexBytes);
			ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "true");
		}
		dataMap.pin=pinVal;
		dataMap.leadingBytesHex=hexBytes;
		dataMap.tempPassphrase=UiMgr.existingAccountNewDevice.tempKey;

		var response=null;
		try {
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOG_IN_WITH_NEW_DEVICE_IMAGE_KEY, dataMap, false);
		}
		catch (e) {
			response={success:false};
		}
		if (!response.success) {
			DialogMgr.closeBlockingModalDialog();
			ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "false");

			var failureMsg;
			if (typeof response.failureDetailsMessage != "undefined" && response.failureDetailsMessage!=null) {
				failureMsg=response.failureDetailsMessage;
			}
			else {
				failureMsg="Your sign-in failed.  Please try again.";

			}
			PinPad.clearPin();
			DialogMgr.alert(failureMsg);		
		}
		else {
			DialogMgr.closeBlockingModalDialog();
			if (window.enablePushNotifications && response.sendUuid && mobileApp) {
				// the server wants the UUID of this device:
				NotificationMgr.init();
			}
			UiMgr.unalertedPageExitOkay=false;

			//console.info("response.handle="+response.handle);

			if (!(typeof response.handle=="undefined" || response.handle==null || response.handle=="")) {
				UiMgr.currentAccountHandle=response.handle;
				UiMgr.currentAcctIsProfessionalClient=(window.professionalSite && response.currentAcctIsProfessionalClient);
				
			}
			UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
			//console.info("UiMgr.currentAccountHandle="+UiMgr.currentAccountHandle);
			

			UiMgr.doPostLoginActions(response);
		}			
	}, 100);
		 

}; 


/**
 * generates a string exactly 81920 chars long which begins with "FFD8" followed by random hexadecimal digits; this
 * allows us backwards compatibility with users who, on mobiles, had the first 40K of their image keys stored
 * in local browser storage.  (All JPGs start with FFD8 and our server API counts on that.)
 */
p.generateMockRandomJpgLeadingHexBytes=function() {
	var targetBinaryByteLength=1024*40;
	var targetLn=targetBinaryByteLength*2; // (40K * 2 because each hex byte takes two characters to express, i.e. string is 80K long)
	var s="FFD8"; // start with the JPG marker (note: we won't end the string with a JPG marker because this string is not expected by the server API to represent a FULL jpg file, just the first 40K, exactly)
	// PRNGs have been known to be completely broken!  As a (fairly weak) countermeasure, we'll also hash some difficult (but
	// not impossible, and some easily knowable) to acquire info:
	var strToHash="";
	try {
		strToHash+=MobileDevice.getDeviceUUID() // hardest-to-guess, but still knowable
			+"|"+MobileDevice.getDeviceModelName()
			+"|"+MobileDevice.getDeviceOS()
			+"|"+MobileDevice.getDeviceOSVersion()
		;
	}
	catch (e) {}
	// hash the device info with the current client time (we do this with the knowledge that the system clock could be compromised
	// too, but again, we are trying to defend against a broken PRNG; this is a second layer of protection).  Also, for 
	// Java developers, note that JavaScript's getTime() returns an JavaScript int; JS doesn't have "long"s):
	s+=Crypto.sha256HashAsHex(strToHash, Crypto.intToHex(new Date().getTime()));
	s+=Crypto.generateRandomBits(targetBinaryByteLength*8); // 40K * 8 bits = 40K bytes
	return s.substring(0, targetLn); // we shave off extra hex digits that we don't need
};


