



p.doCurrentMultipartFormClick=function() {
	if (UiMgr.currentMultipartMode==null) {
		throw new Error("UiMgr.currentMultipartMode cannot be null when UiMgr.doCurrentMultipartFormClick() is called.");
	}
	
	if (UiMgr.currentMultipartMode=="keyUpload") {
		ImageKeyUploader.uploadFileHiddenFieldClick();
		if (window.useCordovaFilePluginForUploads) {
			ImageKeyUploader.openFileChooser();
		}
	}
	else if (UiMgr.currentMultipartMode=="mediaUpload") {
		MediaUploader.uploadFileHiddenFieldClick();
		if (window.useCordovaFilePluginForUploads) {
			MediaUploader.openFileChooser();
		}
	}
	else {
		throw new Error("Unexpected UiMgr.currentMultipartMode ('"+UiMgr.currentMultipartMode+"')");
	}
}




p.doCurrentMultipartFormOnchange=function() {
	if (UiMgr.currentMultipartMode==null) {
		throw new Error("UiMgr.currentMultipartMode cannot be null when UiMgr.doCurrentMultipartFormOnchange() is called.");
	}
	
	if (UiMgr.currentMultipartMode=="keyUpload") {
		ImageKeyUploader.doFileElementOnchange();
	}
	else if (UiMgr.currentMultipartMode=="mediaUpload") {
		MediaUploader.doFileElementOnchange();
	}
	else {
		throw new Error("Unexpected UiMgr.currentMultipartMode ('"+UiMgr.currentMultipartMode+"')");
	}
}
	




p.isAcctLoggedIn=function() {
	return (Core.toStringAllProps(UiMgr.acctPrefs)!="[]"); // how we know if a user is logged in; not elegant, but it works
};



p.createInitialUserAccount=function() {
	// for "professional" sites, there is no UiMgr.creatingAccount.secondUserTempKey.  But the server still
	// expects it, for hashing/nonce purposes, so we need to make one up.  So:
	if (UiMgr.creatingAccount.secondUserTempKey==null) {
		UiMgr.creatingAccount.secondUserTempKey=Crypto.generateRandomBits(1024);
	}
	var createAcctDataMap={
			imageKeyHexBytes:UiMgr.creatingAccount.creatingUserChosenImageKeyHexBytes,
			pin:UiMgr.creatingAccount.creatingUserChosenPin,
			tunnelName:UiMgr.creatingAccount.creatingUserChosenTunnelName,
			nickname:UiMgr.creatingAccount.creatingUserChosenNickname,
			secondUserTempKey:UiMgr.creatingAccount.secondUserTempKey,
			secondUserSignupUrl:UiMgr.creatingAccount.secondUserSignupUrl,
			professionalSite:window.professionalSite,
			useHandles:window.useHandles
	};
	// additional fields as needed:
	if (window.professionalSite) {
		createAcctDataMap.creatingUserEmail=UiMgr.creatingAccount.creatingUserEmail;
		createAcctDataMap.creatingUserFullname=UiMgr.creatingAccount.creatingUserFullname;
	}
	
	// remember that whenever we open a dialog before communicating with the server, we have to put that server-
	// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
	DialogMgr.openBlockingModalDialog("Creating your account...", UiMgr.expectedAuthTimeMillis);
	var createAcctResponse=null;
	var loginAcctResponse=null;
	setTimeout(function(){
		

		var error=null;
		try {
			//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.CREATE_INITIAL_USER_ACCOUNT, createAcctDataMap, UiMgr.creatingAccount.secondUserTempKey);
			createAcctResponse=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CREATE_INITIAL_USER_ACCOUNT, createAcctDataMap, false);	
			if (!createAcctResponse.success) {
				throw new Error("Account creation failed; reason: "+createAcctResponse.failureReasonMessage);
			}
		}
		catch (e) {
			error=e;
		}
		finally {
			DialogMgr.closeBlockingModalDialog();
		}
		if (error!=null) {
			var errMsg;
			if (typeof createAcctResponse.failureReasonMessage!="undefined" && createAcctResponse.failureReasonMessage!=null) {
				errMsg=createAcctResponse.failureReasonMessage;
			}
			else {
				errMsg="There was a problem; your account was not created. Please try again.";
			}
			DialogMgr.alert(errMsg);
		}
		else {
			if (true || window.mobileApp) {
				// if we're mobile, store the image bytes in the user's browser storage...
				ClientStorage.set(UiMgr.clientStorageKeyBytesKey, UiMgr.creatingAccount.creatingUserChosenImageKeyHexBytes);
				ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "true");
				
				

				var pinForAuth=UiMgr.creatingAccount.creatingUserChosenPin;
				// and then log the user in...
				// remember that whenever we open a dialog before communicating with the server, we have to put that server-
				// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.

				DialogMgr.openBlockingModalDialog("Signing you in...", UiMgr.expectedAuthTimeMillis); 
				setTimeout(function() {
					var loginAcctDataMap={};
					try {
						// The handler we're about to talk to requires that we get a nonce from the server, generate our 
						// own nonce, and hash them with the PIN, then set those values in the form, so:
						//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, loginAcctDataMap, pinForAuth);
					}
					catch (e) {
						// Didn't work; user probably lost internet connection (or has an extremely slow one):
						DialogMgr.closeBlockingModalDialog();
						console.error(e);
						DialogMgr.alert("It looks like you don't have an internet connection.  Please wait a bit, then try again.");
						return;
					}

					// Attempt the login (this won't fail except if the user suddenly went offline, or bacause of malicious use; if it fails, we'll swallow the problem and let the user 
					// see the second-user screen:
					loginAcctDataMap.leadingBytesHex=ClientStorage.get(UiMgr.clientStorageKeyBytesKey); // first time we're getting this from local storage; can't get it from a stored car because we nulled it out
					loginAcctDataMap.pin=pinForAuth;
					try {

						loginAcctResponse=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, loginAcctDataMap, false);
					}
					catch (e) {
						loginAcctResponse={success:false};
					}
					DialogMgr.closeBlockingModalDialog();
					if (loginAcctResponse.success) {
						if (window.enablePushNotifications && mobileApp && NotificationMgr.enableNotifications) {
							// the server wants the UUID of this device:
							// try to send it twice, as sometimes updating the preference doesn't store the uuid
							NotificationMgr.init();
							UiMgr.changeAcctPref('doNotificationsAcctPref', 'true');
							loginAcctResponse.doNotificationsAcctPref=true;
						}
						else {
							loginAcctResponse.doNotificationsAcctPref=false;
						}
						UiMgr.unalertedPageExitOkay=false;
						//console.info("loginAcctResponse.handle="+loginAcctResponse.handle);

						if (!(typeof loginAcctResponse.handle=="undefined" || loginAcctResponse.handle==null || loginAcctResponse.handle=="")) {
							UiMgr.currentAccountHandle=loginAcctResponse.handle;
							UiMgr.currentAcctIsProfessionalClient=false; // if we're in this method at all, it's an originating user (tx or tt), which means this is always false

						}
						UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
						//console.info("UiMgr.currentAccountHandle="+UiMgr.currentAccountHandle);


						
						
						// set the account prefs...
						UiMgr.setAcctPrefsFromResponse(loginAcctResponse);
						// ...then reflect them  to the UI:
						UiMgr.updateAcctPrefsUi();						
						
						// Now we populate the two temporary creds (showAuthPage() does that) for this user to give to their correspondent user; then we'll show the 
						// page containing them.
						DialogMgr.closeBlockingModalDialog();
						UiMgr.showAuthPage("authCreateTunnelComplete");
						UiMgr.showFooterIcon("settings", true);
						//alert("xxx "+(!(mobileApp && professionalSite)));
						UiMgr.showFooterIcon("addTunnel", !(mobileApp && professionalSite));
						UiMgr.showFooterIcon("viewTunnelList", true);							
						// null these out:
						UiMgr.creatingAccount.creatingUserChosenImageKeyHexBytes=null;
						UiMgr.creatingAccount.creatingUserChosenPin=null;

					}
					else {
						// This is probably actually an application error, or indication of malicious behavior:
						DialogMgr.alert("Your sign-in failed.  Please check to ensure you have an internet connection.");
					}
				} // end setTimeout
				, 100);
	
			} // end if mobile display
		}
		
	});
};


p.createSecondUserAccount=function() {
	var createAcctDataMap={
			imageKeyHexBytes:UiMgr.newAccountSecondUser.chosenImageKeyHexBytes,
			pin:UiMgr.newAccountSecondUser.chosenPin,
			nickname:UiMgr.newAccountSecondUser.chosenNickname,
			secondUserTempKey:UiMgr.newAccountSecondUser.tempKey,
			secondUserTempPin:UiMgr.newAccountSecondUser.tempPin
	};
	
	// remember that whenever we open a dialog before communicating with the server, we have to put that server-
	// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
	DialogMgr.openBlockingModalDialog("Creating your account...", UiMgr.expectedAuthTimeMillis);
	var createAcctResponse=null;
	var loginAcctResponse=null;
	setTimeout(function(){
		

		var error=null;
		try {
			//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.CREATE_SECOND_USER_ACCOUNT, createAcctDataMap, UiMgr.newAccountSecondUser.chosenPin);
			createAcctResponse=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CREATE_SECOND_USER_ACCOUNT, createAcctDataMap, false);	
			if (!createAcctResponse.success) {
				throw new Error("Account creation failed; reason: "+createAcctResponse.failureReasonMessage);
			}
		}
		catch (e) {
			error=e;
		}
		finally {
			DialogMgr.closeBlockingModalDialog();
		}
		if (error!=null) {
			var errMsg;
			if (typeof createAcctResponse.failureReasonMessage!="undefined" && createAcctResponse.failureReasonMessage!=null) {
				errMsg=createAcctResponse.failureReasonMessage;
			}
			else {
				errMsg="There was a problem; your account was not created. Please try again.";
			}
			DialogMgr.alert(errMsg);
		}
		else {
			if (true || window.mobileApp) {
				// if we're mobile, store the image bytes in the user's browser storage...
				ClientStorage.set(UiMgr.clientStorageKeyBytesKey, UiMgr.newAccountSecondUser.chosenImageKeyHexBytes);
				ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "true");
				
				// and then zero out that value from our local script...
				UiMgr.newAccountSecondUser.chosenImageKeyHexBytes=null;
				// ...and the PIN too, although we'll hold it in a local var because we're about to actually log the user in...
				var pinForAuth=UiMgr.newAccountSecondUser.chosenPin;
				UiMgr.newAccountSecondUser.chosenPin=null;
				
				/* THE REST OF THE CODE HERE IS (AS OF NOW) *IDENTICAL* TO THE CODE CREATEINITIALUSERACCOUNT(); COMBINE. */
				// and then log the user in...
				// remember that whenever we open a dialog before communicating with the server, we have to put that server-
				// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.

				DialogMgr.openBlockingModalDialog("Signing you in...", UiMgr.expectedAuthTimeMillis); 
				setTimeout(function(){

					var loginAcctDataMap={};
					try {
						// The handler we're about to talk to requires that we get a nonce from the server, generate our 
						// own nonce, and hash them with the PIN, then set those values in the form, so:
						//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, loginAcctDataMap, pinForAuth);
					}
					catch (e) {
						// Didn't work; user probably lost internet connection (or has an extremely slow one):
						DialogMgr.closeBlockingModalDialog();
						console.error(e);
						DialogMgr.alert("It looks like you don't have an internet connection.  Please wait a bit, then try again.");
						return;
					}

					// Attempt the login (this won't fail except if the user suddenly went offline, or bacause of malicious use; if it fails, we'll swallow the problem and let the user 
					// see the second-user screen:
					loginAcctDataMap.leadingBytesHex=ClientStorage.get(UiMgr.clientStorageKeyBytesKey); // first time we're getting this from local storage; can't get it from a stored car because we nulled it out
					loginAcctDataMap.pin=pinForAuth;
					try {

						loginAcctResponse=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, loginAcctDataMap, false);
					}
					catch (e) {
						loginAcctResponse={success:false};
					}
					DialogMgr.closeBlockingModalDialog();
					if (loginAcctResponse.success) {
						if (window.enablePushNotifications && mobileApp && NotificationMgr.enableNotifications) {
							// the server wants the UUID of this device:
							// try to send it twice, as sometimes updating the preference doesn't store the uuid
							NotificationMgr.init();
							UiMgr.changeAcctPref('doNotificationsAcctPref', 'true');
							loginAcctResponse.doNotificationsAcctPref=true;
						}
						else {
							loginAcctResponse.doNotificationsAcctPref=false;
						}
						UiMgr.unalertedPageExitOkay=false;
						
						//console.info("loginAcctResponse.handle="+loginAcctResponse.handle);

						if (!(typeof loginAcctResponse.handle=="undefined" || loginAcctResponse.handle==null || loginAcctResponse.handle=="")) {
							UiMgr.currentAccountHandle=loginAcctResponse.handle;
							UiMgr.currentAcctIsProfessionalClient=(window.professionalSite); // if we're here, the user is a client if this is a professionalSite, no need  to check the response.

						}
						UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
						//console.info("UiMgr.currentAccountHandle="+UiMgr.currentAccountHandle);


						// set the account prefs...
						UiMgr.setAcctPrefsFromResponse(loginAcctResponse);
						// ...then reflect them  to the UI:
						UiMgr.updateAcctPrefsUi();
						
						
						AccountUpdateRetriever.requestUpdate(true);
						DialogMgr.closeBlockingModalDialog();
						if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
							UiMgr.showAuthPage("authTunnelList");
						}
						else {
							TunnelMgr.singleTunnelAccountEnterTunnel(true);
						}
						
						UiMgr.showFooterIcon("settings", true);
						//alert("UiMgr.currentAcctIsProfessionalClient="+UiMgr.currentAcctIsProfessionalClient)

						if (!UiMgr.currentAcctIsProfessionalClient) {
							UiMgr.showFooterIcon("addTunnel", !mobileApp);
							UiMgr.showFooterIcon("viewTunnelList", true);							
						}
					}
					else {
						// This is probably actually an application error, or indication of malicious behavior:
						DialogMgr.alert("Your sign-in failed.  Please check to ensure you have an internet connection.");
					}
				}, 100);
	
			}
		}
		
	});
};




p.setAcctPrefsFromResponse=function(response) {
	//alert("setting UiMgr.acctPrefs.fontAcctPref to response.fontAcctPref: "+response.fontAcctPref);
	UiMgr.acctPrefs.fontAcctPref=response.fontAcctPref;
	UiMgr.acctPrefs.fontSizeAcctPref=response.fontSizeAcctPref;
	UiMgr.acctPrefs.autoExitAfterMinutesAcctPref=response.autoExitAfterMinutesAcctPref;
	UiMgr.acctPrefs.sendMessageOnEnterAcctPref=(window.mobileApp?true:response.sendMessageOnEnterAcctPref); // boolean: always true for mobile; there is no send button
	UiMgr.acctPrefs.useVirtualKBForMobileAcctPref=(response.useVirtualKBForMobileAcctPref); // boolean: only applies to mobile - on desktop, users can click a button in the tunnel and open a VKB
	
	if (window.enablePushNotifications) {
		UiMgr.acctPrefs.doNotificationsAcctPref=response.doNotificationsAcctPref; // boolean: true if we send push notifs, false otherwise		
	}
	else {
		UiMgr.acctPrefs.doNotificationsAcctPref=false;
	}
	UiMgr.acctPrefs.suppressAlertCodesAcctPref=response.suppressAlertCodesAcctPref; // array of suppressed codes
	
};





p.doPostLoginActions=function(response) {
	//alert("in doPostLoginActions")
	DialogMgr.openBlockingModalDialog("One moment...");
	// set the account prefs...
	UiMgr.setAcctPrefsFromResponse(response);
	UiMgr.showFooterIcon("settings", true);
	//alert("response.currentAcctIsProfessionalClient="+response.currentAcctIsProfessionalClient)
	if (!response.currentAcctIsProfessionalClient) {
		UiMgr.showFooterIcon("addTunnel", true);
		UiMgr.showFooterIcon("viewTunnelList", true);							
	}

	
	// ...then reflect them  to the UI:
	UiMgr.updateAcctPrefsUi();
	setTimeout(function(){
		DialogMgr.closeBlockingModalDialog();
		AccountUpdateRetriever.requestUpdate(true);
		if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
			UiMgr.showAuthPage("authTunnelList");
		}
		else {
			TunnelMgr.singleTunnelAccountEnterTunnel();
		}
		ClickHandlers.toggleHelpTypes(true);
	}, (!professionalSite || !UiMgr.currentAcctIsProfessionalClient)?500:100);
	

};


p.changeAcctPref=function(prefKey, prefValue) {
	try {
		prefValue=((typeof prefValue=="undefined")?null:prefValue);
		var selectObj=$("#"+prefKey);
		if (prefValue==null) {
			prefValue=selectObj.val();
		}
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CHANGE_ACCOUNT_PREF, {pk:prefKey, pv:prefValue}, false);
		UiMgr.acctPrefs[prefKey]=prefValue;
		$("#"+prefKey+"SavedIndicator").show();
		$("#"+prefKey+"SavedIndicator").hide("fade", "linear", 725);
		
		UiMgr.acctPrefs[prefKey]=prefValue;
		//if (prefKey=="autoExitAfterMinutesAcctPref") {
		//	 no need to do anything to the UI for this setting
		//}
		//if (prefKey=="doNotificationsAcctPref") {
		//	 no need to do anything to the UI for this setting
		//}
		if (prefKey=="useVirtualKBForMobileAcctPref") {
			// no need to do anything to the UI for this setting unless we're currently in a tunnel:
			if (ScreenViewStack.isMessagingUiActive()) {
				MessengerMgr.setVirtualKbModeFromAcctPref(prefValue, true);
			}
		}
		
		else if (prefKey=="sendMessageOnEnterAcctPref") {
			var sendButton=$("#messengerSendButton");
			var sendOnEnterNote=$("#enterToSendNote");
			if (""+prefValue=="true") {
				sendButton.hide();
				sendOnEnterNote.show();
			}
			else {
				sendButton.show();
				sendOnEnterNote.hide();
			}
		}
		else if (prefKey=="fontAcctPref") {
			MessengerMgr.updateMessengerFontSizeAndFace();
		}
		else if (prefKey=="fontSizeAcctPref") {
			MessengerMgr.updateMessengerFontSizeAndFace();
		}
		// and finally, if we changed doNotificationsAcctPref to true, then the server wants to know about this 
		// client's UUID, so:
		if (window.enablePushNotifications && mobileApp) {
			setTimeout(function() {
				NotificationMgr.init(false);
			}, 100);
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.addSuppressAlertCode=function(alertCode) {
	try {
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.ADD_SUPPRESS_ALERT_CODE, {ac:alertCode}, false);	
		var found=false;
		for (var i=0; i<UiMgr.acctPrefs.suppressAlertCodesAcctPref.length; i++) {
			if (UiMgr.acctPrefs.suppressAlertCodesAcctPref[i]==alertCode) {
				found=true;
				break;
			}
		}
		if (!found) {
			UiMgr.acctPrefs.suppressAlertCodesAcctPref[UiMgr.acctPrefs.suppressAlertCodesAcctPref.length]=alertCode;
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};

p.removeSuppressAlertCode=function(alertCode) {
	try {
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.REMOVE_SUPPRESS_ALERT_CODE, {ac:alertCode}, false);	
		var updatedArr=[];
		for (var i=0; i<UiMgr.acctPrefs.suppressAlertCodesAcctPref.length; i++) {
			if (UiMgr.acctPrefs.suppressAlertCodesAcctPref[i]!=alertCode) {
				updatedArr[updatedArr.length]=UiMgr.acctPrefs.suppressAlertCodesAcctPref[i];
			}
		}
		UiMgr.acctPrefs.suppressAlertCodesAcctPref=updatedArr;
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};





p.sendBetaFeedbackFromForm=function() {
	var dataMap={};
	dataMap.betaUserName=$("#betaFeedbackForm #name").val();
	dataMap.email=$("#betaFeedbackForm #email").val();
	dataMap.likeComment=$("#betaFeedbackForm #like").val();
	dataMap.dontlikeComment=$("#betaFeedbackForm #dontlike").val();
	dataMap.otherComment=$("#betaFeedbackForm #othercomments").val();
	dataMap.whereHeardAbout=$("#betaFeedbackForm #whereHeardAbout").val();
	response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.SUBMIT_BETA_FEEDBACK, dataMap, false);
	DialogMgr.alert("Thanks for your valuable feedback.  Please keep it coming!", "OK", DialogMgr.closeDialog);
	
	// clear the fields:
	UiMgr.clearFormField($("#betaFeedbackForm #name"));
	UiMgr.clearFormField($("#betaFeedbackForm #email"));
	UiMgr.clearFormField($("#betaFeedbackForm #like"));
	UiMgr.clearFormField($("#betaFeedbackForm #dontlike"));
	UiMgr.clearFormField($("#betaFeedbackForm #othercomments"));
	UiMgr.clearFormField($("#betaFeedbackForm #whereHeardAbout"));
};


p.destroyAccountIfConfirmed=function() {
	DialogMgr.confirm("<span style=\"font-size:"+(window.mobileApp?"17":"34")+"px;\"><br/>YOU ARE ABOUT TO DESTROY YOUR ACCOUNT!</span><br/><br/>Permanently; forever. Including all tunnels and the messages in them.  You cannot undo this.  "+(window.mobileApp?"Tap":"Click")+" \"Destroy Account Now\" if you really want to do that. "+(window.mobileApp?"Tap":"Click")+" \"Cancel\" otherwise.", UiMgr.doDestroyAccount, UiMgr.noop, "Destroy Account Now", "Cancel");
};




p.doDestroyAccount=function() {
	try {	
		// remember that whenever we open a dialog before communicating with the server, we have to put that server-
		// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
		DialogMgr.openBlockingModalDialog("Destroying your account now.  One moment.", UiMgr.expectedAuthTimeMillis);	
		//alert("destroyinh 2...")
		setTimeout(function(){
			var data={};
			
			try {
				//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.DESTROY_ACCOUNT, data, null);
			}
			catch (e) {
				return;
			}

			try {
				response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.DESTROY_ACCOUNT, data, true, function(){}, function(){DialogMgr.alert("Couldn't destroy your account.  Please check your internet connection and try again.");}, 180000);
				MessengerMgr.doUpdateChecks=false;
				UiMgr.unalertedPageExitOkay=true;
				ImageKeyUploader.clearFileUploadFormFields();
				UiMgr.clearAllNonFileUploadFormFields();
				try {
					ClientStorage.wipe();
				}
				catch (e) {}
				if (!mobileApp) {
					UiMgr.goAboutBlank();
				}
				else {
					DialogMgr.alert("Your account and all tunnels and messages in it have been permanently destroyed.", "OK", UiMgr.goToHomepageAndResetUi);
				}
			}
			catch (e) {
				DialogMgr.alert("YOUR ACCOUNT HAS NOT BEEN DESTROYED.<br/><br/>Could not contact the server to destroy your account; you may have lost your internet connection.  Please try again, or log out and try again later.");
			}
		}, 100);
		
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};







p.destroyTunnelIfConfirmed=function(clientTunnelId, callbackFn) {
	if (typeof callbackFn=="undefined") {
		callbackFn=function() {};
	}
	DialogMgr.confirm("<span style=\"font-size:"+(window.mobileApp?"17":"34")+"px;\"><br/>YOU ARE ABOUT TO DESTROY THIS TUNNEL!</span><br/><br/>Permanently; forever. You cannot undo this.  "+(window.mobileApp?"Tap":"Click")+" \"Destroy Tunnel Now\" if you really want to do that. "+(window.mobileApp?"Tap":"Click")+" \"Cancel\" otherwise.", function() {UiMgr.doDestroyTunnel(clientTunnelId, callbackFn);}, function() {TunnelMgr.switchAddDeleteMode("add");}, "Destroy Tunnel Now", "Cancel");
};




p.doDestroyTunnel=function(clientTunnelId, callbackFn) {
	if (typeof callbackFn=="undefined") {
		callbackFn=function() {};
	}
	try {	
		// stop the AccountUpdateRetriever from running while we delete the tunnel
		UiMgr.destroyingTunnel=true;
		AccountUpdateRetriever.stop();
		// remember that whenever we open a dialog before communicating with the server, we have to put that server-
		// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
		DialogMgr.openBlockingModalDialog("One moment...", UiMgr.expectedAuthTimeMillis);	
		setTimeout(function(){
			var data={clientTunnelId:clientTunnelId};
			try {
				//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.DESTROY_TUNNEL, data, clientTunnelId);
			}
			catch (e) {
				return;
			}
			finally {
				DialogMgr.closeBlockingModalDialog();
			}

			DialogMgr.openBlockingModalDialog("One moment, deleting the tunnel...", UiMgr.expectedAuthTimeMillis);	
			setTimeout(function() {
				try {
					response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.DESTROY_TUNNEL, data, false);
					MessengerMgr.doUpdateChecks=false;
					DialogMgr.closeBlockingModalDialog();
					TunnelMgr.exitTunnel();
					TunnelMgr.removeTunnel(clientTunnelId);
					$("#tunnelListItem"+clientTunnelId).hide();
					UiMgr.showAuthPage("authTunnelList");	
					DialogMgr.closeBlockingModalDialog();
				}
				catch (e) {
					DialogMgr.closeBlockingModalDialog();
					DialogMgr.alert("YOUR TUNNEL HAS NOT BEEN DESTROYED.<br/><br/>Could not contact the server to destroy your tunnel; you may have lost your internet connection.  Please try again, or log out and try again later.");
				}
				finally {
					// make sure to restart the AccountUpdateRetriever after the tunnel has been destroyed
					setTimeout(function() {
						UiMgr.destroyingTunnel=false;
						AccountUpdateRetriever.start();
						callbackFn();
					}, 500);
				}

			}, 100);
		}, 100);
		
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


p.noop=function() {
};











p._togglePageTitle=function() {
	if (UiMgr.windowHasFocus) {
		UiMgr.stopToggleTitle();
	}
	else {
		UiMgr.isTitleToggledOn=!UiMgr.isTitleToggledOn;
		$(document).attr("title", UiMgr.isTitleToggledOn?UiMgr.toggleTitleOnText:UiMgr.toggleTitleOffText);
	}
};

p.startToggleTitle=function() {
	clearInterval(UiMgr.toggleTitleInterval);
	UiMgr._togglePageTitle();
	UiMgr.toggleTitleInterval=setInterval(UiMgr._togglePageTitle, UiMgr.toggleTitleIntervalLengthMillis);
};

p.stopToggleTitle=function() {
	clearInterval(UiMgr.toggleTitleInterval);
	setTimeout(UiMgr._doStopToggleTitle, 200); // seems to be required in some cases to delay this
};

p._doStopToggleTitle=function() {
	$(document).attr("title", UiMgr.toggleTitleOnText);
	UiMgr.isTitleToggledOn=true;
};







p.pinEntryForAuthComplete=function() {
	var pinVal=PinPad.lastUserEnteredPin;
	PinPad.lastUserEnteredPin="";
	var validPin=PinPad.validatePin("auth", pinVal);
	if (validPin) {
		//we're ready to attempt authentication:
		// remember that whenever we open a dialog before communicating with the server, we have to put that server-
		// communicating code in a timeout; otherwise, on some mobile devices, the dialog will never show up.
		DialogMgr.openBlockingModalDialog("Signing you in...", UiMgr.expectedAuthTimeMillis);
		setTimeout(function(){
			var dataMap={};
			try {
				// The handler we're about to talk to requires that we get a nonce from the server, generate our 
				// own nonce, and hash them with the PIN, then set those values in the form, so:
				//CommMgr.addNonceAndHashToAjaxDataObject(UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, dataMap, pinVal);
			}
			catch (e) {
				// Didn't work; user probably lost internet connection (or has an extremely slow one):
				DialogMgr.closeBlockingModalDialog();
				console.error(e);
				DialogMgr.alert("It looks like you don't have an internet connection.  Please wait a bit, then try again.");
				return;
			}
			// Attempt the login:
			if (UiMgr.imageAuthentication.chosenImageKeyHexBytes!=null && UiMgr.imageAuthentication.chosenImageKeyHexBytes.length>0) {
				dataMap.leadingBytesHex=UiMgr.imageAuthentication.chosenImageKeyHexBytes;
				// it wasn't in local storage, so put it there for next time:
				ClientStorage.set(UiMgr.clientStorageKeyBytesKey, UiMgr.imageAuthentication.chosenImageKeyHexBytes);
				ClientStorage.set(UiMgr.clientStorageKeyAccountCreatedForBytesKey, "true");
			}
			else {
				// get it from local storage:
				dataMap.leadingBytesHex=ClientStorage.get(UiMgr.clientStorageKeyBytesKey);
			}
			dataMap.pin=pinVal;
			CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.LOG_IN_WITH_IMAGE_KEY, dataMap, true, 
				// success cb:
				function(response) {
				if (!response.success) {
					DialogMgr.closeBlockingModalDialog();
					var failureMsg;
					if (typeof response.failureDetailsMessage != "undefined" && response.failureDetailsMessage!=null) {
						failureMsg=response.failureDetailsMessage;
					}
					else {
						failureMsg="Your sign-in failed.  Please try again.  Make sure you are using the image key and the PIN you chose when you signed up.";

					}
					if (mobileApp) {
						$("#proposeRemoveMobileKeyFromDevice").show();
					}
					PinPad.clearPin();
					DialogMgr.alert(failureMsg);		
				}
				else {
					DialogMgr.closeBlockingModalDialog();
					if (window.enablePushNotifications && response.sendUuid && mobileApp) {
						// the server wants the UUID of this device:
						NotificationMgr.init();
					}
					
					//console.info("response.handle="+response.handle);


					if (!(typeof response.handle=="undefined" || response.handle==null || response.handle=="")) {
						UiMgr.currentAccountHandle=response.handle;
						UiMgr.currentAcctIsProfessionalClient=(window.professionalSite && response.currentAcctIsProfessionalClient);
					}
					UiMgr.setHandleDisplay(UiMgr.currentAccountHandle);
					//console.info("UiMgr.currentAccountHandle="+UiMgr.currentAccountHandle);


					UiMgr.unalertedPageExitOkay=false;

					UiMgr.doPostLoginActions(response);
				}			
				
			},
			// failure cb:
			CommMgr.defaultErrorCallback
			);
		}, 100);
		
	}
}; 




p.pinEntryForCreatingUserNewPinComplete=function() {
	var pinVal=PinPad.lastUserEnteredPin;
	PinPad.lastUserEnteredPin="";
	var validPin=PinPad.validatePin("creatingUserNewPin", pinVal);
	if (validPin) {
		UiMgr.creatingAccount.creatingUserChosenPin=pinVal;
		UiMgr.retrieveSecondUserTokens();
		if (window.useHandles) {
			UiMgr.showAuthPage('authNewAccountChooseHandle');
		}
		else {
			// skip over handles page, directly to account creation:
			UiMgr.createInitialUserAccount();
		}
		PinPad.hideAllInPagePinPads();
	}
};




p.addTunnelToExistingAccount=function(tunnelName) {
	DialogMgr.openBlockingModalDialog("Creating tunnel...");
	// first, we null out the UiMgr.creatingAccount object, because otherwise authCreateTunnelComplete will use data from it if found:
	UiMgr.creatingAccount=null;
	setTimeout(function() {
		var response=null;
		try {
			var dataMap={tunnelName:tunnelName};
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CREATE_TUNNEL_EXISTING_ACCOUNT, dataMap, false);
			DialogMgr.closeBlockingModalDialog();
			var localId=response.localId;
			TunnelMgr.addTunnel(
				response.localId, 
				tunnelName, 
				null, 
				null, 
				false, 
				false
			);
			UiMgr.lastCreatedTunnelClientId=response.localId;
			UiMgr.newTunnelExistingAccount.secondUserTempKey=response.secondAcctTempTextKey;
			UiMgr.newTunnelExistingAccount.secondUserSignupUrl=response.secondAcctTempSignupUrl;
			UiMgr.newTunnelExistingAccount.secondUserTempPin=response.secondAcctTempPin;
			UiMgr.showAuthPage("authCreateTunnelComplete");
			
		}
		catch (e) {
			response=null;
		}
		if (response==null || !response.success) {
			DialogMgr.closeBlockingModalDialog();
			DialogMgr.alert("There was a problem creating your tunnel; please make sure you have an internet connection.");
		}
	}, 100);

};


p.addTunnelToExistingProfessionalAccount=function(clientName, clientEmail, clientTel) {
	DialogMgr.openBlockingModalDialog("Creating "+UiMgr.skinnedSiteData.clientName.toLowerCase()+" tunnel...");
	// first, we null out the UiMgr.creatingAccount object, because otherwise authCreateTunnelComplete will use data from it if found:
	UiMgr.creatingAccount=null;
	setTimeout(function() {
		var response=null;
		try {
			var dataMap={tunnelName:clientName, clientName:clientName, clientEmail:clientEmail, clientTel:clientTel, professionalTunnel:true};
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CREATE_TUNNEL_EXISTING_ACCOUNT, dataMap, false);
			DialogMgr.closeBlockingModalDialog();
			var localId=response.localId;
			TunnelMgr.addTunnel(
				response.localId, 
				clientName, 
				null, 
				null, 
				false, 
				false
			);
			UiMgr.lastCreatedTunnelClientId=response.localId;
			UiMgr.newTunnelExistingAccount.secondUserTempKey=response.secondAcctTempTextKey;
			UiMgr.newTunnelExistingAccount.secondUserSignupUrl=response.secondAcctTempSignupUrl;
			UiMgr.newTunnelExistingAccount.secondUserTempPin=response.secondAcctTempPin;
			UiMgr.newTunnelExistingAccount.clientName=clientName;
			UiMgr.newTunnelExistingAccount.clientEmail=clientEmail;
			UiMgr.newTunnelExistingAccount.clientTel=clientTel;
			UiMgr.lastEnteredClientName=clientName;
			UiMgr.lastEnteredClientEmail=clientEmail;
			UiMgr.lastEnteredClientTel=clientTel;
			UiMgr.showAuthPage("authCreateProfessionalTunnelComplete");
			
		}
		catch (e) {
			console.info(e.name+" "+e.message);
			response=null;
		}
		if (response==null || !response.success) {
			DialogMgr.closeBlockingModalDialog();
			DialogMgr.alert("There was a problem creating your tunnel; please make sure you have an internet connection.");
		}
	}, 100);

};









p.addTunnelToExistingAccountWithHandleInvite=function(tunnelName, handle) {
	DialogMgr.openBlockingModalDialog("Creating tunnel with invite handle '"+handle+"'...");
	// first, we null out the UiMgr.creatingAccount object, because otherwise authCreateTunnelComplete will use data from it if found:
	UiMgr.creatingAccount=null;
	setTimeout(function() {
		var response=null;
		try {
			var dataMap={tunnelName:tunnelName, handle:handle};
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.CREATE_TUNNEL_EXISTING_ACCOUNT_WITH_HANDLE_INVITE, dataMap, false);
			DialogMgr.closeBlockingModalDialog();
			var localId=response.localId;
			var inviteeInviteAlreadyExisted=response.inviteeInviteAlreadyExisted; // the invitee had invited the inviter, so we just give the user an alert saying so and take them to the tunnel-list page:
			if (inviteeInviteAlreadyExisted) {
				DialogMgr.alert("That user has already created a tunnel for you to share; you may join the user in the \""+response.confidantCreatedTunnelName+"\" tunnel.", "ok", function() {
					TunnelMgr.addTunnel(
							response.localId, 
							response.confidantCreatedTunnelName, 
							null, 
							handle.toLowerCase(), 
							false, 
							false
						);
					UiMgr.lastCreatedTunnelClientId=response.localId;
					UiMgr.showAuthPage("authTunnelList");				
					
				});
			}
			else {
				DialogMgr.alert("The tunnel has been created. Please tell \""+handle.toLowerCase()+"\" to log into Tunnel X and join the tunnel by entering your handle ("+UiMgr.currentAccountHandle+").", "ok", function() {
					TunnelMgr.addTunnel(
							response.localId, 
							tunnelName, 
							null, 
							handle.toLowerCase(), 
							false, 
							false
						);
						UiMgr.lastCreatedTunnelClientId=response.localId;
						if (!professionalSite || !UiMgr.currentAcctIsProfessionalClient) {
							UiMgr.showAuthPage("authTunnelList");
						}
						else {
							TunnelMgr.singleTunnelAccountEnterTunnel();
						}
				});
			}
		}
		catch (e) {
			response=null;
		}
		if (response==null || !response.success) {
			DialogMgr.closeBlockingModalDialog();
			DialogMgr.alert("There was a problem creating your tunnel; please make sure you have an internet connection.");
		}
	}, 100);

};






p.promptForBackButtonAppExit=function() {
	DialogMgr.confirm("Pressing the back button closes the Tunnel X app.  Do you want to close the app?",
			function() {
				UiMgr.expressLogout();
				try {
					navigator.app.exitApp();
				}
				catch (e) {
					console.error("Could not exit app after back-button action using navigator.app.exitApp(); error="+e.mesage);
				}
			}, 
			null, 
			"Yes, close please", 
			"No, don't close"
		);
};

