

p.prettyFormatFilename=function(rawFilename) {
	var pretty;
	try {
		pretty=Core.urldecode(rawFilename).trim();
	}
	catch (e) {
		pretty=pretty.replace(/\%/g,"");
	}
	pretty=pretty.replace(/\+/g, "_");
	pretty=pretty.replace(/\=/g, "-");
	pretty=pretty.replace(/\?/g, "-");
	pretty=pretty.replace(/\&/g, "-");
	pretty=pretty.replace(/\;/g, "");
	pretty=pretty.replace(/\:/g, "-");
	pretty=pretty.replace(/\@/g, "-");
	pretty=pretty.replace(/\#/g, "-");
	pretty=pretty.replace(/\s/g, ""); // delete all whitespace
	if (pretty.indexOf("/")>-1) {
		pretty=pretty.substring(pretty.lastIndexOf("/")+1);
	}
	if (pretty.indexOf("\\")>-1) {
		pretty=pretty.substring(pretty.lastIndexOf("\\")+1);
	}
	return pretty;
	
};



p.goToHomepageAndResetUi=function(skipOnlineCheck) {
	if (typeof skipOnlineCheck=="undefined") {
		skipOnlineCheck=false;
	}
	DialogMgr.openBlockingModalDialog("One moment...");
	if (!skipOnlineCheck) {
		setTimeout(function() {
			// If we're not out of here in 10 seconds, we don't have an internet connection, so:
			DialogMgr.closeBlockingModalDialog();
			DialogMgr.alert("Can't return to the homepage; you don't appear to have an internet connection.");
		}, 10000);		
	}
	// note: DON'T CALL EXPRESSLOGOUT() HERE; that method calls this one.
	UiMgr.unalertedPageExitOkay=true;
	var newLoc=location.href;
	// no cachebuster for mobile app; iOS doesn't like (and it's not needed there anyway):
	if (!window.mobileApp) {
		if  (newLoc.indexOf("&cb=")>-1) {
			newLoc=newLoc.substring(0, newLoc.indexOf("&cb="));
		}
		else if  (newLoc.indexOf("?cb=")>-1) {
			newLoc=newLoc.substring(0, newLoc.indexOf("?cb="));
		}
		if (newLoc.indexOf("?")==-1) {
			newLoc+="?";
		}
		else {
			newLoc+="&";
		}
		newLoc+="cb="+new Date().getTime();		
	}
	if (newLoc.indexOf("#")>-1) {
		// Not sure when/if this ever happens, but if so, it's a disaster as far as trying to reload the page, because
		// the browser will just try to jump to a (nonexistent) a-name tag, not reloading anything, so:
		newLoc=newLoc.substring(0, newLoc.indexOf("#"));
	} 
	//console.info("calling location.replace() to "+newLoc);
	if (newLoc.indexOf("?tk=")>-1) {
		newLoc=newLoc.replace(/\?tk\=/, "?tkx=")
	}
	location.replace(newLoc);		
};





p.showAuthPage=function(id, exitCurrentTunnelIfAny) {
	console.info("showing page '"+id+"'");
	if (typeof exitCurrentTunnelIfAny == "undefined") {
		exitCurrentTunnelIfAny=true;
	}
	var deactivateFooterLogoLink=false; // set to true for any PIN page; we set this to the UiMgr at the end of the fn
	UiMgr.showAuthPages();
	var idFound=false;
	for (var i=0; i<UiMgr.authPageIds.length; i++) {
		UiMgr.authPages[UiMgr.authPageIds[i]][(id==UiMgr.authPageIds[i]?"show":"hide")]();
		if (UiMgr.authPageIds[i]==id) {
			idFound=true;
		}
	}
	if (!idFound) {
		throw new Error("Page with id "+id+" not in UiMgr.authPageIds.");
	}
	
	ScreenViewStack.add(id);

	

	
	// if we're in a tunnel, leave it (incuding telling the server we did that):
	if (exitCurrentTunnelIfAny) {
		TunnelMgr.exitTunnel(false);
	}
	
	
	// if the page we're viewing is the tunnel list, start the account updater; otherwise stop it:
	AccountUpdateRetriever[id=="authTunnelList"?"start":"stop"]();

	DialogMgr.closeBlockingModalDialog();
	
	// show the proper header element (an img or a div depending on skin):
	$("#authHomeHeader")[id=="authHome"?"show":"hide"]();
	$("#authNonHomeHeader")[id!="authHome"?"show":"hide"]();

	
	if (!mobileApp && skinCode=="tunnelx") {
		UiMgr.stopHpCarousel();
	}
	
	// handle page-specific setup:
	if (0==1) {} // leave this here; that way all "real" conditionals are else-if's; without this, we WILL have copy-n-paste issues.
	
	else if (id=="authHome") {
		$("#authHomeAccessCode label").show();
		if (!mobileApp && skinCode=="tunnelx") {
			UiMgr.startHpCarousel();
			UiMgr.startHpCarousel2();
		}
	}
	else if (id=="authCreatingUserUploadNewImageKey") {
		ImageKeyUploader.startUseForPage(id);
		$("#uploadImageTextboxWithLabel label").show()
	}
	
	else if (id=="authSecondUserUploadNewImageKey") {
		ImageKeyUploader.startUseForPage(id);
		$("#uploadImageTextboxWithLabel label").show()
	}
	
	else if (id=="authExistingAccountUploadNewDeviceImageKey") {
		ImageKeyUploader.startUseForPage(id);
		$("#uploadImageTextboxWithLabel label").show()
	}
	
	else if (id=="authTunnelList") {
		// we always show this page initially in "add" mode:
		TunnelMgr.switchAddDeleteMode("add");
		var tunnelsExist=(TunnelMgr.getTunnelsCount()>0);
		$("#tunnelListNoTunnelsMsg")[tunnelsExist?"hide":"show"]();
		$("#tunnelListPlusMinusButtons")[!tunnelsExist?"hide":"show"]();
		
		

	}

	else if (id=="authCreateTunnelOrEnterPasscode") {
		$("#authCreateTunnelOrPasscodePassEntryWithLabel label").show();
	}
	

	else if (id=="authNameNonFirstTunnel") {
		$("#textboxWithOverlayLabel_nonFirstTunnelName label").show();
		$("#tunnelInviteeHandle label").show();
		$("#tunnelInviteeHandleWrapper").hide();
		$("#inviteByHandle").prop("checked", false);
	}

	
	else if (id=="authNewAccountChooseHandle") {
		$("#textboxWithOverlayLabel_creatingUserHandle label").show();
	}

	/*
	else if (id=="authNameSelf") {
		$("#authNameSelfEntryWithLabel label").show();
	}
	*/
	
	else if (id=="authCreatingUserChoosePin") {
		var msg="<br/>You will also use a six-digit PIN to<br/>sign in. Pick one, then click \"next.\""; 
		if (window.mobileApp) {
			msg="choose your pin";
		}
		PinPad.showInPagePinPad(true, "authCreatingUserChoosePinPinHolder", "next", false, ClickHandlers.authCreatingUserChoosePinSubmit, msg);
		deactivateFooterLogoLink=true;
	}
	else if (id=="authImportAccountEnterExistingPin") {
		var msg="<br/>Enter your six-digit PIN.";
		if (window.mobileApp) {
			msg="enter your PIN";
		}

		PinPad.showInPagePinPad(false, "authImportAccountEnterExistingPinPinHolder", null, true, ClickHandlers.authSecondUserEnterTempPinSubmit, msg);
		deactivateFooterLogoLink=true;
	}
	
	
	else if (id=="authChooseKey") {
	}
	else if (id=="authChooseNickname") {
		$("#newTunnelCreatingUserNickname").focus();
	}
	else if (id=="authCreateTunnelComplete") {
		var newAccount=(UiMgr.creatingAccount!=null);
		if (!mobileApp) {
			$("#tunnelCreationCompleteNewAccountText")[newAccount?"show":"hide"]();
			$("#tunnelCreationCompleteExistingAccountText")[newAccount?"hide":"show"]();
			if (newAccount) {
				$("#tunnelCompletePageHandle").html(UiMgr.currentAccountHandle);
				$("#tunnelCompletePageImageKeyName").html(ImageKeyUploader.lastFilenameOnlyUploaded);
				$("#tunnelCompletePagePIN").html(UiMgr.numericPinFromTokens(UiMgr.creatingAccount.creatingUserChosenPin));
			}
		}
		// page is used both during initial account-and-first-tunnel creation, as well as for in-account tunnel creation,
		// so check first to see if we have new-account data to show; if not, show new-tunnel data:
		if (newAccount) {
			// we are in the new-account-and-first-tunnel path:
			$("#authCreateTunnelCompleteForm #secondUserTempKey").html(UiMgr.creatingAccount.secondUserTempKey);
			$("#authCreateTunnelCompleteForm #secondUserSignupUrl").html(UiMgr.creatingAccount.secondUserSignupUrl);
			//$("#authCreateTunnelCompleteForm #secondUserTempPin").html(UiMgr.creatingAccount.secondUserTempPin);			
		}
		else {
			// the user is creating a non-first tunnel in their account:
			if (UiMgr.newTunnelExistingAccount==null || UiMgr.newTunnelExistingAccount.secondUserTempKey==null) {
				throw new Error("UiMgr.newTunnelExistingAccount or UiMgr.newTunnelExistingAccount.secondUserTempKey was null.");
			}
			$("#authCreateTunnelCompleteForm #secondUserTempKey").html(UiMgr.newTunnelExistingAccount.secondUserTempKey);
			$("#authCreateTunnelCompleteForm #secondUserSignupUrl").html(UiMgr.newTunnelExistingAccount.secondUserSignupUrl);
			$("#authCreateTunnelCompleteForm #secondUserTempPin").html(UiMgr.newTunnelExistingAccount.secondUserTempPin);						
		}
	}
	else if (id=="authCreateProfessionalTunnelComplete") {
		$("#authCreateProfessionalTunnelCompleteForm #professionalClientName").html(UiMgr.newTunnelExistingAccount.clientName);
		$("#authCreateProfessionalTunnelCompleteForm #secondUserTempKey").html(UiMgr.newTunnelExistingAccount.secondUserTempKey);
	}
	
	
	else if (id=="authUploadExistingImageKey") {
		ImageKeyUploader.startUseForPage(id);
		$("#uploadImageTextboxWithLabel label").show();
	}
	else if (id=="authChooseExistingPin") {
		var msg="<br/>Enter your PIN by clicking the numbers";
		if (window.mobileApp) {
			msg="enter your pin";
		}
		PinPad.showInPagePinPad(false, "authChooseExistingPinPinHolder", null, true, UiMgr.pinEntryForAuthComplete, msg);
		deactivateFooterLogoLink=true;
	}

	

	else if (id=="authChoosePin") {
		PinPad.showInPagePinPad(true, "tunnelCreatorPinChoiceEntry");
		deactivateFooterLogoLink=true;
	}
	else if (id=="authSecondUserChoosePin") {
		var msg="<br/>You will also use a six-digit PIN to<br/>sign in. Pick one, then click \"next.\"";
		if (window.mobileApp) {
			msg="choose a PIN";
		}

		PinPad.showInPagePinPad(true, "authSecondUserChoosePinPinHolder", "next", false, ClickHandlers.authSecondUserChoosePinSubmit, msg);

		deactivateFooterLogoLink=true;
	}
	UiMgr.confirmBeforeUiReset=(id!="authHome");
	UiMgr.currentAuthPage=id;
	// no: we actually always have the footer link activated; otherwise we are in danger of deadending users of the mobile app:
	//UiMgr.deactivatedFooterLogoLink=deactivateFooterLogoLink;
	UiMgr.refreshFooterLogoBehavior();
	if (window.mobileApp) {
		UiMgr.showAlltextboxWithOverlayLabelLabels();
		// for mobile, we hide the footer logo and exit icon if we're on the homepage, show it otherwise:
		$("#footerLogo")[id=="authHome"?"hide":"show"]();
		// We USED to do this: exit link was for all pages but homepage...
		//UiMgr.showFooterIcon("exit", (id!="authHome"));
		// ...but now, we only show it when user is logged in:
		UiMgr.showFooterIcon("exit", UiMgr.isAcctLoggedIn());
		// this will affect some skins and not others:
	}
	else {
		if (id!="authHome" && window.skinnedUi) {
			$("#contentWrapper").css("background-image", "url(/static/skins/"+window.skinCode+"/images/mainBg.jpg)");			
		}
	}
};

p.numericPinFromTokens=function(tokens) {
	var s="";
	var c;
	for (var i=0; i<6; i++) {
		c=tokens.charAt(i);
		s+=PinPad.pinButtonTokensToDigitsMap.get(c);
	}
	return s;
};

p.showAlltextboxWithOverlayLabelLabels=function() {
	$(".textboxWithOverlayLabel label").show();
};



p.goPreviousScreen=function() {
	// if the user is in a tunnel, leave it:
	if (ScreenViewStack.getCurrentScreenId().startsWith("messengerUi")) {
		TunnelMgr.exitTunnel(true);
	}
	else {
		try {
			UiMgr.showAuthPage(ScreenViewStack.getPreviousScreenId());
		}
		catch (e) {}
	}
	return false;

};







p.resizeMobileAlertHeight=function() {
	//console.info("resizeMobileAlertHeight() called");
	var viewportHt=$(window).height();
	var offset=0;
	$("#mobileModalDialog").css("height", ""+(viewportHt-offset)+"px");
};


p.resizeTunnelListWrapper=function() {
	//console.info("resizeTunnelListWrapper() called");
	// it's overflow-scrollable on the y axis, but it needs a fixed height for that --
	var wrapperParentHeightPx=$("#wrapperTableInnerDiv").height();
	var listWrapperTopLevelBaseSelector="#";
	if (window.mobileApp) {
		listWrapperTopLevelBaseSelector+="mobileTunnelListWrapper";
	}
	else {
		listWrapperTopLevelBaseSelector+="tunnelListWrapper";		
	}

	$(listWrapperTopLevelBaseSelector).css("height", ""+wrapperParentHeightPx+"px");
};
 


p.resizeMobileFullbleedPages=function() {
	//console.info("resizeMobileFullbleedPages() called");
	var viewportHt=$(window).height();
	$(".pageContentWrapper.fullBleed").css("height", ""+(viewportHt-45)+"px");
};



p.updateAcctPrefsUi=function(response) {
	try {
		//alert("setting fontAcctPref to "+""+UiMgr.acctPrefs.fontAcctPref);
		$("#fontAcctPref").val(""+UiMgr.acctPrefs.fontAcctPref);
		$("#fontSizeAcctPref").val(""+UiMgr.acctPrefs.fontSizeAcctPref);
		$("#autoExitAfterMinutesAcctPref").val(""+UiMgr.acctPrefs.autoExitAfterMinutesAcctPref);
		if (window.enablePushNotifications) {
			$("#doNotificationsAcctPref").val(""+UiMgr.acctPrefs.doNotificationsAcctPref);			
		}
		
		
		if (!window.mobileApp) { // setting is not present on mobiles
			$("#sendMessageOnEnterAcctPref").val(""+UiMgr.acctPrefs.sendMessageOnEnterAcctPref);			
		}
		if (window.mobileApp) { // setting is only present on mobiles
			$("#useVirtualKBForMobileAcctPref").val(""+UiMgr.acctPrefs.useVirtualKBForMobileAcctPref);			
		}
		
		
		MessengerMgr.updateMessengerFontSizeAndFace();
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}	
};



p.resizeWrapperTableInnerDiv=function(resizeMainUi) {
	resizeMainUi=(typeof resizeMainUi=="undefined"?false:resizeMainUi);
	//console.info("resizeWrapperTableInnerDiv() called (resizeMainUi="+resizeMainUi+")");

	try {
		if (!UiMgr.ignoreResizeEvent) {
			var wrapperTableInnerDiv=$("#wrapperTableInnerDiv");
			var mainUiTable=$("#mainUiTable");
			wrapperTableInnerDiv.hide();
			if (resizeMainUi) {
				mainUiTable.hide();
			}
			
			var viewportHt=$("#wrapperTableInnerDivTd").height(); // the height of the td that contains this
			//alert("viewportHt="+viewportHt);
			var offset=0;
			var ht=viewportHt-offset;
			ht=(ht<100?100:ht);
			wrapperTableInnerDiv.css("height", ""+(ht+"px"));
			if (resizeMainUi) {
				mainUiTable.css("height", ""+(ht+"px"));
			}
			
			
			//alert("wrapperTableInnerDiv.css(\"height\")="+wrapperTableInnerDiv.css("height"));
			wrapperTableInnerDiv.show();
			if (resizeMainUi) {
				mainUiTable.show();
			}
			
			// now that we've rezised this properly, we can also (mobile only) resize the authPageWrappersWrapper div, which
			// needs to have a height such that it pushes our footer links (not the actual footer; the links, such as about, TOS,
			// etc.) down to their proper location on the page.  So:
			if (window.mobileApp) {
				$("#authPageWrappersWrapper").css("height", ""+(ht-0)+"px");
			}
		}
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}
};


// Annoying.
p.androidNativeBrowserTextboxFocusWorkaround=function() {
	try {
		clearTimeout(UiMgr.ignoreResizeEventTimeout);
		UiMgr.ignoreResizeEvent=true;
		UiMgr.ignoreResizeEventTimeout=setTimeout(function() {UiMgr.ignoreResizeEvent=false;}, 800);
	}
	catch (__ee) {
		alertJavaScriptErrorIfConfigured(__ee); throw _ee;
	}

};




p.registerWindowActivity=function() {
	UiMgr.lastActivityTimeMillis=new Date().getTime();
};




p.clearAllTransparentUploadFileForms=function() {
	// nuke previous forms we've dynamically written (slightly ugly not to be keeping track, but this is safest: if we
	// end up with two image-upload forms on the page at once, we're screwed, and with a bug that will take forever to
	// track down.  (Note that this is here rather than in ImageKeyUploader or MessengerMgr because it applies to both
	// classes.)
	var codes=ImageKeyUploader.allowedPageCodes.keysArray();
	for (var i=0; i<codes.length; i++) {
		$("#transparentFileUploadFieldWrapper_"+codes[i]).html("&nbsp;");
	}
	// now do the special case (media-upload button in the compose pane):
	$("#transparentMediaFileUploadFieldWrapper").html("&nbsp;");
};





p.goAboutBlank=function() {
	// before we go anywhere, hide all page elements:
	try {
		$("body").hide();
	}
	catch (errorWeCantDoAnythingAbout) {}
	
	// clear all form fields:
	UiMgr.clearAllNonFileUploadFormFields();
	ImageKeyUploader.clearFileUploadFormFields();
	
	// null out all objects on this page which contain any data:
	try {
		window.MessengerMgr=null;	
		window.CommMgr=null;
		window.TunnelMgr=null;
		window.ImageKeyUploader=null;
		window.DialogMgr=null;
		window.UiMgr=null;
	}
	catch (errorWeCantDoAnythingAbout) {}

	
	try {
		// in Chrome (unbelievably), redirecting to about:blank leaves the title of the old doc as the title of the blank page, so:
		document.title="about:blank";
	}
	catch (errorWeCantDoAnythingAbout) {}
	try {
		location.replace("about:blank");
	}
	catch (e) {
		try {
			location.replace("blank/");
		}
		catch (errorWeCantDoAnythingAbout) {} // we may have left the page by now, which will result in a JS error in some browsers.
	}
};





p.showAuthPages=function() {
	MediaUploader.reset();
	UiMgr.clearAllNonFileUploadFormFields();
	$("#authPages").show();
	$("#mainUiTable").hide();
	if (window.mobileApp) {
		$("#conversationUiHeader").hide();
		UiMgr.toggleMobileFooter(false);
	}
	$("#nonAuthUiPages").hide();
};


p.showNonAuthUiPage=function(id) {
	if (id=="settings") {
		// we handle settings the "old way" (in-page); others, we do in an alert box --
		ScreenViewStack.add(id);
		UiMgr.clearAllNonFileUploadFormFields();
		UiMgr.showSettingsSubPage("defaultSettingsSubPage"); // ensure main settings page, not add-a-device page, is visible
		$("#nonAuthUiPages").show();
		for (var i=0; i<UiMgr.nonAuthUiPageIds.length; i++) {
			$("#nonAuthUiPages #"+UiMgr.nonAuthUiPageIds[i])[id==UiMgr.nonAuthUiPageIds[i]?"show":"hide"]();
		}
		$("#authPages").hide();
		$("#mainUiTable").hide();
		
		if (!UiMgr.nonAuthUiPageIdsToLoadeds[id]) {
			response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.GET_CONTENT, {contentCode:id}, false);
			$("#nonAuthUiPages #"+id+" #content").html(response.content);
			UiMgr.nonAuthUiPageIdsToLoadeds[id]=true;
		}
	}
	else {
		DialogMgr.openBlockingModalDialog("Loading content, please wait...");
		setTimeout("UiMgr._openContentAndCloseModalDialog('"+id+"')", 50);
	}
	UiMgr.currentAuthPage=null;
};


p.showSettingsSubPage=function(id) {
	if (id=="defaultSettingsSubPage") {
		UiMgr.setUpSettingsTunnelSelectMenu();
	}
	else if (id=="addADeviceSubPage") {
		$("#addADevicePassphrase").html("&nbsp;");
	}
	else if (id=="backupKeySubPage") {
		$("#backupKeyPassphrase").html("&nbsp;");
	}
	else if (id=="removeFromDeviceSubPage") {
		// nothing
	}
	else if (id=="changeHandleSubPage") {
		$("#textboxWithOverlayLabel_existingAccountChangedHandle label").show();
		$("#existingAccountChangedHandle").val("");
	}
	else if (id=="changeProOriginatingNameSubPage") {
		$("#textboxWithOverlayLabel_existingAccountChangedProOriginatingName label").show();
		$("#existingAccountChangedProOriginatingName").val("");
	}
	else if (id=="changeTunnelSettingsSubPage") {
		$("#textboxWithOverlayLabel_newTunnelName label").show();
		$("#newTunnelName").val("");
	}
	else if (id=="managePaymentsSubPage") {
		UiMgr.setUpManagePaymentsSubPage();
	}
	
	
	
	var subpageIds=["defaultSettingsSubPage","addADeviceSubPage","removeFromDeviceSubPage","changeHandleSubPage","changeTunnelSettingsSubPage","changeProOriginatingNameSubPage","managePaymentsSubPage","backupKeySubPage"];
	for (var i=0; i<subpageIds.length; i++) {
		$("#"+subpageIds[i])[subpageIds[i]==id?"show":"hide"]();
	}
};





p.setUpManagePaymentsSubPage=function() {
	var textBlockIds=["paymentNotSetUp_inFreePeriod","paymentNotSetUp_pastFreePeriod","paymentSetUp_paymentCurrent","paymentSetUp_paymentPastDue"];
	var response=null;
	try {
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.GET_PRO_PAYMENT_DATA, {}, false);
	}
	catch (e) {
		response={success:false};
	}
	
	if (!response.success) {
		DialogMgr.alert("Can't retrieve your payment information right now; please try later.");
		return;
	}
	
	var paymentSetUp=response.paymentSetUp;
	var paymentStatusCurrent=response.paymentStatusCurrent;
	var monthlyAmountFormatted=response.monthlyAmountFormatted;
	var daysLeftOrPast=response.daysLeftOrPast;
	var freeIntroDays=response.freeIntroDays;
	
	var blockIdToShow;
	var showPaypalButton=false;
	if (paymentSetUp) {
		blockIdToShow="paymentSetUp_";
		if (paymentStatusCurrent) {
			blockIdToShow+="paymentCurrent";
		}
		else {
			blockIdToShow+="paymentPastDue";
		}
	}
	else {
		blockIdToShow="paymentNotSetUp_";
		if (paymentStatusCurrent) {
			showPaypalButton=true;
			blockIdToShow+="inFreePeriod";
		}
		else {
			blockIdToShow+="pastFreePeriod";
		}
	}
	for (var i=0; i<textBlockIds.length; i++) {
		$("#managePaymentsSubPage #"+textBlockIds[i])[textBlockIds[i]==blockIdToShow?"show":"hide"]();
	}
	$("#managePaymentsSubPage #"+blockIdToShow+" #monthlyAmountFormatted").html(monthlyAmountFormatted);
	$("#managePaymentsSubPage #"+blockIdToShow+" #daysLeftOrPast").html(daysLeftOrPast);
	$("#managePaymentsSubPage #"+blockIdToShow+" #freeIntroDays").html(freeIntroDays);
	$("#managePaymentsSubPage #paypalPaymentArrowButtonLink")[showPaypalButton?"show":"hide"]();
	var paypalUrl="";
	if (showPaypalButton) {
		paypalUrl=response.paypalUrl;
	}
	$("#managePaymentsSubPage #paypalPaymentArrowButtonLink").prop("href", paypalUrl);
	
	
	
	
	
};


p.setUpTunnelSettingsSubPageForTunnel=function(tunnelId) {
	UiMgr.tunnelIdCurrentlyEditingInSettings=tunnelId;
	var editingTunnelName=TunnelMgr.getTunnelAttribute(tunnelId, "name");
	$("#changeTunnelSettingsLabel").html(editingTunnelName);
	$("#deleteTunnelSettingsLabel").html(editingTunnelName);
};

p.setUpSettingsTunnelSelectMenu=function() {
	var tunnelIds=TunnelMgr.getTunnelIdsToTunnelsMap().keysArray();
	var selectEl=$("#settingsChooseTunnel");
	selectEl.empty();
	var option=$("<option></option>").attr("value", "none_chosen").text("...");
	selectEl.append(option);
	var tunnel;
	for (var i=0; i<tunnelIds.length; i++) {
		option=$("<option></option>").attr("value", tunnelIds[i]).text(TunnelMgr.getTunnelAttribute(tunnelIds[i], "name"));
		selectEl.append(option);
	}
};



p._openContentAndCloseModalDialog=function(id) {
	if (!UiMgr.nonAuthUiPageIdsToLoadeds[id]) {
		response=CommMgr.initiateAjaxRequest(CommMgr.getControlServer(), UiMgr.handlerKeys.GET_CONTENT, {contentCode:id}, false);
		UiMgr.nonAuthUiPageIdsToLoadeds[id]=true;
		UiMgr.nonAuthUiPageIdsToContents[id]=response.content;
	}
	DialogMgr.closeBlockingModalDialog();
	DialogMgr.openCustomDialog(UiMgr.nonAuthUiPageIdsToContents[id], (window.mobileApp?280:780), parseInt($(window).height())-100, "", "Close", null, null, null, true, null);
};
p.registerWindowFocusState=function(focused) {
	UiMgr.windowHasFocus=focused;
	try {
		$("#windowHasFocusVarValue").html(""+UiMgr.windowHasFocus);
	}
	catch (e) {}
	//DialogMgr.alert(focused);
};



p.playVid=function(anchorId, fqYoutubeLink) {
	if (!anchorId.endsWith("Anchor")) {
		throw new Error("anchorId must have format 'nameOfVideoAnchor'; this anchorId does not end with 'Anchor'.");
	}
	var vidCode=anchorId.substring(0, anchorId.lastIndexOf("Anchor"));
	var innerVidWrapperHtml="<video style=\"text-align:center;\" class=\"vidTag\" width=\"640\" height=\"360\" controls autoplay>"
		+"<source src=\""+window.pathToStaticContent+"/video/"+vidCode+".mp4\" type=\"video/mp4\">"
		+"<source src=\""+window.pathToStaticContent+"/video/"+vidCode+".ogv\" type=\"video/ogg\">"
		+"<source src=\""+window.pathToStaticContent+"/video/"+vidCode+".ogg\" type=\"video/ogg\">"
		+"<div style=\"width:80%; margin:120px auto 0 auto; text-align:center;\">Hmm, your browser doesn't support the 'video' tag for any of the video formats we offer, but all is not lost!  You can view this video on Youtube <a href=\""+fqYoutubeLink+"\" target=\"_blank\">here</a>.</div>"
		+"</video>"
	;
	$("#"+vidCode+"VidWrapper .vidStill").hide();
	$("#"+vidCode+"VidWrapper .innerVidWrapper").show();
	$("#"+vidCode+"VidWrapper .innerVidWrapper").html(innerVidWrapperHtml);
	
};


p.repopCopyableFormEl=function(nativeFormEl, value, doSelect) {
	var formEl=$(nativeFormEl);
	formEl.val(value);
	if (doSelect) {
		try {
			formEl.select();
		}
		catch (e) {}		
	}
};






// Called onerror of an <img> that has an SVG (for mobile) source; some browsers don't support SVG, so we fall back to a PNG.
// E.g. if image_mobile.svg fails (they always have that naming convention), we attempt to load image_mobileSvgFallback.png.
// Whenever we save an SVG, we also save a "_mobileSvgFallback.png" PNG version.  So:
p.doSvgMobileFallback=function(imgEl) {
	try {
		imgEl.onerror=null;
		if (!window.mobileApp) {
			return;
		}
		var imgElSrc=imgEl.src;
		if (!imgElSrc.endsWith(".svg")) {
			return;
		}
		imgElSrc=imgElSrc.replace(/\_mobile.svg/, "_mobile.png");
		imgEl.src=imgElSrc;
	}
	catch (e) {}		
};


p.textboxLabelClick=function(elementId) {
	$("#textboxWithOverlayLabel_"+elementId+" label").hide();
	$("#textboxWithOverlayLabel_"+elementId+" #"+elementId).focus();
};

p.labelledTextboxFocus=function(elementId) {
	$("#textboxWithOverlayLabel_"+elementId+" label").hide();
};

p.labelledTextboxBlur=function(elementId) {
	UiMgr._showOrHideLabelledTextboxLabel(elementId);
};

p._showOrHideLabelledTextboxLabel=function(elementId) {
	var value=$("#textboxWithOverlayLabel_"+elementId+" #"+elementId).val().trim();
	$("#textboxWithOverlayLabel_"+elementId+" label")[value.length>0?"hide":"show"]();

};



p.clearAllNonFileUploadFormFields=function() {
	UiMgr._clearFormFields(false);
};

/**
 * Clears either all form fields NOT part of the file upload form, or ONLY form fields part of the file upload form, depending
 * on the value of the fileUploadForm boolean.
 */
p._clearFormFields=function(fileUploadForm) {
	var s="";
	$("form").each(
		function() {
			var formName=$(this).attr("name");
			if (formName!="proClientInfo") { // special case; we don't clear this form
				var doClear=(formName!="fileUploadForm");
				if (fileUploadForm) {
					doClear=!doClear;
				}
				if (formName!="fileUploadForm") {
					$("#"+formName+" input, #"+formName+" textarea").each(
						function() {
							$(this).val("");
						}
					);				
				}
				
			}
		}
	);
	// make sure to clear the cordova upload file input if necessary
	if (window.useCordovaFilePluginForUploads) {
		$("#cordovaFileUri").val("");
	}
};



p.setHandleDisplay=function(handle) {
	var rawHandleStr=(UiMgr.currentAccountHandle==null?"[not set]":UiMgr.currentAccountHandle);
	var handleStr;
	var selectors=["#settingsHandleLabel", "#desktopFooterHandleLabel", "#settingsHandleLabelForSubPage"];
	for (var i=0; i<selectors.length; i++) {
		if ($(selectors[i]).html()!=null) {
			if (selectors[i]=="#desktopFooterHandleLabel") {
				handleStr="&nbsp;&nbsp;|&nbsp;&nbsp;You:&nbsp;<span style=\"color:#ffffff;\">"+rawHandleStr+"</span>";
			}
			else {
				handleStr=rawHandleStr;
			}
			$(selectors[i]).html(handleStr);
		}
	}	
};




p.proTabClick=function(tabId) {
	UiMgr.setProMessengerUiPerComponentId(tabId);
};



p.setProMessengerUiPerComponentId=function(id) {
	if (!professionalSite) {
		return;
	}
	var tabIds=["messages","info","notes"];
	var contentContainerIds=["conversationHistory","proClientInfo","proClientNotes"];
	for (var i=0; i<tabIds.length; i++) {
		$("#messengerUiTabs #"+tabIds[i])[id!=tabIds[i]?"addClass":"removeClass"]("nonCurrent");
		$("#conversationHistoryParent #"+contentContainerIds[i])[id!=tabIds[i]?"hide":"show"]();
	}
	$("#editorContainerParentTd").css("opacity", id=="info"?"0.5":"1.0");
	if (!mobileApp) {
		CKEDITOR.instances["msgCompose"].setReadOnly(id=="info");		
	}
	if (id=="messages") {
		MessengerMgr.currentMessageType="standard";
	}
	else if (id=="info") {
		MessengerMgr.currentMessageType="none";
	}
	else if (id=="notes") {
		MessengerMgr.currentMessageType="pro-note";
	}
};


p.startHpCarousel=function() {
	UiMgr.stopHpCarousel(); // just in case
	UiMgr.switchHpCarousel();
	UiMgr.hpCarouselInterval=setInterval(UiMgr.switchHpCarousel, 5000);
};

p.stopHpCarousel=function() {
	clearInterval(UiMgr.hpCarouselInterval);
};

p.switchHpCarousel=function() {
	// rotate the indices:
	var newIdx;
	for (var i=0; i<numCarouselImages; i++) {
		newIdx=UiMgr.hpCarouselIndicesToIds[i]+1;
		if (newIdx==numCarouselImages) {
			newIdx=0;
		}
		UiMgr.hpCarouselIndicesToIds[i]=newIdx;
	}
	var zIndex;
	var jqImg;

	for (var i=0; i<numCarouselImages; i++) {
		jqImg=$("#hpCarouselImg"+i);
		zIndex=UiMgr.hpCarouselIndicesToIds[i]+1;
		jqImg.css("zIndex", zIndex);
		if (zIndex==numCarouselImages) {
			jqImg.fadeOut(1000);
		}
		else {
			jqImg.show();
		}
		
	}

};




/*
 Following three methods are a NEAR DUPLICATION!!!!!!! of the above three.  Very ugly; did this in a hurry to get
 the homepage changes up.  All works great, but obviously it's a hack; needs to be fixed at some point.
 */
p.startHpCarousel2=function() {
	UiMgr.stopHpCarousel2(); // just in case
	UiMgr.switchHpCarousel2();
	UiMgr.hpCarouselInterval2=setInterval(UiMgr.switchHpCarousel2, 4000);
};

p.stopHpCarousel2=function() {
	clearInterval(UiMgr.hpCarouselInterval2);
};

p.switchHpCarousel2=function() {
	// rotate the indices:
	var newIdx;
	for (var i=0; i<numCarouselImages2; i++) {
		newIdx=UiMgr.hpCarouselIndicesToIds2[i]+1;
		if (newIdx==numCarouselImages2) {
			newIdx=0;
		}
		UiMgr.hpCarouselIndicesToIds2[i]=newIdx;
	}
	var zIndex;
	var jqImg;

	for (var i=0; i<numCarouselImages2; i++) {
		jqImg=$("#hpCarouselImg2"+i);
		zIndex=UiMgr.hpCarouselIndicesToIds2[i]+1;
		jqImg.css("zIndex", zIndex);
		if (zIndex==numCarouselImages2) {
			jqImg.fadeOut(1000);
		}
		else {
			jqImg.show();
		}
		
	}

};



// not currently used; leaving in if we need in future
/*
p.updateDebugPaneForUpdaters=function() {
	for (var i=0; i<UiMgr.updaterDebugCodes.length; i++) {
		$("#testLoggerDiv #"+UiMgr.updaterDebugCodes[i]+"Status").html(UiMgr.debugUpdaterRequestsCount[UiMgr.updaterDebugCodes[i]]);
	}
};
*/



