
/**
 * Hide all footer icons
 */
p.hideAllFooterIcons=function() {
	var keys=UiMgr._footerIconCodesToVisibilities.keysArray();
	for (var i=0; i<keys.length; i++) {
		UiMgr._footerIconCodesToVisibilities.put(keys[i], false);
	}	
	UiMgr._refreshFooterIconVisibilities();
};

/**
 * Show or hide a footer icon (calling on an unrecognized code -- or a code which doesn't apply to this platform, e.g. an icon 
 * used only on desktop but not mobile site/app -- has no effect and causes no errors).
 * @param the icon's key (e.g. "exit")
 * @param boolean true to show, false to hide
 */
p.showFooterIcon=function(code, visible) {
	if (UiMgr._footerIconCodesToVisibilities.get(code)!=null) {
		UiMgr._footerIconCodesToVisibilities.put(code, visible);
		UiMgr._refreshFooterIconVisibilities();		
	}
};


/**
 * Switches betwween the small social links (bottom of the footer to the left of text links) being visible
 * and larger links (centered above text links) beiing visible.  Code assumes that we start with large links
 * visible; also asssumes that exactly one set of links is visible at one time
 * @param smallVisible boolean true means small visible, false means large visible
 */
p.switchFooterSocialLinksVisibility=function(smallVisible) {
	$(".footerSocialLinkImg")[smallVisible?"show":"hide"]();
	$("#postSmallSocialLinksPipe")[smallVisible?"show":"hide"]();
	$("#largeSocialLinks")[smallVisible?"hide":"show"]();	
};





p._refreshFooterIconVisibilities=function() {
	var keys=UiMgr._footerIconCodesToVisibilities.keysArray();
	for (var i=0; i<keys.length; i++) {
		try {
			$("#footerIcons #footerButton_"+keys[i])[UiMgr._footerIconCodesToVisibilities.get(keys[i])?"show":"hide"]();
		}
		catch (e) {}
	}
};


//misnomer; this doesn't really refresh behavior; it just changes the css of the footer link depending on whether it does anything; the
//behavior happens in ClickHandlers.footerLogoClick() --
p.refreshFooterLogoBehavior=function() {
	// no: it's always active, lest we deadend users:
	//$("#footerLogo").css("cursor", UiMgr.deactivatedFooterLogoLink?"default":"pointer");
	$("#footerLogo").css("cursor", "pointer");
};




/** Toggles the footer-nav and editor as what's currently visible in the footer area
 * @param showEditor true to show the editor, false to show the footer-nav elements
 */
p.toggleMobileFooter=function(showEditor) {
	$("#footerAreaContainer #footerTable")[showEditor?"hide":"show"]();
	$("#footerAreaContainer #mobileEditorContainer")[!showEditor?"hide":"show"]();
};

/**
 * @param true if mouseover, false if mouseout
 * @param the id of the caller, which has the format "footerButton_exit"
 */
p.footerLinkMouseOverOut=function(mouseover, callerId) {
	UiMgr.authPageContextHelp(callerId, mouseover);

	/*
	var id=callerId.substring(footerButtonIdPrefix.length);
	var ids=UiMgr._footerIconCodesToVisibilities.keysArray();
	for (var i=0; i<ids.length; i++) {
		$("#footerLinkRolloverTexts #"+ids[i])[!mouseover || ids[i]!=id?"hide":"show"]();
	}
	// hide the contextual-help text:
	$("#footerLinkRolloverTexts #contextualHelp").hide();
	$("#footerLinkRolloverTexts")[!mouseover?"hide":"show"]();
	*/
};




p.authPageContextHelp=function(helpCode, show) {
	var msg="&nbsp;";
	var codeRecognized=true;
	if (show) {
		switch (helpCode) {
		case "footerButton_exit": {msg="Sign Out"; break;}		
		case "footerButton_settings": {msg="Settings"; break;}		
		case "footerButton_addTunnel": {msg="Add a tunnel"; break;}		
		case "footerButton_viewTunnelList": {msg="Your tunnels"; break;}		
		case "footerButton_help": {msg="Get help"; break;}		
		case "signInWithYourKey": {msg="Already have an account? Click to upload your image key."; break;}
		case "createAnAccount": {msg="Don't have an account?  Click to get started."; break;}
		case "haveATemporaryPassphrase": {msg="Have a passphrase?  Enter the it and click the arrow."; break;}
		case "whatIsATunnel": {msg="A tunnel is a secure, private place to talk. Click to learn more."; break;}
		case "playStoreLink": {msg="Have an Android phone? Get the app."; break;}
		case "appleStoreLink": {msg="iPhone user? Click to get the app."; break;}
		case "tunnelList_fullCircle": {msg="The solid circle means you have unread messages in this tunnel."; break;}
		case "tunnelList_emptyCircle": {msg="The empty circle means you have no unread messages in this tunnel."; break;}
		case "tunnelList_tunnelNameConfName": {msg="White text means your confidant is not in the tunnel; colored test means he/she is."; break;}
		case "tunnelList_greenArrow": {msg="Click the arrow (or anywhere in the box) to enter this tunnel."; break;}
		case "tunnelList_bomb": {msg="Click the bomb to destroy the tunnel. (You cannot undo this!)"; break;}
		case "virtualKb": {msg="Open the virtual keyboard (keyloggers won't be able to track what you type)."; break;}
		case "uploadMediaButton": {msg="Upload a photo, video, document, or any file. It will be encrypted just as messages are."; break;}
		case "tunnelList_timeSpent": {msg="The amount of time you've spent on Tunnel T with this "+UiMgr.skinnedSiteData.clientName.toLowerCase()+" (hh:mm)."; break;}
		case "convoTab_messages": {msg="Your ongoing conversation with this "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"."; break;}
		case "convoTab_info": {msg="General info about this "+UiMgr.skinnedSiteData.clientName.toLowerCase()+" (visible only to you)."; break;}
		case "convoTab_notes": {msg="Your ongoing notes about this "+UiMgr.skinnedSiteData.clientName.toLowerCase()+" (visible only to you)."; break;}
		case "clientInfoEditBtn": {msg="Click to edit this "+UiMgr.skinnedSiteData.clientName.toLowerCase()+" info."; break;}
		case "clientInfoSaveBtn": {msg="Click to save your "+UiMgr.skinnedSiteData.clientName.toLowerCase()+"-info changes."; break;}
		
		
		
		

		
		default: codeRecognized=false;
		}
	}
	if (codeRecognized) {
		if (show) {
			clearTimeout(UiMgr.hideFooterTextTimeout);
			$("#footerLinkRolloverTexts #contextualHelp").html(msg);
			$("#footerLinkRolloverTexts #contextualHelp").show();
			$("#footerLinkRolloverTexts").show();				
		}
		else {
			UiMgr.hideFooterTextTimeout=setTimeout(function() {
				$("#footerLinkRolloverTexts #contextualHelp").html(msg);
				$("#footerLinkRolloverTexts #contextualHelp").hide();
				$("#footerLinkRolloverTexts").hide();								
			}, 150);
		}
		
	}
};



