
function _VirtualKeyboard () {
	this.MAX_WORD_SUGGESTIONS=5;
	this.DEFAULT_SUGGESTED_WORD_FONT_SIZE_PX=11; // change to this also means change to mobile.css "#wordSuggestions td" font-size def
	this.SMALL_SUGGESTED_WORD_FONT_SIZE_PX=8; // for long words
	this.LARGE_WORD_LENGTH=14; // words over this length get the smaller font size
	//this.SUGGESTED_WORD_DISPLAY_INDICES=[1,0,2]; // display first suggestion in center, second on left, third on right
	this.SUGGESTED_WORD_DISPLAY_INDICES=[2,1,3,0,4]; // if we switch MAX_WORD_SUGGESTIONS to 5
	this.charsToEntities=new Map();
	this.charsToEntities.put("<", "&lt;");
	this.charsToEntities.put(">", "&gt;");
	this.charsToEntities.put("__dquot", "&quot;");
	this.charsToEntities.put("__squot", "&apos;");
	this.charsToEntities.put("&", "&amp;");
	
	this.cssExceptionCharClasses=new Map();
	this.cssExceptionCharClasses.put(".", "period");
	this.cssExceptionCharClasses.put(",", "comma");
	this.cssExceptionCharClasses.put("@", "atsign");
	this.cssExceptionCharClasses.put("?", "questionmark");
	this.cssExceptionCharClasses.put("_squot", "squot");
	this.cssExceptionCharClasses.put("_dquot", "dquot");
	this.cssExceptionCharClasses.put("`", "accent");
	this.cssExceptionCharClasses.put("*", "asterisk");
	this.cssExceptionCharClasses.put("-", "hyphen");
	this.cssExceptionCharClasses.put("_", "underscore");
	
	this.defaultKeyBorderColorCss=null;
	
	this.hideKbTimeout=null;
	this.kbJqRef=null; // this will hold a ref to the JQ object representing the VKB
	
	this.DESKTOP_KEYS=[
	    	           [["1","`",false], ["2","~",false], ["3","#",false], ["4","$",false], ["5","%",false], ["6","^",false], ["7","&",false], ["8","*",false], ["9","(",false], ["0",")",false],  ["[","{",false],["]","}",false],["/","<",false],["_bslash",">",false]],
	    	           [["q","Q",true], ["w","W",true], ["e","E",true], ["r","R",true], ["t","T",true], ["y","Y",true], ["u","U",true], ["i","I",true], ["o","O",true], ["p","P",true], ["-","_",false], ["=","+",false], ["BK","BK",false]],
	    	           [["a","A",true], ["s","S",true], ["d","D",true], ["f","F",true], ["g","G",true], ["h","H",true], ["j","J",true], ["k","K",true], ["l","L",true], [";",":",false], ["_squot","_dquot",false], ["EN","EN",false]],
	    	           [["SH","SH",false], ["z","Z",true], ["x","X",true], ["c","C",true], ["v","V",true], ["b","B",true], ["n","N",true], ["m","M",true], [",",",",true], [".",".",true], ["?","?",true],["!","!",true]],
	    	           [["SP","SP",false]]
	    	           ];
	
	this.MOBILE_KEYS=[
	    	           [["q","Q","1",true],       ["w","W","2",true],      ["e","E","3",true],    ["r","R","4",true],       ["t","T","5",true],    ["y","Y","6",true],   ["u","U","7",true],   ["i","I","8",true],   ["o","O","9",true],    ["p","P","0",true]                                      ],
	    	           [["!","!","<",true],       ["a","A",">",true],      ["s","S","~",true],    ["d","D","#",true],       ["f","F","$",true],    ["g","G","%",true],   ["h","H","^",true],   ["j","J","&",true],   ["k","K","`",true],    ["l","L","{",true] ,     ["@","@","|",true]  ],
	    	           [["SH","SH","SH",false],     ["z","Z","_",true],      ["x","X","+",true],    ["c","C","|",true],       ["v","V","/",true],   ["b","B","[",true],   ["n","N","]",true],   ["m","M","=",true],              ["_dquot","_dquot","_bslash",true],  ["BK","BK","BK",false]                              ],
	    	           [["SN","SN","SN",false], ["-","-",";",true],   [",",",","*",true],    ["SP","SP","SP",false],                                                  [".",".",":",true],   ["_squot","_squot","}",true],   ["?","?",")",true],     ["EN","EN","",false]                               ]
	    	           ]; 
	
	this.currModeShifted=false;
	this.currModeShiftedLocked=false;
	this.currModeSymNumLocked=false; // true when sym/numloc is on
	this.desktopDialogPopupated={};
	this.desktopDialogPopupated.large=false;
	this.desktopDialogPopupated.small=false;
	this.desktopVirtualKeyboardOpen=false;
	
	this.keyboardFeedbackPointer=null;
	this.keyboardFeedbackPointerContents=null;
	
	this.ckEditorInstance=null;
	this.kbVisible=false;
	this.wordSuggestionJqRefs=null;
	this.currentWordSuggestions=[];
}

var p=_VirtualKeyboard.prototype;



// to be called when we first load a tunnel, which may not be the first we've viewed, or after a click on a suggested word if we want
p.clearWordSuggestionHistory=function() {
	VirtualKeyboard.currentWordSuggestions=[];
	try {
		VirtualKeyboard._reflectCurrentWordSuggestionsToUi();
	}
	catch (e) {} // this fails if it's our first visit to a tunnel this session; not a problem, there was no UI stuff to clear.
};

p.keyClick=function(val, clickedDomElement) {
	var defaultKeyBorderColorCss=VirtualKeyboard.defaultKeyBorderColorCss;
	if (defaultKeyBorderColorCss==null) {
		defaultKeyBorderColorCss=$(".keyboard .key").css("background-color");
		VirtualKeyboard.defaultKeyBorderColorCss=defaultKeyBorderColorCss;
	}
	var plaintextEditorJqRef=null;
	if (!mobileApp && VirtualKeyboard.ckEditorInstance==null) { // this way we get this once:
		VirtualKeyboard.ckEditorInstance=CKEDITOR.instances.msgCompose;
	}
	if (mobileApp) {
		plaintextEditorJqRef=MessengerMgr.getCurrentMobileEditorTextarea();
	}
	//alert("plaintextEditorJqRef="+plaintextEditorJqRef)
	//alert("plaintextEditorJqRef[0].id="+plaintextEditorJqRef[0].id)
	
	var clickedKeyWrapper=null;
	var clickedKey=null;
	var noKeyOp=true;
	if (clickedDomElement!=null) {
		clickedKeyWrapper=$(clickedDomElement);
		clickedKey=$(clickedDomElement.firstElementChild);
		noKeyOp=false;
	}

	var contentToInsert=null;
	var insertAsHtml; // if false, we insert as text; otherwise as html
	var doBackspace=false;
	var sendNow=false; // true if user presses enter (always for mobile, sometimes for desktop depending on prefs)
	var showPointer=true;
	if (!noKeyOp) {
		clickedKey.css("border-color", "#ffffff");
		setTimeout(function() {
			clickedKey.css("border-color", defaultKeyBorderColorCss);
		}, 150);		
	}
	
	MessengerMgr.focusEditor();
	
	val=VirtualKeyboard._handleSpecialCharsForKeyClick(val);
	
	// the following two conditional clauses need to be merged; this is lots of dupe code and it's ugly --
	if (val=="__symnum") { // num/sym lock was clicked
		showPointer=false;
		// Num/sym key is a two-way toggle:
		VirtualKeyboard.currModeSymNumLocked=!VirtualKeyboard.currModeSymNumLocked;
		VirtualKeyboard.currModeShifted=false; // lock/unlocking resets caps shift to off
		
		// show the proper kb and shift keys...
		$(".keyboard .keyboardMode.shifted").hide(); // no circumstance after num/sym is clicked would make this the active kb:
		$(".keyboard .keyboardMode.symnumlocked")[VirtualKeyboard.currModeSymNumLocked?"show":"hide"]();
		$(".keyboard .keyboardMode.unshifted")[VirtualKeyboard.currModeSymNumLocked?"hide":"show"]();		
		// if caps shift-lock was on, now it's off, so:
		$(".keyboard .keyboardMode.unshifted #shiftUnlocked").show(); 
		$(".keyboard .keyboardMode.unshifted #shiftLocked").hide();
		$(".keyboard .keyboardMode.shifted #shiftUnlocked").show();
		$(".keyboard .keyboardMode.shifted #shiftLocked").hide();
		$(".keyboard .keyboardMode.symnumlocked #shiftUnlocked").show();
		$(".keyboard .keyboardMode.symnumlocked #shiftLocked").hide();
		
	}	
	else if (val=="__shift") {
		showPointer=false;
		VirtualKeyboard.currModeSymNumLocked=false; // turn off num/sym lock if it was on
		// the shift key is a three-way toggle: 1) unshifted; 2) shifted (next char will be caps); 3) shifted-and-locked (all chars wwill be caps until we toggle back to 1).  So:
		if (!VirtualKeyboard.currModeShifted) {
			VirtualKeyboard.currModeShifted=true;
			VirtualKeyboard.currModeShiftedLocked=false;
		}
		// else we are shifted, so are we locked?
		else if (!VirtualKeyboard.currModeShiftedLocked) {
			VirtualKeyboard.currModeShifted=true;
			VirtualKeyboard.currModeShiftedLocked=true;
		}
		// else we are locked, so we are going back to unshifted/unlocked:
		else {
			VirtualKeyboard.currModeShifted=false;
			VirtualKeyboard.currModeShiftedLocked=false;
		}
		// show the proper kb and shift keys...
		$(".keyboard .keyboardMode.unshifted")[VirtualKeyboard.currModeShifted?"hide":"show"]();
		$(".keyboard .keyboardMode.shifted")[VirtualKeyboard.currModeShifted?"show":"hide"]();
		$(".keyboard .keyboardMode.symnumlocked").hide();
		
		// ... and the proper shift-lock image bg:
		var visibleShiftKey=$(".keyboard .keyboardMode."+(VirtualKeyboard.currModeShifted?"shifted":"unshifted")+" #shiftKey");
		var fqNewBgImgUrl=visibleShiftKey.css("background-image").trim();
		// fqNewBgImgUrl has format url(http://host/path/to/file.ext)
		fqNewBgImgUrl=fqNewBgImgUrl.substring(4, fqNewBgImgUrl.lastIndexOf("/")+1);
		fqNewBgImgUrl+="kbShiftArrow"+(VirtualKeyboard.currModeShiftedLocked?"Lock":"")+".svg";
		visibleShiftKey.css("background-image", "url("+fqNewBgImgUrl+")");
		//alert(fqNewBgImgUrl)
		/*
		$(".keyboard .keyboardMode.unshifted #shiftUnlocked")[VirtualKeyboard.currModeShiftedLocked?"hide":"show"]();
		$(".keyboard .keyboardMode.unshifted #shiftLocked")[VirtualKeyboard.currModeShiftedLocked?"show":"hide"]();
		$(".keyboard .keyboardMode.shifted #shiftUnlocked")[VirtualKeyboard.currModeShiftedLocked?"hide":"show"]();
		$(".keyboard .keyboardMode.shifted #shiftLocked")[VirtualKeyboard.currModeShiftedLocked?"show":"hide"]();
		$(".keyboard .keyboardMode.symnumlocked #shiftUnlocked")[VirtualKeyboard.currModeShiftedLocked?"hide":"show"]();
		$(".keyboard .keyboardMode.symnumlocked #shiftLocked")[VirtualKeyboard.currModeShiftedLocked?"show":"hide"]();
		*/
	
	}
	else if (val=="__back") {
		showPointer=false;
		doBackspace=true;
	}
	else if (val=="__enter") {
		// Enter means same thing on virtual kb as regular: for mobile, it means send; for desktop, it depends on user prefs:
		showPointer=false;
		if (mobileApp) {
			sendNow=true;
		}
		else {
			if ((""+UiMgr.acctPrefs.sendMessageOnEnterAcctPref)=="true") {
				sendNow=true;
			}
			else {
				contentToInsert="<br/>";
				insertAsHtml=true;				
			}
		}
	}
	else {
		var entityVal=(mobileApp?null:VirtualKeyboard.charsToEntities.get(val)); // entities for CKEditor only; for mobile, it's always text
		if (entityVal!=null) { 
			contentToInsert=entityVal;
			insertAsHtml=true;
		}
		else {
			contentToInsert=val;
			insertAsHtml=false;
		}
		showPointer=(contentToInsert!=null && contentToInsert.trim().length>0);
	}
	if (doBackspace) {
		if (mobileApp) {
			// for mobile, we use the rangyinputs jQuery plugin (api https://github.com/timdown/rangyinputs/blob/master/README.md)
			// to handle selection-related operations.
			MessengerMgr.focusEditor();
			var currSelection=plaintextEditorJqRef.getSelection();
			var startIdx=currSelection.start;
			var endIdx=currSelection.end;
			var atStartOfTextarea=(startIdx==0);
			var textIsSelected=currSelection.length>0;
			
			// note: if text is selected, backspace means "delete the selection"; if no text is selected, it means "delete
			// the previous character".  So, behavior is slightly different depending on that:
			if (!textIsSelected) {
				// unless we're at the beginning of the text, extend the selection left by one char:
				if (!atStartOfTextarea) {
					plaintextEditorJqRef.setSelection(startIdx-1, endIdx);
				}
			}
			else {
				// Nothing to do here; we already have a selection to delete.
			}
			plaintextEditorJqRef.deleteSelectedText();
			MessengerMgr.focusEditor();
		}
		else {
			//VirtualKeyboard.ckEditorInstance.lockSelection(); // see http://docs.ckeditor.com/#!/api/CKEDITOR.editor-method-lockSelection
			var ckSelection=VirtualKeyboard.ckEditorInstance.getSelection(true);  // http://docs.ckeditor.com/#!/api/CKEDITOR.editor-method-getSelection
			var nativeSelection=ckSelection.getNative();
			var selectedTextLength=ckSelection.getSelectedText();
			
			// if text is selected, backspace means "delete the selection"; otherwise it means "delete the previous
			// char."  So, if the selection has length zero, extend it one char backwards:
			if (selectedTextLength==0) {
				if (typeof nativeSelection.modify!="undefined") {
					nativeSelection.modify("extend", "backward", "character");					
				}
				else {
					// IE (older):
		            if (document.selection) {
		                var nativeRange=document.selection.createRange();
		                nativeRange.moveStart("character", -1);                                        
		                nativeRange.select();
		            }
		            // IE (newer):
		            else {
		            	// document.selection is deprecated (it was standards-incompliant and has now been replaced with
		            	// ANOTHER STANDARDS-INCOMPLIANT DEAL which has nothing like modify() or moveStart(); users of 
		            	// newer IEs will get here, and see no feedback when backspace (on the VKB) is pressed.
		            }
				}
				VirtualKeyboard.ckEditorInstance.selectionChange(); // see http://docs.ckeditor.com/#!/api/CKEDITOR.editor-method-selectionChange
			}
			var ckRange=ckSelection.getRanges()[0];
			ckRange.deleteContents(true);
			VirtualKeyboard.ckEditorInstance.selectionChange(); // see http://docs.ckeditor.com/#!/api/CKEDITOR.editor-method-selectionChange
			
			// give the caret focus such that it blinks (a hack, but it works and nothing else seems to):
			VirtualKeyboard.ckEditorInstance.insertHtml("");
		}	
	}
	else if (!sendNow) {
		if (contentToInsert!=null && contentToInsert.length>0) {
			if (!mobileApp) {
				// the desktop app, so we're using ckeditor, so:
				VirtualKeyboard.ckEditorInstance[insertAsHtml?"insertHtml":"insertText"](contentToInsert);
			}	
			else {
				// if we're mobile, we're showing the feedback pointer (circle showing letter just typed):
				if (showPointer) {
					if (VirtualKeyboard.mobileKeyPointer==null) {
						VirtualKeyboard.keyboardFeedbackPointer=$("#keyboardFeedbackPointer");
						VirtualKeyboard.keyboardFeedbackPointerContents=$("#keyboardFeedbackPointer #innerWrapper");
					}
					if (!noKeyOp) { 
						VirtualKeyboard.keyboardFeedbackPointerContents.html(contentToInsert);
						var clickedKeyOffset=clickedKey.offset();
						var pointerOffset={top: (clickedKeyOffset.top-62), left: (clickedKeyOffset.left-13)};
						VirtualKeyboard.keyboardFeedbackPointer.offset(pointerOffset);
						setTimeout(function() {
							VirtualKeyboard.keyboardFeedbackPointer.offset({top: 0, left: -200});
						}, 225);						
					}
				}
				// ...and of course we're adding a char to the editor --
				var currSelection=plaintextEditorJqRef.getSelection(); // there is no selection; "selection" represents the caret
				plaintextEditorJqRef.insertText(contentToInsert, currSelection.start, "collapseToEnd");
			}			
		}
	}
	
	if (mobileApp) {
		// Tell the MessengerMgr about the new state of the editor:
		MessengerMgr.plaintextEditorContentsChange(plaintextEditorJqRef.val());		
	}

	
	// if we're not num/sym-locked and the shift key wasn't clicked and we're not shift-locked (either type of shift), then we revert to lowercase, now that we've output the char:
	if (val!="__symnum" && val!="__shift" && !VirtualKeyboard.currModeShiftedLocked && ! VirtualKeyboard.currModeSymNumLocked) {
		setTimeout(function() {
			VirtualKeyboard._revertToUnshifted();
		}, 0);
		
	}
	if (sendNow) {
		MessengerMgr.transmitMessage();
		//Firefox fix:
		setTimeout("MessengerMgr.resetComposePane()", 100);
		// hack-focus the editor without triggering the OS kb to open:
		VirtualKeyboard.forceCaretFocusHack(true);
	}
	else {
		if (!noKeyOp) {
			setTimeout(function() {
				var wordBeforeCaret=VirtualKeyboard.getCurrentWordBeforeCaretFromRangySelection(plaintextEditorJqRef);
				var wordSuggestions=[];
				if (wordBeforeCaret.length>0) {
					wordSuggestions=Dictionary.lookup(wordBeforeCaret, VirtualKeyboard.MAX_WORD_SUGGESTIONS);
				}
				//console.info("wordSuggestions="+wordSuggestions);
				VirtualKeyboard.setCurrentWordSuggestionsArray(wordBeforeCaret, wordSuggestions);
			});			
		}
	}
	MessengerMgr.showOrHideMsgComposeLabel(false);
};

/** Returns the lowercase word that appears before the caret, if the caret is at the end of a word.
 *  returns "" if unsuccessful for whatever reason.
 * This is only intended to work for the app, which means it is only intended to work for webkit browsers
 */
p.getCurrentWordBeforeCaretFromRangySelection=function(plaintextEditorJqRef) {
	try {
		// here we use a combination of the rangyinput selection object (rSelection) and the native current selection
		// to determine what the current word is (what word the caret is in or adjecant to):
		
		var rangySelection=plaintextEditorJqRef.getSelection();
		// we only want to look at letters, no other chars.  So we will use regex, but before that, we will
		// deal with the most common of non-letter chars, e.g. space chars, so our regex operations won't be
		// so heavy (and we can just return under some circumstances):
		// first, if the selection is longer than 0 (that is, if text is actually selected, as opposed to the
		// selection just representing a caret (a selection with the same start and end idx), we'll get outta
		// here:
		if (rangySelection.length>0) {
			return "";
		}
		// okay, no text is selected.  so:
		var val=plaintextEditorJqRef.val().toLowerCase();
		// if there is no text in the editor, we can return:
		if (val.trim().length==0) {
			return "";
		}
		// so there is text in the editor.  but return if the caret is at the beginning of the editor:
		if (rangySelection.start<=0) {
			// (not sure what <0 would mean, but we can't do anything with it)
			return "";
		}
		// so we have text in the editor, and we're not at the beginning of the text.  Now: all we care about
		// is if the caret is at the end of a word; otherwise we return "".  At the end of a word means
		// either at the end of the editor with a letter before it, or with a space after it and a letter
		// before it.  Couple of ways to define "after a word" but this is how we're defining it.  So:
		var atEndOfEditor=(rangySelection.end==val.length);
		var spaceFollowsCaret=(!atEndOfEditor && val.charAt(rangySelection.end)==" ");
		if (!atEndOfEditor && !spaceFollowsCaret) {
			return "";
		}
		// So: we know we are either at the end of the editor or have a space right after us, but unless the
		// char right before us is a letter, we don't have a word.  (If it's a letter, it'll be a lowercase
		// one, because we lc'd the editor value.)  So:
		if (!/^[a-z]+$/.test(val.charAt(rangySelection.end-1))) {
			// we don't have a letter before us, so:
			return "";
		}
		// Okay, we have a word!  Let's get it; first, we'll chop up the val a little (again using non-regex to get rid
		// of the most common non-letters, i.e. spaces):
		val=val.substring(0, rangySelection.end);
		val=val.substring(val.lastIndexOf(" ")+1); // if no spaces, this is fine; lastIdx will be 0
		// now all we need is the contiguous letters preceding the caret:
		var ln=val.length;
		for (var i=ln-1; i>=0; i--) {
			if (!/^[a-z]+$/.test(val.charAt(i))) {
				return val.substring(i+1);
			}
		}
		// whole thing was a word; return it:
		return val;
		
		
	}
	catch (e) {
		return "";
	}
};

p._revertToUnshifted=function() {
	VirtualKeyboard.currModeShifted=false;
	VirtualKeyboard.currModeShiftedLocked=false;
	$(".keyboard .keyboardMode.unshifted").show();
	$(".keyboard .keyboardMode.shifted").hide();
	$(".keyboard .keyboardMode.symnumlocked").hide();	
	
};

function DEBUGgetProps(obj) {
	var s="";
	for (var prop in obj) {
		s+=prop+":"+obj[prop]+",";
	}
	return s;
};

p.openDesktopKeyboard=function(large) {
	if (VirtualKeyboard.desktopVirtualKeyboardOpen) {
		return;
	}
	VirtualKeyboard.currModeShifted=false;
	DialogMgr.openDesktopVirtualKeyboardDialog(large);
	MessengerMgr.focusEditor(); // now the kb is open, focus the editor again
};

p.getMobileFeedbackPointerHtml=function() {
	var html="";
	html+="<div id=\"keyboardFeedbackPointer\"><div id=\"innerWrapper\">&nbsp;</div></div>";
	return html;
};

p.createWordSuggestionRefsAsNeeded=function() {
	if (VirtualKeyboard.wordSuggestionJqRefs==null) {
		VirtualKeyboard.wordSuggestionJqRefs={};
		VirtualKeyboard.wordSuggestionJqRefs.wrapper=$("#wordSuggestions table");
		VirtualKeyboard.wordSuggestionJqRefs.wrapperVisible=true; // not a jq ref; a boolean reflecting visibility of above obj
		VirtualKeyboard.wordSuggestionJqRefs._suggestions=[];
		for (var i=0; i<VirtualKeyboard.MAX_WORD_SUGGESTIONS; i++) {
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i]={};
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].fullWord=$("#wordSuggestions #wordSuggestion"+i+"");
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].typedStart=$("#wordSuggestions #wordSuggestion"+i+" .typedStart");
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].suggestedEnd=$("#wordSuggestions #wordSuggestion"+i+" .suggestedEnd");
			// not jq refs; values tracking some CSS and other values of objects above:
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].wordVisible=true;
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].fullWordFontSizePx=VirtualKeyboard.DEFAULT_SUGGESTED_WORD_FONT_SIZE_PX;
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].typedStartVal="";
			VirtualKeyboard.wordSuggestionJqRefs._suggestions[i].suggestedEndVal="";
			
		}
	}
};


p._getWordSuggestionTypedStartJqRef=function(idx) {
	return VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].typedStart[i];
};

p._getWordSuggestionSuggestedEndJqRef=function(idx) {
	return VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].suggestedEnd[i];
};

p._showHideWordSuggestion=function(idx, visible) {
	if (visible!=VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].wordVisible) {
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].fullWord[visible?"show":"hide"]();
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].wordVisible=visible;
	}
};

p._showHideAllSuggestions=function(visible) {
	if (visible!=VirtualKeyboard.wordSuggestionJqRefs.wrapperVisible) {
		VirtualKeyboard.wordSuggestionJqRefs.wrapper[visible?"show":"hide"]();
		VirtualKeyboard.wordSuggestionJqRefs.wrapperVisible=visible;
	}
};




p._setWordSuggestionFontSize=function(idx, toSmall) { // toSmall boolean: if true, we set to small size, if false to large
	var fontSizePx=(toSmall?VirtualKeyboard.SMALL_SUGGESTED_WORD_FONT_SIZE_PX:VirtualKeyboard.DEFAULT_SUGGESTED_WORD_FONT_SIZE_PX);
	//console.info("in _setWordSuggestionFontSize, idx="+idx);
	//console.info("VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx]="+VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx]);
	if (fontSizePx!=VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].fullWordFontSizePx) {
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].fullWord.css("font-size", ""+fontSizePx+"px");
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].fullWordFontSizePx=fontSizePx;
	}
};

p._displayWordSuggestionTypedStart=function(idx, s) {
	if (s!=VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].typedStartVal) {
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].typedStart.html(s);
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].typedStartVal=s;
	}
};

p._displayWordSuggestionSuggestedEnd=function(idx, s) {
	if (s!=VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].suggestedEndVal) {
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].suggestedEnd.html(s);
		VirtualKeyboard.wordSuggestionJqRefs._suggestions[idx].suggestedEndVal=s;
	}
};


p._displayWordSuggestion=function(idx, wordArr) { // wordArr string array has two elements: the start and end (the typed part and the suggested ending)
	//console.info("in _displayWordSuggestion, idx="+idx+" and wordArr="+wordArr);
	
	var wordLength=wordArr[0].length+wordArr[1].length;
	if (wordLength==0) {
		// don't actually change the display for the two current words; just hide the whole word (better for perf):
		VirtualKeyboard._showHideWordSuggestion(idx, false);
	}
	else {
		VirtualKeyboard._displayWordSuggestionTypedStart(idx, wordArr[0]);
		VirtualKeyboard._displayWordSuggestionSuggestedEnd(idx, wordArr[1]);
		VirtualKeyboard._setWordSuggestionFontSize(idx, wordLength>=VirtualKeyboard.LARGE_WORD_LENGTH);
		VirtualKeyboard._showHideWordSuggestion(idx, true);
	}
};

p._reflectCurrentWordSuggestionsToUi=function(currentWord) {
	if (typeof currentWord=="undefined") {
		currentWord="";
	}
	//console.info("_reflectCurrentWordSuggestionsToUi: currentWord="+currentWord);
	VirtualKeyboard._showHideAllSuggestions(VirtualKeyboard.currentWordSuggestions.length>0);
	var currentSuggestionsLength=VirtualKeyboard.currentWordSuggestions.length;
	var displayableSuggestionsLength=VirtualKeyboard.MAX_WORD_SUGGESTIONS;
	var suggestedWord;
	var suggestedWordArr;
	var dividingIdx;
	for (var i=0; i<displayableSuggestionsLength; i++) {
		//suggestedWord=(i<currentSuggestionsLength?VirtualKeyboard.currentWordSuggestions[i]:"");
		suggestedWord=VirtualKeyboard.currentWordSuggestions[i];
		suggestedWord=(typeof suggestedWord=="undefined"?"":suggestedWord);
		//console.info("------------------ currentSuggestionsLength="+currentSuggestionsLength+" and suggestedWord="+suggestedWord+" and currentWord="+currentWord);
		if (VirtualKeyboard.currModeShiftedLocked) {
			suggestedWord=suggestedWord.toUpperCase();
		}
		else if (VirtualKeyboard.currModeShifted && suggestedWord.length>0) {
			suggestedWord=suggestedWord.substring(0,1).toUpperCase()+suggestedWord.substring(1);
		}
		if (suggestedWord=="") {
			suggestedWordArr=["",""];
			//console.info(">>>1");
		}
		else if (currentWord.toLowerCase()==suggestedWord.toLowerCase()) {
			suggestedWordArr=[suggestedWord,""];
			//console.info(">>>2 - suggestedWordArr="+suggestedWordArr);
		}
		else {
			dividingIdx=currentWord.length;
			suggestedWordArr=[suggestedWord.substring(0, dividingIdx), suggestedWord.substring(dividingIdx)];
			//console.info(">>>3 - suggestedWordArr="+suggestedWordArr);
		}
		VirtualKeyboard._displayWordSuggestion(VirtualKeyboard.SUGGESTED_WORD_DISPLAY_INDICES[i], suggestedWordArr);
	}
};

p.setCurrentWordSuggestionsArray=function(currentWord, suggestedWordsArr) { 
	//console.info("in setCurrentWordSuggestionsArray, suggestedWordsArr="+suggestedWordsArr);
	// check for the one case, but a common one, where we don't have to do anything:
	if (VirtualKeyboard.currentWordSuggestions.length==0 && suggestedWordsArr.length==0) {
		return;
	}
	VirtualKeyboard.currentWordSuggestions=suggestedWordsArr;
	VirtualKeyboard._reflectCurrentWordSuggestionsToUi(currentWord);
}




/**
 * @param desktop Boolean true if this is the desktop keyboard (to appear in a dialog), false if mobile
 * @param large Boolean true if this is the large desktop view, false if small desktop view (or mobile)
 */
p.getHtml=function(desktop, large) {
	if (!desktop) {
		large=false;
	}

	var keypressEventHandlerAttr; // this can be onclick, onmousedown, or ontouchstart depending on platform:
	var falseReturningOnclick=" onclick=\"return false;\" "; // if our keypress event isn't onclick, we'll do an onclick="return false" to improve mobile performance (why it helps, not sure but it does)
	if (!mobileApp) {
		// desktop site:
		keypressEventHandlerAttr="onclick";
		falseReturningOnclick="";
	}
	else {
		if (window.localMobileAppDebug) {
			// desktop debugging of mobile app:
			keypressEventHandlerAttr="onmousedown";	
		}
		else {
			// mobile app:
			keypressEventHandlerAttr="ontouchstart";			
		}
	}

	/* Note: styles for all of the following markup are in main.css (see "Virtual-keyboard styles") */

	var keys;
	var html="";
	if (desktop) {  
		keys=VirtualKeyboard.DESKTOP_KEYS;
	}
	else {  
		keys=VirtualKeyboard.MOBILE_KEYS;
	}

	html+="<div class=\"keyboard"+(!large?" small":"")+"\">";
	if (desktop) {
		if (large) {
			html+="<div class=\"instrux\">When you use this virtual keyboard, \"keyloggers\" can't record what you type. Click \"Smaller keyboard\" for a keyboard that doesn't take up as much space on your screen.</div>";		
		}
		else {
			html+="<div class=\"instrux\">When you use this virtual keyboard, \"keyloggers\" can't record what you type. Click \"Larger keyboard\" for a touchscreen-friendly virtual keyboard.</div>";		
		}		
	}

	else {
		// mobile app, so we do the word-suggestion div here:
		html+="<div id=\"wordSuggestions\">";
		html+="<table cellspacing=\"0\">";
		html+="<tr>";
		for (var i=0; i<VirtualKeyboard.MAX_WORD_SUGGESTIONS; i++) {
			html+="<td><span class=\"wordSuggestion\" id=\"wordSuggestion"+i+"\" "
			+keypressEventHandlerAttr+"=\"VirtualKeyboard.wordSuggestionClick("+i+")\">"
			+"<span class=\"typedStart\"></span>"
			+"<span class=\"suggestedEnd\"></span></span></td>";
		}
		html+="</tr>";
		html+="</table>";
		html+="</div>";
	}
	
	var row, key, keyHtml, letterChar, shifted, symNumLocked, keyboardMode;
	var letterCharIdx=(desktop?2:3);
	var numModes=(desktop?2:3);
	// iterate twice for desktop (unshifted/shifted) and three times for mobile: unshifted, shifted, and symnum-locked
	for (var s=0; s<numModes; s++) {
		shifted=(s==1);
		symNumLocked=(s==2);
		switch (s) {
		case 0: {keyboardMode="unshifted"; break;};
		case 1: {keyboardMode="shifted"; break;};
		case 2: {keyboardMode="symnumlocked"; break;};
		}
		html+="<div class=\"keyboardMode "+keyboardMode+"\">";
		for (var r=0; r<keys.length; r++) {
			html+="<div class=\"row row"+r+"\">";
			row=keys[r];
			var exceptionCharClass;
			for (var k=0; k<row.length; k++) {
				key=row[k];
				letterChar=key[letterCharIdx];
				if (letterChar) {
					exceptionCharClass=VirtualKeyboard.cssExceptionCharClasses.get(key[symNumLocked?2:0]);
					if (exceptionCharClass==null) {
						exceptionCharClass="";
					}
					else {
						exceptionCharClass=" "+exceptionCharClass;
					}
					
					
					if (mobileApp) {
						var keyClickVal;
						if (symNumLocked) {
							keyClickVal=key[2];
						}
						else {
							keyClickVal=key[shifted?1:0];
						}
						keyHtml=VirtualKeyboard.getStandardKeyHtml(key, shifted, symNumLocked, keyClickVal, falseReturningOnclick, keypressEventHandlerAttr, exceptionCharClass, "nonImageKey", null);


					}
					else {
						// NOTE: DESKTOP ONLY:
						keyHtml="<div class=\"keyWrapper\" "+falseReturningOnclick+" "+keypressEventHandlerAttr+"=\"VirtualKeyboard.keyClick('"+key[shifted?1:0]+"', this); return false;\"><div class=\"key letterChar\">"
							+"<div class=\"standardLabel"+exceptionCharClass+"\">"+key[shifted?1:0]+"</div></div></div>";
							//+"<div class=\"standardLabel"+exceptionCharClass+"\">e</div></div></div>";
					}
				}
				else {
					if (key[0]=="EN" || key[0]=="BK" || key[0]=="SP" || key[0]=="SH" || key[0]=="SN") {
						var imageFilename;
						var innerKeyWrapperCssClass;
						var keyClickVal;
						switch (key[0]) {
						case "EN": { // Enter key (always actually the "send" key for mobile, since it's always send-on-enter for mobile)
							imageFilename=(mobileApp?"kbSendButton.svg":"kbEnterArrow.png");
							innerKeyWrapperCssClass="enter";
							keyClickVal="__enter";
							break;
						}
						case "BK": { // backspace key
							imageFilename="kbBackArrow."+(mobileApp?"svg":"png");
							innerKeyWrapperCssClass="back";
							keyClickVal="__back";
							break;
						}
						case "SP": { // spacebar
							imageFilename="kbSpace."+(mobileApp?"svg":"png");
							innerKeyWrapperCssClass="space";
							keyClickVal=" ";
							break;
						}
						case "SH": { // standard shift
							imageFilename="kbShiftArrow."+(mobileApp?"svg":"png");
							innerKeyWrapperCssClass="shift";
							keyClickVal="__shift";
							break;
						}
						case "SN": { // sym/num shift (note: mobile only)
							imageFilename="kbSymnumShift"+(symNumLocked?"Locked":"")+".svg";
							innerKeyWrapperCssClass="symnum";
							keyClickVal="__symnum";
							break;
						}
						default: throw new Error("key[0] ("+key[0]+") is not an expected value.");
						}
						
						keyHtml=VirtualKeyboard.getStandardKeyHtml(key, shifted, symNumLocked, keyClickVal, falseReturningOnclick, keypressEventHandlerAttr, exceptionCharClass, innerKeyWrapperCssClass, imageFilename);
					}
					else {
						// NOTE: DESKTOP ONLY:
						keyHtml=""
						+"<div class=\"keyWrapper\" "+falseReturningOnclick+" "+keypressEventHandlerAttr+"=\"VirtualKeyboard.keyClick('"+key[shifted?1:0]+"', this); return false;\">"
							+"<div  class=\"key innerKeyWrapper\">"
							
								+"<div class=\""+(shifted?"large":"small")+"\">"
									+VirtualKeyboard._handleSpecialCharsForDisplay(key[1])
								+"</div>"
								+"<div class=\""+(shifted?"small":"large")+"\">"
									+VirtualKeyboard._handleSpecialCharsForDisplay(key[0])
								+"</div>"
								
							//+"<div class=\""+(shifted?"large":"small")+"\">c</div>"
							//+"<div class=\""+(shifted?"small":"large")+"\">d</div>"

							+"</div>"
						+"</div>"
					}
				}
				html+=keyHtml; // append key html
			}
			html+="</div>"; // end row html
		}	
		html+="</div>"; // end keyboardMode html
	}
	html+="</div>";	// end keyboard html
	return html;
};


p.getStandardKeyHtml=function(key, shifted, symNumLocked, keyClickVal, falseReturningOnclick, keypressEventHandlerAttr, exceptionCharClass, innerKeyWrapperCssClass, bgImageFilename) {
	var hasVisibleBg=true;
	if (bgImageFilename==null) {
		bgImageFilename="kbBlankBg."+(mobileApp?"svg":"png");
		hasVisibleBg=false;
	}
	var keyLabelTop=key[2];
	var keyLabelBottom=key[shifted?1:0];
	if (hasVisibleBg) {
		keyLabelTop="&nbsp;";
		keyLabelBottom="&nbsp;";		
	}
	// special cases for highlighting the shift keys when we're in shifted mode:
	var backgroundColorCssStyle="";
	var idAttr="";
	if (key[0]=="SH") {
		idAttr=" id=\"shiftKey\" ";
		if (shifted) {
			backgroundColorCssStyle="background-color:#ffffff; ";
		}
	}
	else if (symNumLocked && key[0]=="SN") {
		backgroundColorCssStyle="background-color:#ffffff; ";
	}
	return "<div class=\"keyWrapper\" "+falseReturningOnclick+" "+keypressEventHandlerAttr+"=\"VirtualKeyboard.keyClick('"+keyClickVal+"', this); return false;\">"
			+"<div "+idAttr+" class=\"key innerKeyWrapper backgroundImage "+innerKeyWrapperCssClass+"\" style=\""+backgroundColorCssStyle+"background-image:url("+baseImagesUrlNonSkinned+bgImageFilename+");\">"
				+"<div class=\""+(symNumLocked?"large":"small")+(symNumLocked?exceptionCharClass:"")+"\">"+VirtualKeyboard._handleSpecialCharsForDisplay(keyLabelTop)+"</div>"
				+"<div class=\""+(symNumLocked?"small":"large")+(symNumLocked?exceptionCharClass:"")+"\">"+VirtualKeyboard._handleSpecialCharsForDisplay(keyLabelBottom)+"</div>"
			+"</div>"
		+"</div>"
	;
};



p.wordSuggestionClick=function(idx) {
	setTimeout(function() { // if this isn't in a timeout, iOS focuses the OS kb for some reason
		
		// for now, this code assumes that we are at the end of the word and that nothing is selected; if we want that
		// functionality in future, we need to add it here.
		var plaintextEditorJqRef=$(MessengerMgr.getCurrentMobileEditorTextarea());
		var currentWord=VirtualKeyboard.getCurrentWordBeforeCaretFromRangySelection(plaintextEditorJqRef);
		if (currentWord.length==0) {
			// it shouldn't, but:
			return;
		}
		// rest of this code uses ranginputs API extensively --
		var rangySelection=plaintextEditorJqRef.getSelection();
		if (rangySelection.length>0) {
			// it shouldn't; no way for users to select input in app
			return;
		}
		plaintextEditorJqRef.setSelection(rangySelection.end-currentWord.length, rangySelection.end);
		var insertWord=VirtualKeyboard.currentWordSuggestions[VirtualKeyboard.SUGGESTED_WORD_DISPLAY_INDICES.indexOf(idx)]
		
		var currentWordIsLc=currentWord==currentWord.toLowerCase();
		
		if (VirtualKeyboard.currModeShiftedLocked) {
			insertWord=insertWord.toUpperCase();
		}
		else if (VirtualKeyboard.currModeShifted && insertWord.length>0) {
			insertWord=insertWord.substring(0,1).toUpperCase()+insertWord.substring(1);
		}

		plaintextEditorJqRef.replaceSelectedText(insertWord, "collapseToEnd");

		VirtualKeyboard.clearWordSuggestionHistory();
		VirtualKeyboard._revertToUnshifted();
		
		// hack-focus the editor without triggering the OS kb to open:
		VirtualKeyboard.forceCaretFocusHack(true);
		
	}, 10);
};

p.editorOverlayFocusEvent=function(elValue) {
	VirtualKeyboard.changeKbVisibilityAsNeeded(true);
};



p.kbFocused=function() {
	clearTimeout(VirtualKeyboard.hideKbTimeout);
};

p.convoHistoryFocused=function() {
	if (mobileApp && ScreenViewStack.isMessagingUiActive() && MessengerMgr.isVirtualKbModeEnabled()) {
		VirtualKeyboard.changeKbVisibilityAsNeeded(false);
	}
};


p.forceCaretFocusHack=function(inTimeout) {
	// sometimes, for unclear reasons, calling MessengerMgr.focusEditor() either fails to give the caret focus, or
	// causes the OS's virtual kb to open. 
	if (mobileApp && MessengerMgr.isVirtualKbModeEnabled()) {
		//console.info("forceCaretFocusHack() called; inTimeout="+inTimeout);
		if (inTimeout) {
			setTimeout(VirtualKeyboard._doForceCaretFocusHack, 200);
		}
		else {
			VirtualKeyboard._doForceCaretFocusHack();
		}		
	}
};

p._doForceCaretFocusHack=function() {

	// For whatever reason, clicking any virtual key focuses the editor without triggering the OS keyboard; we don't
	// actually want to trigger key input, but we have to, so we do the least invasive thing we can, which is to
	// toggle the sym/number-lock key (so quickly it's not visible, and toggling twice has zero effect):
	VirtualKeyboard.keyClick("__symnum", null);
	VirtualKeyboard.keyClick("__symnum", null);


};





p.changeKbVisibilityAsNeeded=function(visible, force) {
	force=(typeof force=="undefined"?false:force);
	//console.info("in changeKbVisibilityAsNeeded(), visible="+visible)
	if (force || visible!=VirtualKeyboard.isKbVisible()) {
		VirtualKeyboard.setKbVisible(visible, force);
	}
	// hack-focus the editor without triggering the OS kb to open(doesn't matter if we've just shown or hidden kb; either way):
	VirtualKeyboard.forceCaretFocusHack(true);


};



p.isKbVisible=function() {
	return VirtualKeyboard.kbVisible;
};

p.setKbVisible=function(visible, force) {
	force=(typeof force=="undefined"?false:force);
	if (force || visible!=VirtualKeyboard.kbVisible) {
		VirtualKeyboard.kbVisible=visible;
		$("#virtualKeyboard")[visible?"show":"hide"]();
	    console.info("calling resizeWrapperTableInnerDiv() from VirtualKeyboard.setKbVisible...");
		UiMgr.resizeWrapperTableInnerDiv(true);
		MessengerMgr.resizeHistoryBoxHeight(true, visible);	
		
		MessengerMgr.showOrHideMsgComposeLabel(false);
	}
};




p._handleSpecialCharsForDisplay=function(s) {
	switch (s) {
	case "_squot": {return "&apos;";}
	case "_dquot": {return "&quot;";}
	case "_bslash": {return "\\";}
	default: {return s;}
	}
};

p._handleSpecialCharsForKeyClick=function(s) {
	if (!mobileApp) {
		switch (s) {
		case "_squot": {return "&apos;";}
		case "_dquot": {return "&quot;";}
		case "_bslash": {return "\\";}
		default: {return s;}
		}
	}
	else {
		switch (s) {
		case "_squot": {return "'";}
		case "_dquot": {return "\"";}
		case "_bslash": {return "\\";}
		default: {return s;}
		}
	}
};


var VirtualKeyboard=new _VirtualKeyboard();
